2015-08-12 10:44  robert

	* include/osg/State: Added initializer

2015-08-12 10:30  robert

	* ChangeLog: Updated ChangeLog

2015-08-12 10:19  robert

	* src/osgVolume/Shaders/volume_frag.cpp,
	  src/osgVolume/Shaders/volume_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_mip_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_mip_frag.cpp: Merged shaders from
	  svn/trunk that refactor the workaround to the NVidia driver bug

2015-08-12 10:06  robert

	* ChangeLog: Update ChangeLog

2015-08-12 06:38  robert

	* CMakeLists.txt, ChangeLog, README.txt: Change RC number to 0 for
	  3.4.0 stable release.
	  Updated ChangeLog
	  Updated the release data in the README

2015-08-11 20:12  robert

	* CMakeLists.txt, ChangeLog: Updated ChangeLog and RC nubmer to 13,
	  and added GL1 to the docs on the GL_PROFILE usage

2015-08-11 20:08  robert

	* src/osgVolume/Shaders/volume_frag.cpp,
	  src/osgVolume/Shaders/volume_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_mip_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_mip_frag.cpp: Refactored
	  workaround of NVidia nan length bug.

2015-08-11 08:44  robert

	* CMakeLists.txt, CMakeModules/FindAsio.cmake,
	  CMakeModules/FindLIBLAS.cmake, src/osgPlugins/CMakeLists.txt:
	  Moved the FIND_PACKAGE(Boost) from the root CMakeLists.txt into
	  the local Find scripts to avoid Boost check when not neccessary.

2015-08-10 19:58  robert

	* ChangeLog: Updated ChangeLog

2015-08-10 19:56  robert

	* src/osg/State.cpp: From svn/trunk merged support for passing the
	  GL_VENDOR string into the #pragma(tic) shader compositions
	  defines

2015-08-10 19:46  robert

	* CMakeLists.txt, ChangeLog: Update RC number to 12, and updated
	  ChangeLog

2015-08-10 19:40  robert

	* CMakeLists.txt: Fixed line endings

2015-08-10 19:39  robert

	* src/osgVolume/Shaders/volume_frag.cpp,
	  src/osgVolume/Shaders/volume_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_mip_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_mip_frag.cpp: Updated built-in
	  shaders from OpenSceneGraph-Data vesion that introduce
	  #pragma(tic) shaders that resolve the NVidia loop iteration bug.

2015-08-10 19:19  robert

	* src/osg/Shader.cpp: Quietened down #pragma(tic) shader
	  composition messages

2015-08-10 05:04  robert

	* include/osg/Types, src/osg/CMakeLists.txt: Build fix for VS and
	  installing TYpes

2015-08-09 10:20  robert

	* AUTHORS.txt, ChangeLog: Update ChangeLog and AUTHORS for rc11

2015-08-09 10:16  robert

	* CMakeLists.txt: Updated RC number to 11.

2015-08-09 10:16  robert

	* src/osg/GL.in: Changed GLint64 and GLuint64 to use int64_t and
	  uint64_t (pulled in via include/osg/Types) to avoid conflict with
	  Qt5 definitions

2015-08-09 09:40  robert

	* include/osgViewer/api/X11/PixelBufferX11,
	  src/osgViewer/PixelBufferX11.cpp: Added #idef guards for SGIX
	  usage

2015-08-08 08:49  robert

	* src/osgPlugins/zip/ZipArchive.cpp: From Glenn Waldron, fix error
	  in ZIP plugin handling of memory buffer

2015-08-06 15:10  robert

	* CMakeLists.txt, ChangeLog: Updated rc number and ChangeLog for
	  3.4.0-rc10

2015-08-06 15:04  robert

	* src/osgVolume/Shaders/volume_frag.cpp,
	  src/osgVolume/Shaders/volume_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_frag.cpp,
	  src/osgVolume/Shaders/volume_lit_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_mip_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_iso_frag.cpp,
	  src/osgVolume/Shaders/volume_tf_mip_frag.cpp: Merged workaround
	  for NVidia driver/GPU bug by updating shaders from svn/trunk that
	  change float to int usage.

2015-08-06 15:03  robert

	* src/osgText/Text.cpp: Added checks for the validity of chached
	  coordinate arrays.

2015-08-03 19:38  robert

	* AUTHORS.txt, CMakeLists.txt, ChangeLog: Updated rc number to 9,
	  and updated ChangeLog and AUTHORS.txt

2015-08-03 19:14  robert

	* include/osgViewer/api/X11/PixelBufferX11,
	  src/osgViewer/PixelBufferX11.cpp: From Andy Skinner, "Someone was
	  using our code on a system that does not seem to have the SGIX
	  symbols used in osgViewer.cpp.
	  
	  
	  
	  I used osgSetGLExtensionsFuncPtr to remove the symbols. I don't
	  know how to test this path, but it did remove the symbols from
	  libosgViewer.so. I have also not been able yet to see if that was
	  sufficient for our customer.
	  
	  
	  
	  I did this by looking at other cases, and I tried to follow some
	  of the same practices in PixelBufferX11, like using _useSGIX in a
	  similar way to the previous _useGLX1_3."

2015-07-31 15:12  robert

	* AUTHORS.txt, ChangeLog: Update ChangeLog and AUTHORS

2015-07-31 15:01  robert

	* CMakeLists.txt: Updated rc number to 8 for 3.4.9-rc8

2015-07-31 13:47  robert

	* CMakeModules/OsgAndroidMacroUtils.cmake: From Terry Welsh, "I
	  downloaded the Android 3rdparty deps from here
	  http://www.openscenegraph.org/index.php/download-section/dependencies
	  but was not able to use them for a while. Attached are changes to
	  OsgAndroidMacroUtils.cmake that allow the deps to be found by
	  cmake.
	  
	  Specifically, all FIND_PATH commands require the
	  NO_CMAKE_FIND_ROOT_PATH option to actually find paths. This is
	  odd
	  because if you inspect CMAKE_FIND_ROOT_PATH it appears to be
	  empty. I
	  would expect it to have no effect at all.
	  
	  I also needed to remove quotes from this line in order for
	  headers to be found:
	  
	  set(FREETYPE_INCLUDE_DIRS "${FREETYPE_DIR}/include
	  ${FREETYPE_DIR}/include/freetype/config")
	  
	  Assuming this script worked in the past, it seems like cmake
	  behavior
	  may have changed at some point. I'm using cmake version
	  2.8.12.2."

2015-07-31 13:44  robert

	* src/osg/GLExtensions.cpp: From Jannik Heller, "Here is a patch
	  for the S3TC capability check.
	  
	  On a Intel HD graphics Linux system with Mesa 10.1.3, I found
	  that osg's Extensions::isTextureCompressionS3TCSupported()
	  returned false, even though S3TC compressed textures *are* in
	  fact working. I tested this by loading and rendering various
	  DXT1, DXT3 and DXT5 compressed textures in the OSG.
	  
	  "glxinfo | grep s3tc" gives:
	  GL_S3_s3tc
	  
	  Note, if I install the package "libtxc-dxtn-s2tc0", I get in
	  addition:
	  
	  glxinfo | grep s3tc
	  GL_EXT_texture_compression_s3tc
	  GL_S3_s3tc
	  
	  However, S3TC compressed textures worked correctly within the OSG
	  even without libtxc-dxtn-s2tc0 installed.
	  
	  I'm not sure what the differences between these extensions are,
	  but based on the description at
	  https://www.opengl.org/registry/specs/S3/s3tc.txt I would assume
	  that both will work for OSG's purposes. The attached patch
	  changes isTextureCompressionS3TCSupported() to accept either
	  extension."

2015-07-31 10:59  robert

	* include/osgText/Text: Warning fix

2015-07-31 10:54  robert

	* src/osg/Image.cpp, src/osgPlugins/3ds/ReaderWriter3DS.cpp,
	  src/osgPlugins/lua/LuaScriptEngine.cpp,
	  src/osgViewer/ViewerEventHandlers.cpp: From Kristofer Tingdahl,
	  warning fixes.

2015-07-31 10:27  robert

	* src/osg/GL.in: Compile fix for Mingw.

2015-07-23 21:32  robert

	* AUTHORS.txt, CMakeLists.txt, ChangeLog: Update version and rc
	  number of 3.4.0-rc7.

2015-07-23 15:46  robert

	* examples/osganalysis/osganalysis.cpp,
	  examples/osgcatch/osgcatch.cpp,
	  examples/osggraphicscost/osggraphicscost.cpp,
	  examples/osgmotionblur/osgmotionblur.cpp,
	  examples/osgshaderterrain/osgshaderterrain.cpp,
	  examples/osgtext/osgtext.cpp,
	  examples/osgthreadedterrain/osgthreadedterrain.cpp,
	  examples/osgvolume/osgvolume.cpp, include/osg/GraphicsThread,
	  include/osg/OperationThread, src/osg/GraphicsThread.cpp,
	  src/osg/OperationThread.cpp, src/osgUtil/GLObjectsVisitor.cpp,
	  src/osgUtil/IncrementalCompileOperation.cpp,
	  src/osgUtil/RenderStage.cpp, src/osgViewer/Renderer.cpp: Added
	  explicit initialization of osg::Referenced(true) to
	  osg::Operation subclasses as it uses virtual inhertiance from
	  osg::Referenced.

2015-07-23 14:37  robert

	* include/osg/Types, include/osgViewer/ViewerBase: From Pjotr
	  Svetachov, buid fixes for VS2015.

2015-07-23 14:30  robert

	* src/osgPlugins/osc/osc/OscOutboundPacketStream.cpp: Fixed
	  indentation

2015-07-23 14:03  robert

	* src/osgPlugins/osc/osc/OscOutboundPacketStream.cpp:

2015-07-23 11:14  robert

	* examples/osgSSBO/osgSSBO.cpp, examples/osgcluster/osgcluster.cpp,
	  examples/osggpucull/AggregateGeometryVisitor.h,
	  examples/osgoit/DepthPeeling.cpp, examples/osgoit/DepthPeeling.h,
	  examples/osgparticleeffects/osgparticleeffects.cpp,
	  examples/osgshadow/osgshadow.cpp,
	  examples/osgspotlight/osgspotlight.cpp,
	  examples/osgwidgetnotebook/osgwidgetnotebook.cpp,
	  src/osg/glu/libutil/mipmap.cpp, src/osgDB/ConvertBase64.cpp,
	  src/osgPlugins/3ds/WriterNodeVisitor.cpp,
	  src/osgPlugins/OpenFlight/FltExportVisitor.cpp,
	  src/osgPlugins/OpenFlight/LightSourcePaletteManager.cpp,
	  src/osgPlugins/OpenFlight/LightSourcePaletteManager.h,
	  src/osgPlugins/OpenFlight/PrimaryRecords.cpp,
	  src/osgPlugins/OpenFlight/expPrimaryRecords.cpp,
	  src/osgPlugins/freetype/FreeTypeLibrary.cpp,
	  src/osgPlugins/osc/OscReceivingDevice.cpp,
	  src/osgPlugins/osc/osc/OscHostEndianness.h,
	  src/osgPlugins/osga/OSGA_Archive.h,
	  src/osgShadow/ConvexPolyhedron.cpp,
	  src/osgShadow/DebugShadowMap.cpp,
	  src/osgShadow/OccluderGeometry.cpp, src/osgShadow/ShadowMap.cpp,
	  src/osgSim/SphereSegment.cpp,
	  src/osgUtil/DelaunayTriangulator.cpp, src/osgUtil/Optimizer.cpp,
	  src/osgUtil/SceneView.cpp, src/osgViewer/View.cpp,
	  src/osgWrappers/deprecated-dotosg/osg/NodeCallback.cpp: Warning
	  fixes for Clang-3.6

2015-07-23 09:23  robert

	* src/osgFX/BumpMapping.cpp, src/osgFX/Cartoon.cpp: Added missing
	  handling of lightnumber and associate lights

2015-07-23 07:39  robert

	* src/osg/GL.in: Changed the GL_HEADER_HAS_GLINT64 and
	  GL_HEADER_HAS_GLUINT64 to use cmakedefine to improve handling of
	  when cmake doesn't find GLint64 and GLuint64.

2015-07-22 14:55  robert

	* applications/osgversion/Contributors.cpp: Fixed Contributors list

2015-07-22 14:51  robert

	* ChangeLog: Updated ChangeLog

2015-07-22 14:41  robert

	* CMakeLists.txt: Update rc to 6.

2015-07-22 14:30  robert

	* include/osg/AlphaFunc, include/osg/GLDefines: Moved from
	  svn/trunk, moved GL_ALPHA_TEST from AlphaFunc to GLDefines

2015-07-22 14:27  robert

	* CMakeLists.txt, src/osg/GL.in: From svn/trunk merged automatic
	  detection of GLint64 + GLuint64 in GL headers

2015-07-21 14:22  robert

	* src/osgPlugins/OpenFlight/PaletteRecords.cpp: Added check for
	  validity of OpenFlight shininess value.

2015-07-21 13:42  robert

	* include/osg/BoundsChecking: Fixed typo

2015-07-20 13:23  robert

	* src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp:
	  Reduced debug message verbosity.

2015-07-20 07:53  robert

	* CMakeLists.txt: Updated RC to 5 for 3.4.0-rc5 release

2015-07-20 07:46  robert

	* ChangeLog: Updated ChangeLog for rc

2015-07-20 07:42  robert

	* src/osgPlugins/osgjs/json_stream: Changed the _MSC_VER check to
	  <= 1700 to support VS2012.

2015-07-19 09:51  robert

	* src/osgPlugins/tiff/ReaderWriterTIFF.cpp: Reinstated the
	  TIFFSetField(image, TIFFTAG_ROWSPERSTRIP, rowsperstrip);

2015-07-17 18:31  robert

	* CMakeModules/FindGStreamer.cmake: From KOS, "I've mentioned in
	  the "osg-users" ML about build error with the newest GStreamer
	  1.5
	  
	  Please, have a look at the attached patch."
	  
	  CMakeModules/FindGStreamer.cmake

2015-07-17 09:16  robert

	* CMakeLists.txt: Updated release candidate number

2015-07-17 09:06  robert

	* AUTHORS.txt, ChangeLog: Updated ChangeLog and AUTHORS

2015-07-17 08:21  robert

	* CMakeLists.txt: Added cmake version checked for cmake_policy
	  setting

2015-07-17 08:12  robert

	* src/osgPlugins/tiff/ReaderWriterTIFF.cpp: From Patrick Neary, "To
	  the tiff plugin, add the capability to write tiff images with
	  unsigned short data"

2015-07-16 19:16  robert

	* src/osg/Image.cpp: From Patrick Neary, "Added some lesser used
	  tokens that we use from GL_ARB_texture_rg to
	  computeFormatDataType(), and computeNumComponents() in
	  src/osg/Image.cpp"

2015-07-16 15:56  robert

	* src/osgQt/GraphicsWindowQt.cpp: From Cory Slep and Robert
	  Osfield, "When using Open Scene Graph and Qt on Android, the
	  resulting thread that an application developer’s Q*Application is
	  run on is different than what Qt considers the “main” thread,
	  which can cause subtle problems. This is because Qt loads native
	  libraries in one thread, and later runs the application in a
	  different thread. They delay running in the second thread as long
	  as possible as they have a nontrivial bootstrapping process. The
	  motivation for Qt having this second thread is to allow them to
	  remain responsive to both Java and native events, and capture
	  events that would otherwise be “missed”

2015-07-16 11:01  robert

	* src/osgText/Text.cpp: Added check to catch cases where the
	  backdrop coordinate cache is too small for the number of contexts
	  being computed.

2015-07-15 10:02  robert

	* src/osgPlugins/ive/DataInputStream.cpp: Added initializers and
	  reverted OSX workaround from 2013.

2015-07-14 16:55  robert

	* CMakeLists.txt: Fixed source of 3.4.0-rc tags to branches so that
	  release candidates are made from the correct 3.4 branch.

2015-07-14 16:37  robert

	* CMakeLists.txt, ChangeLog: Updated ChangeLog and Release
	  Candidate number of 3.4-rc2

2015-07-14 13:33  robert

	* CMakeLists.txt: Moved the cmake_policy(SET CMP0043 NEW) to work
	  for all script paths that Qt5 usage could pass through.

2015-07-14 13:26  robert

	* CMakeLists.txt: Added cmake_policy(SET CMP0043 NEW) usage when
	  compiling against Qt5 as it was causing a warning we couldn't fix
	  on the OSG side otherwise.

2015-07-14 08:25  robert

	* src/osg/StateSet.cpp: Added _defineList into the
	  osg::StateSet::compare() implementation to address issues with
	  osgUtil::Optimizer ignoring defines.

2015-07-13 16:09  robert

	* include/osgText/Text, src/osgText/Text.cpp: Added
	  Text::GlyphQuads::release/resizeGLObjects() and handling of
	  inconsistent contextID sizes to avoid crashes when viewers and
	  scene graphs aren't initialized correctly to the right number of
	  contexts.

2015-07-13 16:04  robert

	* src/osgViewer/CompositeViewer.cpp, src/osgViewer/Viewer.cpp,
	  src/osgViewer/ViewerBase.cpp: Standardize the call to
	  setUpThreading() in CompositeViewer/Viewer::realize().
	  
	  Standardize the call to scene->resizeGLObjects().

2015-07-13 08:48  robert

	* include/osg/GLDefines: From Terry Welsh, "fThis fixes problem
	  where new glClipControl feature would not compile for GLES2
	  profile"

2015-07-03 06:50  robert

	* AUTHORS.txt, ChangeLog: Updated ChangeLog and AUTHORS for 3.4-rc1

2015-07-03 06:30  robert

	* .: Branch OpenSceneGraph-3.4

2015-07-03 06:28  robert

	* Updated for 3.4 branch.

2015-07-02 11:58  robert

	* Fixed repeated name in SETUP_PLUGIN.

2015-07-02 10:25  robert

	* Updated ChangeLog and AUTHORS file in prep for 3.4 branch.

2015-07-02 08:57  robert

	* Build fix

2015-07-02 08:52  robert

	* Moved the defination of GL_MAX_VARYING_COMPONENTS to GL_3_0 block
	  to avoid warnings of redefinition.

2015-07-01 05:32  robert

	* Updated ChangeLog

2015-07-01 05:10  robert

	* From Mathias Froehlich, added seriliazers for new
	  osg::ClipControl

2015-06-30 09:51  robert

	* Updated ChangeLog and AUTHORS files

2015-06-30 09:11  robert

	* From Mathias Froehlich, "Attached a new state attribute
	  implementing the glClipControl that appeared with GL4.5."

2015-06-30 08:39  robert

	* Quitened down debug for ViewConfig argument parsing

2015-06-30 08:38  robert

	* Build fix for GLDAL>=2

2015-06-26 09:40  robert

	* From Christian Kehl, added Vec2::set(const Vec2) method

2015-06-19 09:51  robert

	* From Jannik Heller, fixed clearReferencesToDependentCameras()
	  calls

2015-06-17 16:25  robert

	* Fixed handling of use GLObjectsVisitor for modifying scene graph
	  state without compiling to OpenGL so that the visitor can be run
	  safely without a graphics context being current.

2015-06-16 17:18  robert

	* Small tidy up to make script more readable.

2015-06-16 17:17  robert

	* Added QT_QTCORE_INCLUDE_DIR entry to qfont plugin build to fix
	  Qt4 build under Linux

2015-06-15 19:59  robert

	* From Jannik Heller, "I've added the check for Qt version
	  mismatches into osgQt as suggested in
	  http://forum.openscenegraph.org/viewtopic.php?t=14999.
	  
	  When an application is built with Qt4, but osgQt was built with
	  Qt5 (or vice versa), upon #includeing osgQt users will receive an
	  #error aborting the build.
	  
	  This at least provides a proper error message rather than a
	  crash, while we are working on better fixes for the problem."

2015-06-15 13:51  robert

	* Experiment with how to define GLsizeiptr.

2015-06-15 13:51  robert

	* Upated version number

2015-06-12 20:23  robert

	* Removed old and unused windows code path to avoid confusion

2015-06-12 11:28  robert

	* Updated ChangeLog

2015-06-12 08:04  robert

	* From Farshid Lashkari, "I've modified some setter methods of
	  TextBase to avoid unnecessary calls to
	  computeGlyphRepresentation() if the value has not changed."

2015-06-11 08:44  robert

	* Reverted the typdef GLfloat GLdouble for Andoid as this was
	  causing conflicts.

2015-06-10 18:22  robert

	* Updated ChangeLog and AUTHORS file for 3.3.8 dev release

2015-06-10 16:48  robert

	* From Laurens Voerman, "attached is a zip with the files:
	  
	  OpenSceneGraph\CMakeModules\FindOpenEXR.cmake
	  
	  I introduced a bug in the previous submission pointed out by
	  Dmitry Marakasov:
	  looking for IlmIlf instead of IlmImf (as the previous version did
	  - but using variable OPENEXR_IlmIlf_LIBRARY)
	  
	  For some reason google decided his message was spam, so I just
	  noticed it, and I reply to confirm his remarks and attach a full
	  file.
	  
	  "

2015-06-10 16:47  robert

	* From Colin McDonald, "An earlier fix in OSG 3.2 has been
	  inadvertently lost in 3.3.x. The glGenerateMipMap function is
	  part of the GL_EXT_framebuffer_object extension. Just checking if
	  the function is present before using it for texture mipmaps is
	  not sufficient, as on remote X-windows displays the client side
	  capability may be different from the display server. This can
	  lead to mipmapped textures failing to render. I've restored a fbo
	  extension check. I've also tided up the GL version checking a
	  little."

2015-06-10 10:00  robert

	* From Philippe Renon, "Fixed potential divide by zero in
	  NodeTrackerManipulator : The divide by zero happens when throwing
	  a NodeTrackerManipulator.
	  The infinite result trickles down and later causes NaN in
	  culling.
	  
	  The fix was to use getThrowScale() as done everywhere else."

2015-06-09 16:49  robert

	* Added supoort for
	  osg::CullSettings/Camera::InheritanceMaskActionOnAttributeSetting
	  and InheritanceMask properties.

2015-06-09 12:51  robert

	* Added namespace around typedef to avoid conflict issues

2015-06-09 10:49  robert

	* Introduce osg::Object::asNode(), asNodeVisitor(),
	  asStateAttribute() and asUniform() to replace dynamic_cast<>
	  usage in Callback.cpp.

2015-06-09 09:44  robert

	* Added output of HUD scene graph to hud.osgt and hud.osgb for
	  testing purposes.

2015-06-08 11:33  robert

	* Updated AUTHORS and ChangeLog for dev release

2015-06-08 11:18  robert

	* From Mike Connell, "Give ReadFileCallback access to parent
	  location : These small changes to the database pager allow user
	  code in the ReadFileCallback to safely determine where the file
	  being loaded is destined to be inserted into the scenegraph.
	  "

2015-06-08 10:20  robert

	* Addressed race condition where SceneView::setLightingMode() was
	  setting a shread Master Camera's StateSet.

2015-06-07 11:13  robert

	* Fixed setReferenceTime() bug where a * eather than the correct /
	  was being used. Bug and fix suggested Benjamin Richter.

2015-06-04 09:35  robert

	* Updated AUTHORS for dev release

2015-06-04 09:13  robert

	* From Jannik Heller, Transform::computeBound() optimization.

2015-06-04 09:05  robert

	* From Jannik Heller, Removed unused
	  StatsHandler::_keyEventToggleVsync

2015-06-04 09:00  robert

	* From Jannik Heller, "In the attachment you will find a build fix
	  for the latest trunk. osgAnimation failed to compile when using
	  OSG_USE_REF_PTR_IMPLICIT_OUTPUT_CONVERSION=OFF ."

2015-06-03 10:28  robert

	* Removed export that was breaking windows build

2015-06-03 09:14  robert

	* From KOS, "New classes for osgAnimation presented:
	  UpdateFloatUniform, UpdateVec3fUniform and UpdateMatrixfUniform
	  (based on UpdateUniform template)
	  
	  
	  Classes operate like osgAnimation::UpdateMaterial for Material's
	  diffuse component, but change Uniform."

2015-06-03 09:07  robert

	* From KOS, build fix for osg::Uniform::Callback to
	  osg::UniformCallback change

2015-06-03 09:06  robert

	* Added doxygen comment for typedef

2015-06-03 08:38  robert

	* Build fix for when Uniform::Callback isn't defined

2015-06-02 10:25  robert

	* From Konstantin Matveyev, serializer support for UniformCallback

2015-06-02 09:33  robert

	* From Konstantin Matveyev, "I've changed osg::Uniform::Callback to
	  osg::UniformCallback.
	  osg::UniformCallback inherits osg::Callback now.
	  
	  I don't really now if this class should be inside
	  osgWrappers/serializers
	  because StateAttributeCallback is not presented there, but i've
	  included it in the patch.
	  
	  
	  Please see archive in the attachment.
	  
	  
	  PS
	  DEEP_COPY_UNIFORMS works for me.
	  "
	  Note from Robert Osfield, added typedef UniformCallback Callback
	  for backwards compatibility.

2015-06-02 09:18  robert

	* Changed name of UniformCallback to UniformBufferCallback to avoid
	  conflict with changes to come to the osg::Uniform::Callback ->
	  osg::UniformCallback.

2015-06-01 13:40  robert

	* From Albert Luaces, typo fixes.

2015-06-01 13:11  robert

	* From Jannik Heller, typo fixes

2015-06-01 12:14  robert

	* From Jannik Heller, "This patch adds a missing initialization of
	  osgParticle::ParticleProcessor::_frameNumber in the copy
	  constructor.
	  I noticed this because valgrind was complaining about use of
	  uninitialized memory."

2015-06-01 12:07  robert

	* From Frashud Lashkari, "I was getting "Unsupported wrapper
	  class..." error messages when attempting to load osgb models
	  simultaneously from multiple threads. I believe the problem is
	  caused by un-synchronized access to the global
	  osgDB::ObjectWrapperManager class. I've attached a change that
	  adds a mutex to the class and uses it when accessing the internal
	  wrapper/compress maps. This appears to fix the issues I was
	  having."

2015-06-01 10:50  robert

	* From Jannik Heller, "I have added new functions
	  Texture::generateAndAssignTextureObject mirroring the
	  Texture::generateTextureObject functions.
	  
	  I have left the Texture::generateTextureObject functions intact
	  as I'm not sure if/how it's used outside the core OSG. If you
	  feel that compatibility isn't important in that area feel free to
	  drop it.
	  
	  While testing the build with
	  OSG_USE_REF_PTR_IMPLICIT_OUTPUT_CONVERSION=OFF I found a compile
	  error in GlyphGeometry.cpp that was entirely unrelated to the
	  changes I've made. The fix is included in the patch.
	  
	  There is one thing left to fix and that is
	  Texture2D::SubloadCallback:
	  
	  class OSG_EXPORT SubloadCallback : public Referenced
	  {
	  public:
	  ....
	  virtual TextureObject* generateTextureObject(const Texture2D&
	  texture, State& state) const
	  {
	  return osg::Texture::generateTextureObject(&texture,
	  state.getContextID(), GL_TEXTURE_2D);
	  }
	  ...
	  }"
	  

2015-06-01 10:41  robert

	* From Jannik Heller, build fix

2015-05-29 07:52  robert

	* From Jannik Heller, fix for race condition in orphanded
	  BufferObject handling.

2015-05-26 17:24  robert

	* From Colin McDonald, "rc/osgUtl/MeshOptimizers.cpp won't compile
	  on some systems due to a missing std:: namespace prefix."

2015-05-26 17:22  robert

	* From Farshid Lashkari, "attached a small change to
	  osgUtil::SceneView that prevents unnecessary calls to glClear
	  when the split stereo separation is 0."

2015-05-26 17:17  robert

	* From Thomas Hogarth, "Little fix for
	  ClassInterface::getSupportedProperties, before if you set
	  searchAssociates to false then it would return the same
	  BaseSerialiser::Type for every entry in the PropertyMap as i was
	  not being incremented on line 539. Fix attached."

2015-05-26 17:12  robert

	* From We See, "I found a small bug in osgUtil::RenderStage::draw()
	  (osg 3.3.7), which crashes osg. The problem was caused by an
	  access to the object _camera without checking whether the object
	  is valid. So I changed the line:
	  
	  Code:
	  if (_cameraRequiresSetUp ||
	  (_cameraAttachmentMapModifiedCount!=_camera->getAttachmentMapModifiedCount()))
	  
	  to
	  
	  Code:
	  if (_cameraRequiresSetUp || (_camera.valid() &&
	  _cameraAttachmentMapModifiedCount!=_camera->getAttachmentMapModifiedCount()))
	  "

2015-05-26 17:09  robert

	* From Farshid Lashkari and Robert Osfield, "a small change to the
	  CullVisitor class, which will use cloneType() on the root render
	  stage when creating children render stages. This allows us to
	  pass a custom RenderStage object to the SceneView and have it
	  used for all sub-stages."

2015-05-26 10:05  robert

	* Rewrote the Text3D bevel implementation to automatically adjust
	  bevel thickness to avoid overalapping and erronous tesselation.
	  
	  Added osgText::Bevel::s/getRoundedConcaveJunctions(bool) to
	  control how the bevel should be tessellated around concave
	  junctions on the glyph boundary.

2015-05-26 08:48  robert

	* Added use of ref_ptr<>

2015-05-25 12:39  robert

	* Changed the EventQueue::frame() event generation to use the
	  generatePointerData/reprojectPointerData() methods in the same
	  way that other events are handled.

2015-05-25 11:33  robert

	* Added osgGA::GUIEventAdapter* returns from various EventQueue
	  event generation methods.

2015-05-21 14:11  robert

	* Fixed memory error associated with reading over the end of
	  container due to an unbounded while loop.

2015-05-06 18:39  robert

	* Update ChangeLog and AUTHORS file

2015-05-05 11:05  robert

	* Changed the CMP0020 check to > 2.8.10
	  Updated SO version number

2015-04-30 14:04  robert

	* From Christian Kehl, changes for making osgAndroid working with
	  GLES1 enabled

2015-04-30 13:59  robert

	* From Dmitriy Ogalcev, fix for crash when calling setCursor from a
	  non GUI thread

2015-04-28 16:12  robert

	* Replaced attempt at passing NULL Matrix with two specialized
	  methods.

2015-04-27 19:31  robert

	* Renamed LineSegment::intersect(BoundingSphere/Box, double/float&,
	  double/float&) methods to
	  LineSegment::intersectAndComputeRations(..) to avoid confusion
	  with the change in convention for
	  the old intersect(BoundingBox&, float/double&, float/double&)
	  method as it was inconsitent with the rest of the OSG including
	  the intersect(BoundingSphere) method in how the ratio for the
	  second intersection was measure from - original from the end
	  point, but now made consistent with other places in the OSG so be
	  based on ration from start to end of segment.

2015-04-23 14:44  robert

	* Refactoring GlyphGeometry Boundary class to facilate better bevel
	  overlap detection

2015-04-23 12:58  robert

	* Comment out debug notification

2015-04-23 09:49  robert

	* Removed unused method

2015-04-22 14:25  robert

	* From Giampaolo Vigano, "please find attached a further fix for
	  3ds plugin: now reflection map works also with transparent
	  objects (I also removed a redundant setting of BlendFunc)."

2015-04-21 17:29  robert

	* From Chris Denham, "I found a couple of memory leaks in 3DS
	  reader plugin and I have attached corrected files. I have
	  attached an example 3DS file I used to test the leaks/fixes using
	  osgviewer for trunk at rev [14853] and the tagged version 3.2.1.
	  
	  The first leak is in the lib3ds module (yeah, I know that
	  probably should be corrected at http://code.google.com/p/lib3ds/
	  but I'm assuming that as no commits have happened there since
	  2011 that it may be better to fix the copy we have in the OSG of
	  that project) The leak is caused by lib3d's use of realloc(ptr,
	  0) to free up memory allocations, but realloc, when ptr==NULL
	  returns malloc(0) rather than NULL and thus leaks a zero byte
	  allocation. The solution here was to adjust the
	  'lib3ds_util_reserve_array' function so that it realloc is not
	  used to release a NULL pointer.
	  
	  The second leak is in ReaderWriter3DS.cpp and arises when any of
	  the created StateSet objects added to the StateSetMap don't
	  subsequently get applied to a Node. The solution here was just to
	  simply use the osg::ref_ptr around the raw StateSet pointer that
	  was used in the locally defined StateSetInfo struct."

2015-04-20 10:41  robert

	* Updated AUTHORS

2015-04-20 10:36  robert

	* Build fix

2015-04-20 10:19  robert

	* Build fix

2015-04-20 09:39  robert

	* Moved uniform substitution to infront of vertex attribute
	  substituion to make sure gl_Vertex usage is replaced when
	  required.

2015-04-20 09:08  robert

	* From Tim Moore, "The order_by_primitive_mode comparer was not
	  providing a strict weak
	  ordering, which was causing a crash in the sort() call in
	  VertexAccessOrderVisitor::optimizeOrder (gcc 4.9, Fedora 21)."

2015-04-17 14:36  robert

	* Updated dev release number

2015-04-17 13:33  robert

	* Added implementations for the libraryName and className for the
	  AntiSquish node.

2015-04-17 13:24  robert

	* Fixed CollectParentPaths visitor so that it sets the
	  setNodeMaskOverride(0xffffffff) to make sure all parents are
	  traversed to find parents, even ones that have their NodeMask set
	  to 0x0.

2015-04-17 13:22  robert

	* Added --test-NodeMask option to test crash when a parent of
	  osgmanipulator::AntiSquish node has a NodeMask set to 0x0.

2015-04-16 11:19  robert

	* Changed MSVC version test to <= to enable fallback for VS2010.

2015-04-16 10:07  robert

	* Fixed crash when AntiSquish node is the root of the scene graph.

2015-04-15 18:34  robert

	* Updated ChangeLog

2015-04-15 18:05  robert

	* Updated version number of dev release

2015-04-15 17:12  robert

	* Added missing const to find VS2005 build

2015-04-14 18:16  robert

	* Added check for changes to window size during
	  GraphicsWindowWin32::init() to fix bug that occurs when the
	  window manage resizes the window automatically on creation.

2015-04-14 15:50  robert

	* From Philippe Renon, MingW build fix

2015-04-13 11:48  robert

	* Fixed typo of SEPARATE enums

2015-04-13 10:43  robert

	* From Jannik Heller, typo fixes

2015-04-13 10:11  robert

	* From Konstantin Matveyev, "I've added GLES3 profile, which also
	  enables GLES2 features (OSG_GLES3_AVAILABLE=true =>
	  OSG_GLES2_AVAILABLE=true).
	  
	  If OSG_OPENGL_PROFILE="GLES3" =>
	  GraphicsWindowIOS will create gles3 context.
	  If failed, GraphicsWindowIOS will create gles2 context.
	  Multisampling also working.
	  
	  "

2015-04-13 09:50  robert

	* From Laurens Voerman, I have modified the FindOpenEXR.cmake to
	  find the debug libraries, and to define a variable
	  (OPENEXR_LIBRARIES_VARS) with the variable names that might have
	  a _DEBUG version defined.

2015-04-13 08:55  robert

	* Added passing of command line arguments to viewer construction to
	  allow one to specify extra controls for the viewer such as window
	  size etc.

2015-04-09 18:42  robert

	* Refactored AntiSquish::computeUnSquishedMatrix() method to use
	  the parent node path of the AntiSquish node
	  to compute the required matrix rather than using the NodePath
	  provided by the NodeVistor. This is required
	  as in osg::computeLocalToWorld() usage case the NodeVisitor
	  pointer is NULL, so the correct matrix isn't possible to compute.

2015-04-09 18:38  robert

	* Added WindowSizeHandler to osgmanipulator example

2015-04-07 18:01  robert

	* From Jannik Heller, typo fixes

2015-04-07 16:58  robert

	* From Giampaolo Viganò, "you can find in the attached ZIP archive
	  a fix for 3ds plugin transparent/diffuse textures and opacity
	  maps and the support for reflection map"

2015-04-07 15:53  robert

	* From Janik Heller, clean up of drawable/node usage

2015-04-07 15:52  robert

	* Removed unused ShapesToGeometriesVisitor.

2015-04-07 15:49  robert

	* Cleaned up handling of Drawables so it utilizes the Node
	  inheritance properly.

2015-04-03 15:43  robert

	* Build fix for VS2005.

2015-04-03 13:34  robert

	* Improved the doxygen comment for the new
	  createImageWithOrientationConversion(..) function.

2015-04-03 13:29  robert

	* Added automatic rotation of jpeg image based on EXIF rotation
	  information provided in the header.

2015-04-03 13:19  robert

	* Implemented an osg::createImageWithOrientationConversion(...)
	  method to aid for changing orientation of images.

2015-04-02 16:11  robert

	* Added reading of EXIF_Orientation tags when present in a jpeg
	  file.

2015-04-02 10:12  robert

	* From Wojciech Lewandowski, Windows build fixes, "These are the
	  tweaks I had to make. JSON_Objects / json_stream headers
	  attached. I am not sure how these will behave on VS 2010. Someone
	  with VS 2010 should test it. Should be okay on VS 2008 and below
	  + VS 2012 and above, though."

2015-04-01 09:37  robert

	* From Lionel Largarde, "fix for the
	  Image::computeNumberOfMipmapLevels method. The method did use the
	  float version of the log function and the / operator.
	  It works for most of the input sizes, but fails for 8192,
	  32768...
	  For 8192, the method returns 13 instead of 14."

2015-03-31 19:31  robert

	* Fixed crash when using a subload callback, where the _images
	  array is empty by _images[0] was still being accessed.

2015-03-31 19:29  robert

	* Added --subload command line option and test subload callback for
	  testing purposes

2015-03-31 16:23  robert

	* Introduced osg::Camera::resize(..) method and associated enum
	  thus:
	  
	  enum ResizeMask
	  {
	  RESIZE_VIEWPORT=1,
	  RESIZE_ATTACHMENTS=2,
	  RESIZE_PROJECTIONMATRIX=4,
	  RESIZE_DEFAULT=RESIZE_VIEWPORT|RESIZE_ATTACHMENTS
	  };
	  
	  /** Resize, to the specified width and height, the viewport,
	  attachments and projection matrix according to the resizeMask
	  provided.
	  * Note, the adjustment of the projection matrix is done if the
	  RESIZE_PROJECTIONMATRIX mask to set and according to the rules
	  specified in the ProjectionResizePolicy. */
	  void resize(int width, int height, int
	  resizeMask=RESIZE_DEFAULT);

2015-03-31 15:08  robert

	* Introduced Camera::resizeAttachments(int width, int height) to
	  resize all the Texture and Image assigned the the Camera
	  attachments.

2015-03-31 10:41  robert

	* Refactor the RTT Camera resize code into a seperate Callback
	  method in prep for this all being done by a single Camera API
	  call.

2015-03-31 10:36  robert

	* Added Camera::dirtyAttachmentMap(),
	  Camera::s/getAttachmentMapModified() value and usage of this in
	  RenderStage as a new mechanism
	  for telling the rendering backend to update itself to reflect new
	  values in the attachments such as new texture or image sizes.

2015-03-23 11:36  robert

	* Added StatsHandler to osgtessellationshaders example to test out
	  rendering bug associated with stats rendering.

2015-03-20 17:58  robert

	* Added event handle to alter the RTT Camera's dimensions to follow
	  the windows resizes.

2015-03-20 15:49  robert

	* Fixed resize dimensions of X11 window

2015-03-20 11:48  robert

	* From Jannik Heller, "Fix for Qt4 multi-threaded crash. This patch
	  adds the AA_X11InitThreads flag to the QApplication setup,
	  meaning QT will call XInitThreads for us. This also bumps the
	  required QT version to 4.8+, because the AA_X11InitThreads flag
	  was introduced in that version. If that is not acceptable, we
	  could add a QT_VERSION >= 0x040800 guard, or manually call
	  XInitThreads() instead. Let me know what you think."

2015-03-19 10:49  robert

	* Added Texture wrap setting to CLAMP_TO_EDGE to fix rendering
	  problem when running the default osgdistortion example

2015-03-17 18:10  robert

	* Fixed VisualStudio warning

2015-03-17 14:50  robert

	* From Konstantin Matveyev, "Added ComputeBoundingBoxCallback,
	  ComputeBoundingSphereCallback and UpdateCallback implmenentations
	  to serializers"

2015-03-17 09:40  robert

	* Updated ChangeLog and AUTHORS file for dev release

2015-03-17 09:09  robert

	* Fixed library wrapper

2015-03-17 08:25  robert

	* Added ComputeBoundingSphereCallback reference

2015-03-17 08:24  robert

	* From Konstantin Matveyev, "More "LibraryWrapper" fixes for osg
	  and osgAnimation NodeKits
	  in the attachment (for 3.3.6 version :)
	  
	  Fixes:
	  
	  osg:
	  Unsupported associated class osg::UpdateCallback
	  (osg_Drawable_UpdateCallback);
	  ComputeBoundingBoxCallback
	  
	  osgAnimation:
	  Unsupported wrapper class
	  osgAnimation::RigComputeBoundingBoxCallback
	  "

2015-03-17 08:19  robert

	* Changed to using osgDB::ofstream to work around Windows build
	  issue

2015-03-16 17:01  robert

	* Removed unneccessary library link line.

2015-03-16 14:16  robert

	* Removed the using namespace std and replaced with local std:: to
	  make the code clearer

2015-03-16 12:13  robert

	* Refactored the command line setup to enable better control of set
	  up.
	  Added WindowSizeHandler to allow for adjustment of window size.

2015-03-16 10:30  robert

	* From Konstantin Matveyev, "Last update in the
	  osgAnimation::Animation ONCE mode bug fix"

2015-03-16 10:07  robert

	* Added --play-mode [ONCE, STAY, LOOP, PPONG] to help with testing.

2015-03-13 08:12  robert

	* From Konstantin Matveyev, "Small fix for OSG 3.3.6.119 in the
	  attachment.
	  
	  One line added in osg/LibraryWrapper.cpp
	  
	  USE_SERIALIZER_WRAPPER(Callback)
	  "

2015-03-12 17:11  robert

	* Refactored how the callbacks for updating geometry are managed in
	  MorphGeometry and RigGeometry to address bugs in serialization.

2015-03-12 15:12  robert

	* From Laurens Voerman, "attached is a zip with a modified version
	  of:
	  OpenSceneGraph\CMakeModules\FindFBX.cmake
	  
	  This version can find fbx sdk 2015.1 and will prefer it over
	  older versions.
	  
	  Tested with Visual Studio Express 2013 on 64bit windows 7"

2015-03-12 13:41  robert

	* From Mattias Helsing, add copyright notice from other osgjs
	  header to the json_stream header

2015-03-12 13:37  robert

	* Added using namespace std and removed the std:: prefixes before
	  the std::isfinte and std::isinf function calls to avoid problems
	  with Android builds against older NDK's.

2015-03-11 17:47  robert

	* From Laurens Voerman, warning fixes

2015-03-11 17:36  robert

	* From Laurens Voerman, "The current version will not compile with
	  SDL version 2, error
	  OpenSceneGraph\src\osgPlugins\sdl\JoystickDevice.cpp(42): error
	  C2664: 'const char *SDL_JoystickName(SDL_Joystick *)' : cannot
	  convert argument 1 from 'int' to 'SDL_Joystick *'
	  due to changes in the SDL api.
	  
	  Tested with Visual Studio Express 2013; SDL 2.0.1"

2015-03-11 17:27  robert

	* Completed support for assigning 3D osg::Image to
	  osg::Texture2DArray.
	  
	  Improved the osgtexture2DArray example to add --mipmap and
	  --packed command line options to help with testing.

2015-03-11 15:44  robert

	* Updated the comments to be more relevant

2015-03-10 18:15  robert

	* Work in progress to allow osg::Texture2DArray to be set up with a
	  single osg::Image containing 3D image data.

2015-03-10 18:07  robert

	* Work in progress on new osgtexture2DArray example

2015-03-09 11:27  robert

	* From Cedric Pinson, gles and osgjs plugins that support
	  conversion of OSG loaded models into a form that can be used with
	  osgjs JavaScript library

2015-03-05 19:53  robert

	* Update AUTHORS file for 3.3.6 dev release

2015-03-05 19:33  robert

	* Updated dev release number

2015-03-05 19:26  robert

	* Updated ChangeLog for dev release

2015-03-05 10:53  robert

	* Added check for newline at end of version line, and of it's not
	  add a '\n'

2015-03-04 18:39  robert

	* Updated SO_VERSION after changes to osgPresentation

2015-03-04 18:36  robert

	* Restructed the osgPresentation and present3D directories back to
	  the structure that was present in OSG-3.2

2015-03-04 17:42  robert

	* Removed the experiemental osgPresentation classes. These are only
	  partially functional and not appropriate for the stable OSG-3.4
	  release

2015-03-03 15:26  robert

	* Updated AUTHORS for 3.3.5 dev release

2015-03-03 14:59  robert

	* Fixed ClusterCullingCallback parser problem due to osg::Callback
	  not being included in inheritance list

2015-03-03 12:56  robert

	* Restructed the checks in the
	  CollectLowestTransformsVisitor::removeTransforms() to avoid
	  benign case being flagged as warning.

2015-03-03 12:03  robert

	* From Miha Ravselj, "Regarding previous submission it was only
	  partial solution. After further testing I found similar bug also
	  in ClearNode serializer.
	  
	  //GLbitfield mask = GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT;
	  This line was problematic since it produced incorrect result when
	  let's say COLOR flag is serialized
	  it should be null as in Camera serializer or in a proposed
	  BitFlagsSerializer
	  
	  
	  This line of code caused that whenever only GL_COLOR_BUFFER_BIT
	  bit was written and on value read
	  GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT was restored instead of
	  GL_COLOR_BUFFER_BIT only.
	  
	  //GLbitfield mask = 0; //this resolves the issue same as in
	  camera
	  Also same bit-wise comparison bug was also present in write
	  method.
	  -------------------------------------------------------------------------------------
	  
	  As you can see there are total 3 bit mask serializers in OSG and
	  all 3 had bugs so I decided to add ADD_BITFLAGS_SERIALIZER and
	  replace USER serializers in osg::Camera, osg::ClearNode and
	  osgText::TextBase. I have made sure that bitflags serializer does
	  not break backwards-compatibility since it uses same code as user
	  serializer does in all 3 cases. (see tester.cpp on how
	  compatibility test was performed)"

2015-03-03 12:00  robert

	* Re-organized the #ifdef's to avoid usage of glPolyginMode under
	  GLES

2015-03-02 14:38  robert

	* Updated SO_VERSION to take account of API changes in osgDB

2015-03-02 12:11  robert

	* From Johannes Scholz, "Attached you find a patch for
	  osgDB::OutputStream and osgDB::InputStream to include
	  osg::Image::data() using Base64 encoding inside the ASCII OSGT,
	  if WriteImageHint=IncludeData is set, only."

2015-03-02 12:09  robert

	* From Michael McDonnel, "The tessellation shader example has a
	  small bug.The middle of the
	  geometry is clipped as soon as it is tessellated. The clipping is
	  probably caused by rounding errors because it is only in one
	  spot. The
	  clipping disappears when the camera is moved, and reappears when
	  it is
	  moved back. Expanding the the bounding box fixed the clipping
	  bug."
	  
	  Tweaked by Robert Osfield to expand it to a -1 to 1 unit box.
	  Actual clipping bug is not due to rounding errors but the shaders
	  creating vertices outside the bounding box of the original input
	  vertices

2015-03-01 15:20  robert

	* Fixed StateSet::Define names to match
	  OpenSceneGraph-Data/shaders.

2015-03-01 11:08  robert

	* From Jannik Heller, "I noticed the rotation in the
	  OrbitManipulator depends on the framerate. To reproduce this
	  issue, start the osganimate example, rotate the model with the
	  left mouse button, then let go of the mouse button while still
	  moving. You will notice that with V-Sync enabled, the model
	  rotates slower.
	  
	  The OrbitManipulator calculates a scale to counteract the
	  framerate dependency, but it turns out this scale wasn't used for
	  the rotation yet."

2015-02-27 10:01  robert

	* Updated version number after dev release.

2015-02-27 09:47  robert

	* Updated ChangeLog and Contributors to fix trailing spaces

2015-02-27 09:05  robert

	* Fixed Windows warnings

2015-02-27 04:29  robert

	* Fixes for warnings

2015-02-26 20:15  robert

	* Fixed build with auto ptr conversion switched off

2015-02-26 19:51  robert

	* Updated AUTHORS

2015-02-26 19:14  robert

	* From Bradley Baker Searles, "We had someone replace a DDS texture
	  with a GL_RGB/GL_UNSIGNED_SHORT_5_6_6 image, which would trigger
	  a crash in Image.cpp while flipping the mipmap chain. The code
	  was trying to flip the mipmaps using the rowStep for the
	  full-size image (we have "dds_flip" set in the
	  osgDB::ReaderWriter::Options in the osgDB::Registry)."

2015-02-26 18:06  robert

	* From Bradley Baker Searles, "Small patch attached to handle DDS
	  flip when s=4. Currently it will omit flipping and generate a
	  warning: "Vertical flip was skipped. Image dimensions have to be
	  multiple of 4."

2015-02-26 17:49  robert

	* From Julien Valentin and Alberto Luaces, added support for
	  transform feedback extensions

2015-02-26 17:18  robert

	* Update AUTHORS file

2015-02-26 14:16  robert

	* Fixed typo

2015-02-26 13:52  robert

	* Regenerated AUTHORS.txt to fix missing special characters

2015-02-25 19:59  robert

	* Updated AUTHORS file

2015-02-25 19:52  robert

	* Updated ChangeLog

2015-02-25 19:38  robert

	* From Aitor Moreno, "Attached you will find the modified file
	  without the lines which raises the exception. "

2015-02-25 19:31  robert

	* From Jamie Robertson, "I've been using osgSim::ScalarBar to
	  display fixed range color values (e.g. red from 1-2, green from
	  3-4 etc), by setting the _numColors the same as the number of
	  actual colors in the ColorRange.
	  
	  Currently if you do this you get strange looking results as the
	  colors are calculated for values in the centre of each color
	  step, so if your steps are large, the colors are interpolated
	  sigificantly (see screen grab of red, green and blue colors for
	  illustration).
	  
	  I've attached a fix which just uses the original color values
	  whenever _numColors equals the number of actual defined colors in
	  the ColorRange. I doubt anyone would want interpolated colors in
	  these circumstances."

2015-02-25 19:25  robert

	* From Dmitry Marakasov, "While packaging osg-3.3.3 I've discovered
	  that gstreamer detection is
	  broken:
	  
	  -- Could NOT find GStreamer (missing: GSTREAMER_BASE_INCLUDE_DIRS
	  GSTREAMER_BASE_LIBRARIES GSTREAMER_GSTREAMER-APP_INCLUDE_DIRS
	  GSTREAMER_GSTREAMER-APP_LIBRARIES
	  GSTREAMER_GSTREAMER-PBUTILS_INCLUDE_DIRS
	  GSTREAMER_GSTREAMER-PBUTILS_LIBRARIES) (found version "1.4.5")
	  
	  though all required modules are installed.
	  
	  There are two problems: first, module names are spelled
	  incorrectly in root
	  CMakeLists.txt (e.g. gstreamer-app instead of app), so variables
	  expected
	  for them are e.g. GSTREAMER_GSTREAMER-APP_INCLUDE_DIRS instead of
	  GSTREAMER_APP_INCLUDE_DIRS.
	  
	  Second, gstreamer base component is detected as GSTREAMER while
	  checked
	  later as GSTREAMER_BASE. I've uncommented the detection as
	  GSTREAMER_BASE, but obviously that should be revisited and only
	  one
	  detection left. With this patch, gstreamer is detected properly
	  and
	  the plugins is successfully built and installed."

2015-02-25 19:19  robert

	* From Jonathan Greig, "I was testing out the example and it works
	  fine as a standalone example, but I found that it didn't work as
	  expected when adding the class to some existing code I have to
	  test it out. The osg widget was appearing but it didn't appear to
	  be updating. After tweaking it to pass on the parent QWidget
	  pointer from my code, it worked as expected. I added the
	  WindowFlags to the attached file for good measure. If you look at
	  the Qt Documentation for QWidget (
	  http://doc.qt.io/qt-5/qwidget.html#QWidget ), you'll see that is
	  exactly where I got this from. When subclassing a widget as such,
	  you should allow the user to pass in the parent at least,
	  considering that has a major effect on how or if Qt may clean up
	  the memory."

2015-02-25 18:56  robert

	* From Andreas Henne, Support for GL3 core profile in osgText

2015-02-25 16:59  robert

	* From Michael McDonnell, "I have changed the code so that the plus
	  key increases both the inner
	  and outer tessellation. The minus key decrease both the inner and
	  outer tessellation. You can still use the arrow keys to control
	  inner
	  and outer tessellation separately."
	  
	  From Robert Osfield, clean up the code to fix warnings and make
	  the coding style more consistent with the rest of the OSG.

2015-02-25 14:55  robert

	* Fixed handling of NULL entries in osg::Geometry TexCoordArrayList
	  and VertexAttribArrayList.

2015-02-24 11:06  robert

	* Fixed matrix setup.

2015-02-23 20:28  robert

	* Fixed image allocation operations.

2015-02-23 11:43  robert

	* From Miha Ravšelj and Robert Osfield, fix for serializer bug in
	  osgText::TextBase and osg::Camera

2015-02-23 11:07  robert

	* From Arjun Ramamurthy, fix for use of StatsHandler in
	  multipleviews/windows

2015-02-20 15:12  robert

	* Changed the toggle of defines so that it works with assumed
	  defaults now set up by the GeometryPool so that when toggling it
	  doesn't have a delay in what the user would expect

2015-02-20 15:04  robert

	* Removed redudent shaders, and updated remaining shaders to match
	  OpenSceneGraph-Data/shaders

2015-02-20 15:02  robert

	* First step of refactoring the osg::Program management in
	  osgTerrain::GeometryPool for better performance by placing
	  default osg::Program and shader defines on a single StateSet
	  below the osgTerrain::Terrain

2015-02-18 10:52  robert

	* Moved osgTerrain::GeometryPool from
	  osgTerrain::DisplacementMappingTechnique to the
	  osgTerrain::Terrain

2015-02-18 10:23  robert

	* From Sebastian Messerschmidt, "Attached you find a version of the
	  ReaderWriterDDS with info outputs set to OSG_INFO instead of
	  OSG_NOTICE. The old version spams the console for each loaded DDS
	  file."

2015-02-17 20:42  robert

	* Added support for DefineList to StateSet::merge(..)

2015-02-17 19:40  robert

	* From Stephan Wenglorz, "the attached fix corrects a small bug in
	  OperationThread::setDone(bool), calling it had the opposite
	  effect of what was intended, i.e. setting done to false actually
	  finished the thread. The effect was that VPB threads would exit
	  before starting osgdem when a task had been enqueued, because
	  they initially set done to false."

2015-02-17 19:22  robert

	* Removed GL_ usage in defines

2015-02-17 19:21  robert

	* Removed commented out lines

2015-02-17 10:36  robert

	* Cleaned up warning generated when compiling osgocculusviewer

2015-02-13 12:50  robert

	* Improvements to the #pragma(tic) shader composition support

2015-02-13 10:56  robert

	* Deprecated the old ShaderComposition example code so that it's
	  now only invoked if you add a --old to the osgshadercomposition
	  command line.
	  
	  Introduced a new shader composition example based on the new
	  #pragama and #define based GLSL shader/osg::StateSet::setDefine()
	  functionality now built into the core OSG.

2015-02-13 07:45  robert

	* From Farshid Lashkari, "I've attached a fix for some internal glu
	  functions so that they use size_t for computing allocation sizes
	  instead of GLint. I encountered some large images that were
	  triggering integer overflows with the current code."

2015-02-11 19:21  robert

	* Fixed warning

2015-02-11 16:41  robert

	* Added reassignment of the #version line to the first entry in the
	  source list.

2015-02-11 09:41  robert

	* Added GL #define for Windows build

2015-02-10 21:13  robert

	* Windows build fix

2015-02-10 18:01  robert

	* Added GL_LINES_ADJACENCY_EXT variants back into ObjectWraper to
	  enable backwards compatibility.

2015-02-10 17:53  robert

	* Change for new Program API

2015-02-10 17:20  robert

	* Added support for new #pragam(atic) shader composition to new
	  displacement mapping technique

2015-02-10 17:04  robert

	* Introduced new shader composition approach that utilizes #pragma
	  requires(), #pragma import_defines() and #ifdef in GLSL to enable
	  multiple different versions of shaders based
	  on defines passed in from osg::StateSet::setDefine(..).

2015-02-04 15:11  robert

	* Fixed typo.

2015-02-03 16:36  robert

	* Removed unncessary _EXT

2015-02-02 09:53  robert

	* Commented out the experimental V8 and Python plugins as these
	  plugins only existed as a proof of concept test linkage with
	  these dependenices, and have no functionality beyond this.

2015-01-27 15:07  robert

	* Replaced _EXT defines with GL-3.2 versions

2015-01-23 17:15  robert

	* From Javier Taibo,
	  "I have found a "bug" in the new audio decoding code (actually I
	  think the bug is in ffmpeg, but anyway it should be wise to
	  protect the OSG plug-in about it). I am attaching a security
	  check in FFmpegDecoderAudio.cpp.
	  
	  If anybody is curious about the problem, it happens sometimes
	  when decoding an AAC audio stream. It eventually includes a PCE
	  block inside the AAC audio frame and then ffmpeg audio decoding
	  function signals a "new_frame" with 1024 samples, but a null
	  pointer instead of the audio data. It can be easily detected
	  because in these cases number of channels is 0. Maybe this is the
	  intended behaviour for ffmpeg, but I find it quite weird.
	  "
	  
	  " It seems that libav does not have a channels attribute in
	  AVFrame structure. This new version should do."

2015-01-23 13:51  robert

	* Changed osgFX::MultiTextureControl so that it uses an
	  osg::FloatArray internally to enable sharing with osg::Uniform.

2015-01-23 13:50  robert

	* Added MultiTextureControl event handling of shift 012 i.e. ')',
	  '!', '"' and 'A' to toggle full on for each of the respective or
	  all texture units.

2015-01-22 16:49  robert

	* Added #define GL_SEPARATE_ATTRIBS and correcte
	  GL_INTERLEAVED_ATTRIBS

2015-01-22 16:41  robert

	* From Alexey Pavlov, "Export fix for Windows platform"

2015-01-22 15:08  robert

	* Added GL_INTERLEAVED_ATTRIBS for windows build

2015-01-22 15:07  robert

	* Fixed warning

2015-01-21 15:35  robert

	* From Andreas Henne, OpenGL core profile fixes required for OSX.

2015-01-21 11:09  robert

	* Added TextureWeights uniform support and controls to
	  osgFX::MultiTextureControl to support usage with shaders.

2015-01-20 18:01  robert

	* Re-enabled texturing and fixed runtime warning

2015-01-20 17:58  robert

	* Added hardwired geometry shaders

2015-01-20 17:40  robert

	* Updated shaders

2015-01-20 15:23  robert

	* Added key osgTerrain::GeometryPool methods virtual to make it
	  easier to override the shaders

2015-01-20 11:24  robert

	* Changed the reset of the GLExtensions::Set() in the State
	  destructor so that it checks to see if the local _glExtensions
	  pointer has been set up and taken ownership of the
	  GLExtensions::Set() value

2015-01-19 11:29  robert

	* Added GeometryPool::s/getUseGeometryShader() hint, and
	  OSG_TERRAIN_USE_GEOMETRY_SHADER env var for setting the default
	  value.

2015-01-16 11:03  robert

	* Added support for using geometry shaders to align the quad
	  diagonals with the local terrain

2015-01-12 10:31  robert

	* Added a local Vec3Array cache to the HeightFieldDrawable to
	  facilitate efficient intersection testing

2015-01-12 10:30  robert

	* Added ability to populate a local vertex cache for when one
	  computes final vertex position in a vertex shader but still want
	  to the Primitive functors to work with the transformed positions.

2015-01-07 14:14  robert

	* From Javier Taibo, "I have found that since version 1.1, FFMPEG
	  changed the way audio streams are retrieved, from packed to
	  planar format. SDL interprets packed audio, as is used in the
	  osgmovie example. To make the audio work when the OSGffmpeg
	  plug-in is compiled against recent FFMPEG versions,
	  FFmpegDecoderAudio must check for planar formats and in these
	  cases request the samples as packed. This way all works as
	  before. It can be checked with osgmovie example application.
	  
	  $ osgmovie --audio movie.avi.ffmpeg
	  FFmpegImageStream::open audio failed, audio stream will be
	  disabled: unknown audio format
	  
	  With the attached FFmpegDecoderAudio.cpp, audio sounds correctly.
	  
	  I am also attaching a modified version of FindFFmpeg.cmake that
	  allows to set as FFMPEG_DIR the ffmpeg compiled in the source
	  directory structure. It should not break anything as it only adds
	  some additional search paths.
	  "

2015-01-07 10:36  robert

	* From Farshid Lashkari, "small change to
	  osg::Image::readImageFromCurrentTexture to allow reading data
	  from compressed cubemap textures."

2015-01-06 17:23  robert

	* Cleaned up GL_TEXTURE_BUFFER_*ARB usage as include/osg/GLDefines
	  now provides the non ARB variants

2015-01-06 17:12  robert

	* From Julien Valentin, "To sum up changes, I had:
	  -some extensions in GLExtensions
	  - GL_TEXTURE_BUFFER as target in osg::StateSet
	  - a VBO based transform feed back example
	  "

2015-01-06 17:09  robert

	* Updates SO_VERSION in prep for API modifications since the 3.3.3
	  dev release

2015-01-06 14:55  robert

	* From Julien Valentin, added missing initializer

2015-01-06 14:41  robert

	* From Julien Valentin, typo fix

2015-01-05 17:39  robert

	* From Jason Beverage, "Here is a fix to the STL plugin that fixes
	  build errors introduced in the last commit. It's just a simple
	  addition of the stdint.h header."

2014-12-24 11:56  robert

	* Updated ChangeLog and AUTHORS

2014-12-24 11:43  robert

	* Removed debug message

2014-12-24 11:25  robert

	* From Marc Helbling, Clément Léger, Aurélien Chatelain, Paul
	  Cheyrou-Lagrèze :
	  "a last submission for the obj plugin
	  * supports vertex color definition after vertex position by
	  Clément Léger
	  * supports zbrush vertex color definition (as #MRGB comment) by
	  Aurélien Chatelain
	  * adds a noReverseFace option to not mess with face definition by
	  Aurélien Chatelain
	  * makes material parsing case insensitive (by Paul
	  Cheyrou-Lagrèze and me)
	  * makes the plugin resilient to faulty vertex uv/normal
	  definition (i.e. when a too big index is referenced) by Aurélien
	  hatelain
	  "

2014-12-24 11:02  robert

	* From Aurélien Chatelain, "adds support for
	  * quad primitives
	  * face definition with the "vertex_index" label (previously only
	  "vertex_indices" was supported)
	  * replaces normal computation by the SmoothingVisitor to avoid
	  code duplication
	  "
	  
	  Submitted by Marc Helbling.

2014-12-24 10:55  robert

	* From Aurélien Chatelain, "the smoothing visitor did not handle
	  shared arrays. It may leads to bad geometry arrays when a shared
	  array is involved in the scene.
	  This submission adds shared array duplication (and moves the
	  SharedArrayOptimizer declaration in MeshOptimizer to make it
	  callable from the SmoothingVisitor)."
	  
	  Submitted by Marc Helbling.
	  Edited by Robet Osfield to retain the usual OSG coding style.

2014-12-24 10:47  robert

	* From Aurélien Chatelain, "updates the STL plugin:
	  * fixes vertex color support
	  * adds 'magics' color definition
	  * cleans options to make the plugin more consistent with other
	  plugins
	  * adds options to not tristrip geometries"
	  
	  Submitted by Marc Helbling.

2014-12-24 10:14  robert

	* Aded shaders for various combinations of layers.

2014-12-24 10:13  robert

	* Added osgDB::readShaderFileWithFallback(..) convinience functions
	  to make it easier to set up reading external shader files with a
	  built in fallback.

2014-12-23 14:20  robert

	* Added support for reading Vec3 colour arrays

2014-12-23 12:10  robert

	* Changes to allow the COLLADA plugin to compile against the latest
	  COLLADA DOM version 2.4 as well as retaining compatibility with
	  the old 2.2 DOM.

2014-12-22 10:35  robert

	* Added comment about using -DCMAKE_DISABLE_FINDPACKAGE_* command
	  line.

2014-12-22 09:50  robert

	* Added doxygen comment for ref_ptr<>::release().

2014-12-22 09:49  robert

	* Updated version number after dev release

2014-12-19 11:00  robert

	* Windows build error and warning fixes

2014-12-19 10:25  robert

	* Updated ChangeLog and AUTHORS file for dev release

2014-12-19 08:27  robert

	* Added if () block to avoid script variables set to NOT-Found
	  being used in searching

2014-12-19 08:25  robert

	* Fixed script warnings

2014-12-18 17:47  robert

	* From Aitor Moreno, LAS plugin - depends upon boost and liblas and
	  liblas-c

2014-12-18 16:52  robert

	* From Adrian Clark, build fix for recent Android NDK using the old
	  Android build approach.

2014-12-18 15:59  robert

	* From Mattias Helsing, "CMake have release 3.0 and 3.1 and we have
	  some bad checks for cmake
	  major version when settings cmake policies in CMakeLists.txt.
	  This fixes it"

2014-12-18 11:36  robert

	* Updated AUTHORS

2014-12-18 11:19  robert

	* Updated ChangeLog in prep for dev release

2014-12-18 11:09  robert

	* Fixed warning

2014-12-18 10:59  robert

	* Added DisplaySettings::s/getNvOptimusEnablement() and
	  OSG_NvOptimusEnablement env var control to control the setting of
	  the NvOptimusEnablement variable

2014-12-18 09:24  robert

	* From Sukender, "Added options to the FBX writer: an ascii/binary
	  switch, and the ability to select FBX version as the SDK handles
	  it (Ex: "FBX201300").
	  
	  This allows the user to achieve backward compatibility, and debug
	  format issues using text output."

2014-12-18 09:03  robert

	* From Mattias Helsing, "The addition of the GStreamer cmake find
	  script broke my build because
	  cmake vars weren't passed correctly to find_package_handler_args,
	  so
	  while the find script didn't find a single required GStreamer lib
	  or
	  include path it still reported GSTREAMER_FOUND=TRUE (and then
	  tried to
	  compile the new plugin). This fixes it and correctly reports
	  missing
	  components."

2014-12-17 19:21  robert

	* Added support for using SDL2 to the osgmovie to enable it to
	  handle floating point audio formats

2014-12-17 19:20  robert

	* From Javier Taibo, " I have found that since version 1.1, FFMPEG
	  changed the way audio streams are retrieved, from packed to
	  planar format. SDL interprets packed audio, as is used in the
	  osgmovie example. To make the audio work when the OSGffmpeg
	  plug-in is compiled against recent FFMPEG versions,
	  FFmpegDecoderAudio must check for planar formats and in these
	  cases request the samples as packed. This way all works as
	  before. It can be checked with osgmovie example application.
	  
	  $ osgmovie --audio movie.avi.ffmpeg
	  FFmpegImageStream::open audio failed, audio stream will be
	  disabled: unknown audio format
	  
	  With the attached FFmpegDecoderAudio.cpp, audio sounds correctly.
	  
	  I am also attaching a modified version of FindFFmpeg.cmake that
	  allows to set as FFMPEG_DIR the ffmpeg compiled in the source
	  directory structure. It should not break anything as it only adds
	  some additional search paths.
	  
	  "
	  
	  Note from Robert Osfield, I have found in testing that audio
	  quality is not good for planar floating point formats, even with
	  adding support for SDL2 to the osgmovie example. I haven't yet
	  tracked down the cause of these audio problems or a solution.

2014-12-17 10:19  robert

	* From Sukender, "FBX writer was writing an empty file when the
	  scene had a root node being a Geode.
	  This was caused be the change in Drawable (now derived from Node)
	  and Geode (now derived from Group).
	  This fix simply sticks with previous behaviour. Another change
	  could be to adapt WriterNodeVisitor.
	  "

2014-12-16 17:37  robert

	* Fixed warnings and memmory leaks

2014-12-16 17:15  robert

	* Fixed warnings

2014-12-16 17:08  robert

	* Improved handling of invalid/unhandled files
	  Added support for ImageStream::LoopigMode variable
	  Fixed memory leak associtied with restarting videos
	  Changed Image::setData() to Image::dirty() to avoid resetting
	  data

2014-12-16 11:20  robert

	* From Julen Garcia, "Here there is a small plugin I use to play
	  video files. It is based on GStreamer
	  http://gstreamer.freedesktop.org and I have used the FFmpeg
	  plugin as inspiration."
	  
	  From Robert Osfield, fixed handled of row widths so that they are
	  padded to a 4 byte boundary as certain row widths were being
	  rendered incorrectly.

2014-12-16 09:34  robert

	* From Marc Helbling, "please find enclosed a submission that
	  should improve the VertexAccessOrderVisitor (pre-transform)
	  optimizer:
	  * it sorts primitives to keep "more complex" primitives first;
	  maybe you'll prefer to have this as an option (but usually it
	  should make more sense to pre-transform triangles before e.g.
	  lines)
	  * currently, the visitor rely on TriangleIndexFunctor and does
	  not take care of points and lines (see
	  https://github.com/openscenegraph/osg/blob/master/include/osg/TriangleIndexFunctor#L124-130).
	  This can lead to issues e.g. if you store the wireframe lines
	  along with some triangles: the triangles will be reindexed but
	  not the line. I've therefore added
	  osg/include/TriangleLinePointIndexFunctor to index triangles,
	  lines and points and derived VertexReorder from this class.
	  * to avoid issues, shared arrays are duplicated. However, in some
	  cases (e.g. an UV channel shared in the geometry only) this is
	  not required. I'm adding a SharedArrayOptimizer to optimize this:
	  it looks for duplicated UVs before the array duplication and
	  deduplicate arrays after.
	  "

2014-12-15 17:15  robert

	* From Marc Helbling, "please find the mergeTriangleStrip code
	  merged in osgUtil::TriStripVisitor.
	  I've removed the references to DrawArrays as we should no longer
	  produce any.
	  
	  Note that:
	  * as the name suggest, it only works for triangle strips but
	  could probably be easily extended to quads
	  * the resulting primitive is not highly optimized; we could
	  probably sort the strips in order to minimize the number of
	  primitive restart
	  * as we may merge DrawElementsUInt and DrawElementUShort, the
	  code will only generate DrawElementsUInt"

2014-12-10 18:23  robert

	* Build fix

2014-12-10 13:05  robert

	* Added OpenGL Transform Feedback extensions.

2014-12-10 12:23  robert

	* From Marcus Hein, Added support for OpenGL SSBO and SSBB via
	  osg::ShaderStorageBufferObject and
	  osg::ShaderStorageBufferBinding to core OSG library, and added
	  new osgSSBO example

2014-12-10 11:44  robert

	* Added GLDefines header

2014-12-10 11:29  robert

	* From Farshid Lashkari, "The Collada loader would crash while
	  processing textures on certain files. I've attached the fix."

2014-12-10 10:44  robert

	* Removed old GL2Extensions class, replacing it with a typedef to
	  GL2Extensions
	  Removed old includes to include/osg/GL2Extensions

2014-12-10 10:38  robert

	* Moved GL2Extensions functionality into the
	  include/osg/GLExtensions header and new GLExtensions object.
	  Moved the #defines into new include/osg/GLDefines
	  Converted all GL2Extensions usage to GLExtensions usage

2014-12-10 09:11  robert

	* Streamlined the extension functions

2014-12-09 21:33  robert

	* Added #ifdef's around GLsync typedef

2014-12-09 20:09  robert

	* Windows build fixes

2014-12-09 19:31  robert

	* Added new examples to runexamples.bat script

2014-12-09 19:22  robert

	* Quietened down debug messages

2014-12-09 19:20  robert

	* From Wand Rui, "I've rewritten the osgblenddrawbuffers example to
	  use the new BlendFunci and Capability classes. Hope it will tell
	  others how to make use of the new functionality and why they are
	  important in modern MRT-based applications."

2014-12-09 18:30  robert

	* Moved FBO Extensions into GL2Extensions.

2014-12-09 14:58  robert

	* Removed no longer used Extension definition

2014-12-09 14:57  robert

	* Moved local Extensions structs into GL2Extensions

2014-12-09 11:14  robert

	* Moveved Stencil/StencilTwoSided::Extensions into GL2Extensions

2014-12-09 10:37  robert

	* Moved local Extensions objects to GL2Extensions

2014-12-09 10:05  robert

	* Moved Texture*::Extensions functionality into GL2Extensions

2014-12-08 16:08  robert

	* MOved VertexProgram and FragmentProgram::Extensions into
	  GL2Extensions.

2014-12-08 11:08  robert

	* Fixed memory leak in RenderStageCache.

2014-12-07 17:31  robert

	* MOved SampleMaski::Extensions into osg::GL2Extensions

2014-12-05 20:05  robert

	* Moved TextureCubeMap::Extension functionality into GL2Extensions

2014-12-05 17:26  robert

	* Moved osg::Drawable::Extensions into osg::GL2Extensions

2014-12-05 10:37  robert

	* Fixed windows build warnings

2014-12-05 09:52  robert

	* Windows build fix

2014-12-05 08:58  robert

	* From the GLintptr + GLsizeiptr defintions to GL2Extensions header

2014-12-04 19:03  robert

	* Moved osg::BlenFunc::Extensions into osg::GL2Extensions

2014-12-04 18:13  robert

	* Moved GLBufferObject::Extensions structure into
	  osg::GL2Extensions

2014-12-04 18:12  robert

	* Removed redundent spaces

2014-12-04 17:12  robert

	* Added glMemoryBarrier, glMapBufferRange and glBindBufferBase to
	  GL2Extensions

2014-12-04 16:28  robert

	* Moved old GL2Extensions::Get(..) usage across to new
	  osg::State::get<GL2Extensions>() usage

2014-12-04 16:22  robert

	* Ported GL2Extentions across to using the new GL extensions
	  approach - cutting code count by 3000 lines!

2014-12-04 15:10  robert

	* Build fix for when ref_ptr<> auto conversion is disabled

2014-12-03 17:31  robert

	* Added osg::Capability and Cabibilityi base classes to wrap up
	  glEnable/glDisable + glEnablei/glDisablei functionality, with
	  osg::Enablei and osg::Disablei concrete implementations.

2014-12-02 17:12  robert

	* Added osg::BlendFunci, osg::BlendEquationi and osg::ColorMaski
	  StateAttrirbutes that wrap the glBlendFunci, glBlendEquationi and
	  glColorMaski functions

2014-12-02 15:37  robert

	* Moved BlendEquation across to using the new GL extension setup
	  approach.

2014-12-02 15:21  robert

	* Fixed typo

2014-12-02 11:10  robert

	* Added a template get and get_exisiting method into osg::State
	  that implements a new mechanism for managing OpenGL extensions.
	  
	  Refactored the BendFunc::Extensions usage to simplify it
	  utilizing the new osg::State extension mechanism.

2014-11-28 16:20  robert

	* From Rafa Gaitan, "I'm attaching also a new version of the
	  toolchain with support for the r10c ndk. This fixes some CMake
	  Warnings and allows to use the toolchain in macosx."

2014-11-28 16:10  robert

	* Removed include/osg/Version and include/OpenThreads/Version
	  headers as these are autogenerated.
	  
	  Changed the paths for the OpenThreads/osg Version headers to be
	  placed in the PROJECT_BINARY_DIR.

2014-11-28 10:54  robert

	* Standardized on defined(__ANDROID__)

2014-11-28 10:52  robert

	* Added getlocaledecpoint() workaround for Android build of lua
	  plugin

2014-11-27 15:54  robert

	* Added in source shaders

2014-11-27 15:39  robert

	* Changed the name of shader files

2014-11-26 20:40  robert

	* From Jason Beverage, "It looks like the Callback header got
	  accidentally removed from the CMakeLists.txt in the submission
	  yesterday for the geometry instancing example."

2014-11-26 19:05  robert

	* Windows build fix

2014-11-26 17:08  robert

	* Fixed warnings

2014-11-26 17:04  robert

	* Fixed warnings

2014-11-26 16:29  robert

	* Fixed deprecated warnings

2014-11-26 16:15  robert

	* Fixed warning

2014-11-26 16:04  robert

	* Fixed warnings.

2014-11-26 16:00  robert

	* Fixed warning

2014-11-26 15:59  robert

	* Fixed warning

2014-11-26 14:06  robert

	* Added osgTerrain::DisplacementMappingTechnique serializer

2014-11-26 14:04  robert

	* Renamed ShaderTerrain to DisplacementMappingTechnique and moved
	  it from the osgterrain example testbed into the osgTerrain
	  NodeKit

2014-11-26 13:36  robert

	* Moved osgTerrain::GeometryPool from osgterrain example into
	  osgTerrain NodeKit

2014-11-25 14:37  robert

	* Removed GL header as it's already included via the
	  ${OPENSCENEGRAPH_OPENGL_HEADER} entry.

2014-11-25 10:58  robert

	* From PawelKsiezopolski, "This submission contains a new example
	  for OSG : a geometry instancing rendering
	  algorithm consisting of two consequent phases :
	  
	  - first phase is a GLSL shader performing object culling and LOD
	  picking ( a culling shader ).
	  Every culled object is represented as GL_POINT in the input
	  osg::Geometry.
	  The output of the culling shader is a set of object LODs that
	  need to be rendered.
	  The output is stored in texture buffer objects. No pixel is drawn
	  to the screen
	  because GL_RASTERIZER_DISCARD mode is used.
	  
	  - second phase draws osg::Geometry containing merged LODs using
	  glDrawArraysIndirect()
	  function. Information about quantity of instances to render, its
	  positions and other
	  parameters is sourced from texture buffer objects filled in the
	  first phase.
	  
	  The example uses various OpenGL 4.2 features such as texture
	  buffer objects,
	  atomic counters, image units and functions defined in
	  GL_ARB_shader_image_load_store
	  extension to achieve its goal and thus will not work on graphic
	  cards with older OpenGL
	  versions.
	  
	  The example was tested on Linux and Windows with NVidia 570 and
	  580 cards.
	  The tests on AMD cards were not conducted ( due to lack of it ).
	  The tests were performed using OSG revision 14088.
	  
	  The main advantages of this rendering method :
	  - instanced rendering capable of drawing thousands of different
	  objects with
	  almost no CPU intervention ( cull and draw times are close to 0
	  ms ).
	  - input objects may be sourced from any OSG graph ( for example -
	  information about
	  object points may be stored in a PagedLOD graph. This way we may
	  cover the whole
	  countries with trees, buildings and other objects ).
	  Furthermore if we create osgDB plugins that generate data on the
	  fly, we may
	  generate information for every grass blade for that country.
	  - every object may have its own parameters and thus may be
	  distinct from other objects
	  of the same type.
	  - relatively low memory footprint ( single object information is
	  stored in a few
	  vertex attributes ).
	  - no GPU->CPU roundtrip typical for such methods ( method uses
	  atomic counters
	  and glDrawArraysIndirect() function instead of OpenGL queries.
	  This way
	  information about quantity of rendered objects never goes back to
	  CPU.
	  The typical GPU->CPU roundtrip cost is about 2 ms ).
	  - this example also shows how to render dynamic objects ( objects
	  that may change
	  its position ) with moving parts ( like car wheels or airplane
	  propellers ) .
	  The obvious extension to that dynamic method would be the
	  animated crowd rendering.
	  - rendered objects may be easily replaced ( there is no need to
	  process the whole
	  OSG graphs, because these graphs store only positional
	  information ).
	  
	  The main disadvantages of a method :
	  - the maximum quantity of objects to render must be known
	  beforehand
	  ( because texture buffer objects holding data between phases have
	  constant size ).
	  - OSG statistics are flawed ( they don't know anymore how many
	  objects are drawn ).
	  - osgUtil::Intersection does not work
	  
	  Example application may be used to make some performance tests,
	  so below you
	  will find some extended parameter description :
	  --skip-dynamic - skip rendering of dynamic objects if you only
	  want to
	  observe static object statistics
	  --skip-static - the same for static objects
	  --dynamic-area-size - size of the area for dynamic rendering.
	  Default = 1000 meters
	  ( square 1000m x 1000m ). Along with density defines
	  how many dynamic objects is there in the example.
	  --static-area-size - the same for static objects. Default = 2000
	  meters
	  ( square 2000m x 2000m ).
	  
	  Example application defines some parameters (density, LOD ranges,
	  object's triangle count).
	  You may manipulate its values using below described modifiers:
	  --density-modifier - density modifier in percent. Default = 100%.
	  Density ( along with LOD ranges ) defines maximum
	  quantity of rendered objects. registerType() function
	  accepts maximum density ( in objects per square kilometer )
	  as its parameter.
	  --lod-modifier - defines the LOD ranges. Default = 100%.
	  --triangle-modifier - defines the number of triangles in finally
	  rendered objects.
	  Default = 100 %.
	  --instances-per-cell - for static rendering the application
	  builds OSG graph using
	  InstanceCell class ( this class is a modified version of Cell
	  class
	  from osgforest example - it builds simple quadtree from a list
	  of static instances ). This parameter defines maximum number
	  of instances in a single osg::Group in quadtree.
	  If, for example, you modify it to value=100, you will see
	  really big cull time in OSG statistics ( because resulting
	  tree generated by InstanceCell will be very deep ).
	  Default value = 4096 .
	  --export-objects - write object geometries and quadtree of
	  instances to osgt files
	  for later analysis.
	  --use-multi-draw - use glMultiDrawArraysIndirect() instead of
	  glDrawArraysIndirect() in a
	  draw shader. Thanks to this we may render all ( different )
	  objects
	  using only one draw call. Requires OpenGL version 4.3 and some
	  more
	  work from me, because now it does not work ( probably I
	  implemented
	  it wrong, or Windows NVidia driver has errors, because it hangs
	  the apllication at the moment ).
	  
	  This application is inspired by Daniel Rákos work : "GPU based
	  dynamic geometry LOD" that
	  may be found under this address :
	  http://rastergrid.com/blog/2010/10/gpu-based-dynamic-geometry-lod/
	  There are however some differences :
	  - Daniel Rákos uses GL queries to count objects to render, while
	  this example
	  uses atomic counters ( no GPU->CPU roundtrip )
	  - this example does not use transform feedback buffers to store
	  intermediate data
	  ( it uses texture buffer objects instead ).
	  - I use only the vertex shader to cull objects, whereas Daniel
	  Rákos uses vertex shader
	  and geometry shader ( because only geometry shader can send more
	  than one primitive
	  to transform feedback buffers ).
	  - objects in the example are drawn using glDrawArraysIndirect()
	  function,
	  instead of glDrawElementsInstanced().
	  
	  Finally there are some things to consider/discuss :
	  - the whole algorithm exploits nice OpenGL feature that any GL
	  buffer
	  may be bound as any type of buffer ( in our example a buffer is
	  once bound
	  as a texture buffer object, and later is bound as
	  GL_DRAW_INDIRECT_BUFFER ).
	  osg::TextureBuffer class has one handy method to do that trick (
	  bindBufferAs() ),
	  and new primitive sets use osg::TextureBuffer as input.
	  For now I added new primitive sets to example (
	  DrawArraysIndirect and
	  MultiDrawArraysIndirect defined in
	  examples/osggpucull/DrawIndirectPrimitiveSet.h ),
	  but if Robert will accept its current implementations ( I mean -
	  primitive
	  sets that have osg::TextureBuffer in constructor ), I may add it
	  to
	  osg/include/PrimitiveSet header.
	  - I used BufferTemplate class writen and published by Aurelien in
	  submission forum
	  some time ago. For some reason this class never got into
	  osg/include, but is
	  really needed during creation of UBOs, TBOs, and possibly SSBOs
	  in the future.
	  I added std::vector specialization to that template class.
	  - I needed to create similar osg::Geometries with variable number
	  of vertices
	  ( to create different LODs in my example ). For this reason I've
	  written
	  some code allowing me to create osg::Geometries from osg::Shape
	  descendants.
	  This code may be found in ShapeToGeometry.* files. Examples of
	  use are in
	  osggpucull.cpp . The question is : should this code stay in
	  example, or should
	  it be moved to osgUtil ?
	  - this remark is important for NVidia cards on Linux and Windows
	  : if
	  you have "Sync to VBlank" turned ON in nvidia-settings and you
	  want to see
	  real GPU times in OSG statistics window, you must set the power
	  management
	  settings to "Prefer maximum performance", because when "Adaptive
	  mode" is used,
	  the graphic card's clock may be slowed down by the driver during
	  program execution
	  ( On Linux when OpenGL application starts in adaptive mode, clock
	  should work
	  as fast as possible, but after one minute of program execution,
	  the clock slows down ).
	  This happens when GPU time in OSG statistics window is shorter
	  than 3 ms.
	  "

2014-11-25 10:33  robert

	* Removed DrawArrays optimization to simplify the code and open the
	  door to adding primitive combining.

2014-11-25 10:11  robert

	* Commented out State::setUpVertexAttribAlias(..) debug message.

2014-11-24 15:19  robert

	* From Jan Klimke, "i noticed, that there are a couple of
	  additional flaws when building osg for Mac OS X 10.10 Yosemite.
	  
	  The mac os sdk version is recognized by the current CMAKE script
	  as 10.1 instead of 10.10 since it cuts the version string from
	  the 4th place. I introduced a more reliable version checking
	  based on splitting the returned version code into MAJOR MINOR and
	  PATCH parts and reassemble the OSG sdk version afterwards.
	  
	  I replaced the existing CMake code against the following
	  (returning now version 10.10 as expected):
	  
	  # Determine the canonical name of the selected Platform SDK
	  EXECUTE_PROCESS(COMMAND "/usr/bin/sw_vers" "-productVersion"
	  OUTPUT_VARIABLE OSG_OSX_SDK_NAME
	  OUTPUT_STRIP_TRAILING_WHITESPACE)
	  STRING(REPLACE "." ";" MACOS_VERSION_LIST ${OSG_OSX_SDK_NAME})
	  LIST(GET MACOS_VERSION_LIST 0 MACOS_VERSION_MAJOR)
	  LIST(GET MACOS_VERSION_LIST 1 MACOS_VERSION_MINOR)
	  LIST(GET MACOS_VERSION_LIST 2 MACOS_VERSION_PATCH)
	  
	  SET(OSG_OSX_SDK_NAME
	  "macosx${MACOS_VERSION_MAJOR}.${MACOS_VERSION_MINOR}")
	  
	  Also i added the check for the new Version to some more find
	  scripts.
	  
	  Additionally the nil object in Objective C now seems to be
	  equivalent with a null_ptr that cannot be passed as GLInt
	  anymore. So i switched this in the PixelBufferCocoa.mm to pass a
	  zero instead of nil.
	  "

2014-11-24 14:54  robert

	* Added VertexAttribDivisor class to wrap up glVertexAttribDivisor
	  function

2014-11-24 14:09  robert

	* Fixed osgsimplegl3 example's set up of the main camera.

2014-11-24 14:01  robert

	* Added numTextureUnits parameter to the
	  osg::State::resetVertexAttributeAlias(bool, unit) method, and set
	  the default to 8.

2014-11-21 20:16  robert

	* From Alberto Luaces,"the current code uses the preprocessor for
	  generating the plugin path in
	  a way that when CMAKE_INSTALL_PREFIX contains something along the
	  lines
	  of
	  
	  /usr/x86_64-linux-gnu/
	  
	  it gets substituted as
	  
	  /usr/x86_64-1-gnu/
	  
	  that is, the string is preprocessed again, thereby making changes
	  to
	  anything that matches any defined symbol, as "linux" in this
	  example
	  (https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=763816).
	  
	  Quoting that path directly in CMake scripts solves that problem.
	  "

2014-11-21 20:15  robert

	* Added comment clarifying how Image::getColor(..) out of 0..1
	  range texcoords are handled - now clamped to edge.

2014-11-21 17:22  robert

	* Implemented a clamp to edge policy for the
	  Image::g/setColor(color, texcoord).

2014-11-21 17:17  robert

	* Added testing for Drawables in the CopyOp::operator(Node*) to
	  replicate the old functionality.

2014-11-21 16:27  robert

	* From Sebastian Messerschmidt, "Added setColor function to modify
	  an image based on texture coordinates, parallel to the getColor
	  functionality."

2014-11-21 14:46  robert

	* Added --db-affinit cpuNum option to osgterrain example to
	  illustrate how to set the thead affinity of the DatabasePager
	  threads.

2014-11-21 10:44  robert

	* From Sebastian Messerschmidt, "Attached you find a change adding
	  a getNumSamples() function to retrieve the value set via
	  setNumSamples."

2014-11-21 10:37  robert

	* From Rafa Gaitan, "I finally had some time to change the build
	  system for Android using a Toolchain, which, I think, will be
	  easier to maintain and uses cmake standard system to build it.
	  
	  My changes:
	  -------------------
	  - I changed the cmake files and added a toolchain for building
	  OSG in Android. The toolchain is based on the one used at OpenCV.
	  For building OSG for android you just need to do:
	  
	  mkdir build_android_static_gles2 && cd build_android_static_gles2
	  cmake .. -DANDROID_NDK=<path-to-the-android-ndk>
	  -DCMAKE_TOOLCHAIN_FILE=../PlatformSpecifics/Android/android.toolchain.cmake
	  -DOPENGL_PROFILE="GLES2"
	  -DDYNAMIC_OPENTHREADS=OFF
	  -DDYNAMIC_OPENSCENEGRAPH=OFF
	  -DANDROID_NATIVE_API_LEVEL=15 # optional
	  -DANDROID_ABI=armeabim #optional
	  -DCMAKE_INSTALL_PREFIX=<path-to-the-install-path> #optional
	  make -j 8
	  make install
	  
	  The OPENGL_PROFILE works as expected, changing it to "GLES1" it
	  builds and links OSG using GLES1.
	  The DYNAMIC_OPENTHREADS/DYNAMIC_OPENSCENEGRAPH parameters also
	  allows to build the dynamic libraries
	  
	  - I also added some build fixes for android related to the
	  texture formats and added some missing USE_OSG_SERIALIZER_WRAPPER
	  in the osg serializer library to support loading osgb files in
	  static."

2014-11-21 10:21  robert

	* From Björn Blissing, fix for ambiguous defines in Atomic.cpp when
	  compiling with MinGW and GCC

2014-11-20 17:37  robert

	* From Claus Steuer, "XCode 6, IOs 8.1 SDK Compile fix : There are
	  some undefined texture formats when compiling osg for IOs 8.1
	  with XCode 6 and OpenGLES2 enabled."

2014-11-20 17:00  robert

	* From Pjotr Svetachov, "I was experimenting with VBO's to try to
	  get them on par with display
	  lists when drawing lots of batches and noticed that my program
	  generated a lot of unneeded glClientActiveTexture calls. Digging
	  deeper I found out it came from State::disableTexCoordPointer
	  where
	  the function would call glClientActiveTexture but not
	  glDisableClientState because the geometry didn't have texture
	  coordinates for that channel. This is because in our scene there
	  are
	  some geometries that have move than one uv channels making
	  State::_texCoordArrayList grow. Then the method
	  State::applyDisablingOfVertexAttributes() will call
	  disableTexCoordPointer multiple times.
	  
	  I rearrange the method a little to combat this. Now the logic has
	  the
	  same ordering as disableTexCoordPointersAboveAndIncluding which
	  already combats this."

2014-11-20 16:38  robert

	* From Farshid Lashkari, "The obj loader was overriding the
	  existing database path list with the file path of the model,
	  instead of prepending the file path to the path list. The latter
	  seems to be more common behavior for most of the existing loader
	  plugins. Also, the local options weren't actually being used when
	  processing the scene graph for textures. I've attached the fix
	  for both issues."

2014-11-20 10:52  robert

	* From Marc Helbling, "here is a trivial fix in the Inventor
	  plugin. In one code path, the pointer validity is checked after
	  dereferencing a pointer that can be null (image->valid()) instead
	  of calling ref_ptr::valid (image.valid())."

2014-11-20 10:45  robert

	* From Marc Helbling, "I've come across scenes that contains
	  geometries with initialized but empty vertex arrays and
	  primitives and that would make some optimizers crash.
	  
	  The submission therefore only contains a test on the size of the
	  vertex array for the VertexCacheMissVisitor and the
	  VertexAccessOrderVisitor visitors."

2014-11-20 10:05  robert

	* From Christian Ruzicka, "while testing this commit on our OSG 3.2
	  version, I observed that the changes for ETC2 brake ETC1 support.
	  Attached you'll find the changes to get ETC1 running again"

2014-11-20 09:55  robert

	* From Sukender, "Fix for 3DS reader, which may read wrong
	  triangles. Actually, indices may suffer a 'short int' overflow,
	  in two places."

2014-11-20 09:41  robert

	* Fixed segfalt in Texture2DArray copy constructor where it would
	  apply images to an uninitialzed vector.

2014-11-20 09:32  robert

	* From Marc Helbling, "patch adding support for ambient material in
	  the FBX plugin. It's a straightfoward adaptation of the emissive
	  support and has been tested on a proprietary model."

2014-11-20 09:21  robert

	* From Pjotr Svetachov, fix for build breakage with giflib 5.0.

2014-11-20 08:26  robert

	* From Per Nordqvist, "The README.txt is still somewhat confusing
	  so I have updated it"

2014-11-19 17:45  robert

	* Removed configure script as it's no longer required as cmake .
	  will now default to Release

2014-11-19 17:42  robert

	* Added CMake script to set the default CMAKE_BUILD_TYPE to
	  Release. Approach taken from simgear.

2014-11-19 17:29  robert

	* Fixed Contributors names

2014-11-19 17:10  robert

	* From Clement Boesch, "Fix remaining bit of Giflib5 usage"

2014-11-19 11:37  robert

	* From Laurens Voerman, "I found a new way to crach the osgviewer:
	  osgviewer "ProxyNode { FileNameList { cow.osgt } num_children 1
	  }".osgs
	  
	  The proxy node reader wrongly assumes options to be non NULL.
	  
	  fixed in attached zip:
	  src\osgWrappers\deprecated-dotosg\osg\ProxyNode.cpp
	  
	  applies to both the 3.2 branch and svn trunk"

2014-11-19 11:30  robert

	* From Wang Rui, "The submission includes some fixes for osgQt
	  library and osgQtWidgets example: (1) QTextEdit now works with
	  mouse/drag events, (2) scrollbars will change when OSG window is
	  resizing, (3) improve rendering efficiency of
	  QGraphicsViewAdapter so that it works with complex Qt UI, (4) add
	  new setBackgroundWidget() method to indicate a 'background
	  widget', which will ignore mouse/key events on it and pass them
	  to the 3D scene."

2014-11-19 10:43  robert

	* Changed the way that the cell size is passed to the shader

2014-11-19 09:33  robert

	* From James Turner, "Converting the loops to forward versions
	  fixed the issue. The problem is size_t is unsigned; at the limit
	  condition it doesn’t go negative but wraps around to
	  0xffffffffffffffff …. and boom."

2014-11-17 15:43  robert

	* Fixed typo

2014-11-17 09:19  robert

	* Fixed typo in comment

2014-11-14 17:44  robert

	* Added use of GL_TRIANGLE_STRIP to cut down the size of the
	  primitive indices required.

2014-11-14 16:47  robert

	* Implemented skirt functionality

2014-11-13 09:40  robert

	* Refactored the handling of use of the osgDB::ObjectCache in the
	  DatabasePager to use a local thread specific ObjectCache to
	  handle new additions and
	  then have these additions merged with the main Registry
	  ObjectCache during the main loop.

2014-11-11 18:28  robert

	* Moved implementation of ObjectCache functionality out of Registry
	  into a dedicated osgDB::ObjectCache class.

2014-11-10 16:04  robert

	* To handle thread safe paging and use of the osgDB::Registry
	  ObjectCache, moved the handling of cache into
	  osgDB::DatabasePager.

2014-11-06 10:44  robert

	* From Pjotr Svetachov, "I tried your fix and it exposed a bug in
	  my fix :)
	  The problem is that the readObjectFields method will add the
	  object to the _identifierMap. So all the other instances of that
	  image in the same file will be replaced by the created dummy
	  object. In my fix this was an dummy image and I didn't notice it
	  in our scene's, probably because it covered a small part of an
	  object. In your fix the dummy object was not an image and that
	  leads to a crash when something tries to use it as an image. I
	  have attached a small fix for this bug.
	  
	  "

2014-11-06 10:40  robert

	* Introduced use of MarkerObject to
	  IncrmentalCompileOperation/DatabasePager as a way of marking
	  objects that have already been processed and compiled,
	  thus avoid potential threading conflicts when paged subgraphs are
	  reused.

2014-11-05 16:08  robert

	* Added handling of the reading of field properties to a dummy
	  object for cached images to avoid threading issues associated
	  with reusing and modifying an active object.

2014-11-05 13:38  robert

	* Reinstated the original mechanism for OperationThread::cancel()
	  that co-operatively releases blocks/barriers to make sure the
	  thread is able to exit correctly.

2014-11-04 20:07  robert

	* Improvements to the ShaderTerrain experiemental terrain rendering
	  technique.

2014-11-04 20:07  robert

	* Changed TerrainTile::setDirty() to use children needing update
	  traversal mechanism to address threadng issues.

2014-11-04 20:06  robert

	* Change isRunning variable to an Atomic to address possible race
	  condition asscoiated with reading and writing to the variable
	  from different threads.

2014-11-04 16:29  robert

	* Build fixes for ffmpeg LIBAVCODEC_VERSION_MAJOR >= 56

2014-11-04 11:18  robert

	* Added an InitRegistry static intiialization and destrucion static
	  to help control the order of construction and destruction of the
	  osgDB::Registry.

2014-11-04 10:46  robert

	* Replaced use of while(isRunning()) { YieldCurrentThread(); }
	  style loops with use of join() to avoid false positives being
	  reported by valgrind when using the helgrind tool for thread
	  debugging.

2014-10-21 15:08  robert

	* Added experimental osgTerrain::ShaderTerrain TerrainTechnique to
	  osgterrain example to flesh out new shader based displacement
	  mapping approach to osgTerrain databases.
	  
	  Requires shader files place in OpenSceneGraph-Data/shaders from
	  OpenSceneGraph-Data's svn/trunk to function.
	  
	  Run osgterrain example with --shader command line option to
	  select displacement mapping shader approach.

2014-10-21 14:47  robert

	* Removed --sync related code as it's now integrated into
	  osg::DisplaySettings and osgViewer

2014-10-21 14:46  robert

	* Added osg::SyncSwapBuffersCallback to include/osg/GraphicsContext
	  and support for enabling it to include/osg/DisplaySettings, and
	  to the Viewer/CompositeViewer::realize() methods.
	  
	  To enable the sync of swap buffers set the env var
	  OSG_SYNC_SWAP_BUFFERS to ON or 1, to switch off set to OFF or 0.
	  
	  One can also use the --sync command line option for application
	  that pass on command line options to the
	  osg::DisplaySettings::instance().

2014-10-21 08:27  robert

	* Removed checks against Drawable as these are no longer required.

2014-09-17 17:40  robert

	* Added support for writing the file path of a script to the lua
	  package.path to help with loading scripts within lua.

2014-09-16 17:40  robert

	* Changed osgvolume example to use the new tf plugin rather than
	  having local code for reading transfer function

2014-09-16 11:00  robert

	* Added write support

2014-09-15 17:53  robert

	* Added .tf & .tf-255 plugin for reading ascii 1D transfer functon
	  files in support for volume rendering.

2014-09-12 14:16  robert

	* Added basic frame rendering for TabWidget

2014-09-10 17:03  robert

	* Improved the alignment and sizing of TabWidget tab headers

2014-09-10 11:59  robert

	* Implemented the selection of tabs by clicking, using mouse wheel
	  or arrow keys.

2014-09-09 16:12  robert

	* Improved the handling of the dialog title text

2014-09-09 15:14  robert

	* Moved the diaglog title bar widgets into the
	  Widget::GraphicsSubgraph map to avoid them poluting the Dialog's
	  children list and to prevent them from being serialized.

2014-09-09 13:37  robert

	* Introduced Widget::WidgetStateSet to help localize the StateSet
	  set up by Widget implementations from being serialized or
	  affecting what end users apply via the standard
	  Node::s/getStateSet().
	  
	  Further work on TabWidget.

2014-09-08 08:53  robert

	* Build fix

2014-09-05 16:04  robert

	* Added shell of new osgUI::TabWidget class

2014-09-05 11:05  robert

	* Introduced support for specifying whether a serializer supports
	  different types of usage - one or more of READ_WRITE_PROPERTY,
	  GET_PROPERTY and SET_PROPERTY.

2014-09-03 15:54  robert

	* Added setting of the IsoSurfaceProperty in VolumeSettings

2014-09-03 12:28  robert

	* Added close button on Dialog title bar

2014-09-02 17:01  robert

	* Refactored the handling of ComboBox item picking to make it
	  faster and more reliable

2014-09-02 10:00  robert

	* Improved handling of ComboBox popup toggling

2014-09-02 09:14  robert

	* Added support for scaling widgets via the scoll wheel.

2014-09-02 08:41  robert

	* Removed debugging message

2014-09-01 19:13  robert

	* Added DragCallback class to help dialog dragging support.
	  Introduced a new
	  Widget::computeExtentsPositionInLocalCoordinates() method that
	  intersects with a ray through mouse pointer and the extents of
	  the widget.

2014-08-28 15:11  robert

	* Improved support for controlling the ShadingModel via the
	  VolumeSettings object

2014-08-28 09:42  robert

	* Improved handling of VolumeSettings

2014-08-27 15:08  robert

	* Changed the osgUI behaviour so that events are set to be handled
	  by Widgets that have focus even if they don't directly use them.

2014-08-27 15:07  robert

	* Changed the NodeVisitor::apply(Drawable&) to call apply(Node&)

2014-08-27 09:25  robert

	* Added support for getting osgVolumre::Property::ModifieCount

2014-08-25 16:56  robert

	* Added Property::getModifiedCount() + dirty() to help with
	  tracking changes. Added VolumeSettings serializers for Property
	  objects

2014-08-25 13:43  robert

	* Changed StateSet::ParentList from vector<Object*> to
	  vector<Node*> to reflect that Drawable is now a Node.

2014-08-22 19:00  robert

	* Improved handling of setting of the depth of the UI.

2014-08-20 14:15  robert

	* Reordered method implemenations to make it easier to compare
	  similar methods

2014-08-19 16:58  robert

	* Added toggling on/off of the VolumeSettings ui via the 'E' key.

2014-08-19 16:37  robert

	* Updated VolumeSettings.lua reference to use ui prefix to work
	  with the new OpenSceneGraph-Data/ui/VolumeSettings.lua file.

2014-08-19 09:27  robert

	* Fixed MD2 danglng pointer crash.

2014-08-19 09:00  robert

	* Fixed build

2014-08-19 08:57  robert

	* Fixed build

2014-08-14 19:00  robert

	* Added support for ComboBox::currentIndexChanged*(uint) callback
	  API.

2014-08-13 09:24  robert

	* Resert default value to 1.0

2014-08-08 16:42  robert

	* From Ryan Kawicki, "There is an issue where the model insets of a
	  terrex terrain are being removed during the loading process. The
	  issue is described below.
	  
	  - the issue here is that the plugin is removing group nodes if
	  that group node only has one child. becuase transforms are also
	  group nodes, there were cases when the transform would have only
	  one child under it and would cause it to remove the translation
	  portion. this would cause all the vertex data to be loaded around
	  the last matrix operation, which in our case was the origin
	  (0,0,0).
	  
	  We work off of OSG 2.8.1 but see that this has not been addressed
	  on latest yet. I’ve tested this against 2.8.1 and have cleanly
	  applied it to my local repository off of latest."

2014-08-08 16:34  robert

	* From Tim George, "Currently there is a problem with using a
	  camera with a viewport with a non 0 offset and also using an FBO.
	  The problem is that only area made up of the viewports width and
	  height is drawn based on an offset of 0,0 instead of using the
	  viewports offset.
	  
	  It is caused by line 991 in RenderStage.cpp:
	  
	  
	  Code:
	  fbo_ext->glBlitFramebuffer(
	  0, 0, static_cast<GLint>(_viewport->width()),
	  static_cast<GLint>(_viewport->height()),
	  0, 0, static_cast<GLint>(_viewport->width()),
	  static_cast<GLint>(_viewport->height()),
	  blitMask, GL_NEAREST);
	  
	  
	  
	  which is not taking into account the viewport x and y when
	  performing the blit. It probably should be:
	  
	  
	  Code:
	  fbo_ext->glBlitFramebuffer(
	  static_cast<GLint>(_viewport->x()),
	  static_cast<GLint>(_viewport->y()),
	  static_cast<GLint>(_viewport->width()) +
	  static_cast<GLint>(_viewport->x()),
	  static_cast<GLint>(_viewport->height()) +
	  static_cast<GLint>(_viewport->y()),
	  static_cast<GLint>(_viewport->x()),
	  static_cast<GLint>(_viewport->y()),
	  static_cast<GLint>(_viewport->width()) +
	  static_cast<GLint>(_viewport->x()),
	  static_cast<GLint>(_viewport->height()) +
	  static_cast<GLint>(_viewport->y()),
	  blitMask, GL_NEAREST);
	  "
	  
	  Note from Robert Osfield, made small tweak to above on merge,
	  changing the width+x to x+width to make it read more naturally.

2014-08-08 16:09  robert

	* From Marc Helbling, "please find a fix for the vertex
	  pretransform visitor (VertexAccessOrderVisitor).
	  The issue with current code is that arrays are collected *before*
	  duplicating shared arrays which leads to arrays that are
	  correctly duplicated but that are not reordered.
	  
	  Also the submitted patch contains a small cleaning in
	  GeometryArrayGathrer as the _useDrawElements variable is not
	  used; it is only set in the GeometryArrayGathrer constructor and
	  VertexAccessOrderVisitor already checks that primitives have
	  indexed type."

2014-08-08 15:45  robert

	* From Glen Waldron, "Node: patch for remove*Callback() methods to
	  resolve a crash"

2014-08-08 09:28  robert

	* Changes to support building against ANDROID under OSX.

2014-08-05 18:32  robert

	* Implemented osgUI::Validator, IntValidator and DoubleValidator
	  classes that manage validation/specialization of LineEdit widgets
	  to work with just integer or double values.

2014-08-01 13:07  robert

	* Implemented callbacks for validate(), textChanged() and
	  returnPressed()

2014-08-01 10:57  robert

	* Moved responsiblity for checking current event focus onto
	  Widget::handleImplementations().
	  
	  Added support for closing CombinBox popup when the mouse is
	  clicked outside the popup or combobox widget.

2014-07-31 18:29  robert

	* Added NodeVisitor::INTERSECTION_VISITOR VisitorType

2014-07-30 12:48  robert

	* Fixed rendering of Popups

2014-07-30 12:47  robert

	* Update SO version to account for new changes to osg::StateSet and
	  osgUI

2014-07-30 12:47  robert

	* Added StateSet::RenderBinMode::PROTECTED_RENDERBIN_DETAILS and
	  OVERRIDE_PROTECTED_RENDERBIN_DETAILS options.

2014-07-29 15:50  robert

	* Added preliminary icon to ComboBox.

2014-07-29 15:50  robert

	* Fixed debug comment

2014-07-29 15:50  robert

	* Implemented prelimary icon support allowing UI widget to place
	  image and model based icons on widgets

2014-07-29 15:47  robert

	* Added catch for NULL Transform pointers getting into the
	  _transformMap.

2014-07-28 16:19  robert

	* Added handling of Drawables added directly to scene graph without
	  Geode decorating them.

2014-07-24 14:14  robert

	* Added support for changing background colour of LineEdit widget
	  when focus changes

2014-07-24 13:25  robert

	* Refined the colouring of widget to be more in sync with the
	  defaults used in Qt.

2014-07-23 16:36  robert

	* Added VolumeSettings::Filename property.

2014-07-23 15:57  robert

	* Changed the default text colour to black

2014-07-23 14:50  robert

	* Added writeFile support

2014-07-23 10:49  robert

	* Added Node:getNumParents() and Node:getParent(index) support

2014-07-22 16:02  robert

	* Removed State::AppliedProgramObjectSet container and Obsever
	  usage from osg::State to address threading bug crash.
	  
	  The State::AppliedProgramObjectSet wasn't ever being used
	  actively in the current rev of the OSG so populating and clearing
	  was no longer neccessary, allowing the code to be removed
	  completely.

2014-07-21 16:36  robert

	* Centralized the calling of #include <stdint.h> and VS fallback
	  into include/osg/Types header

2014-07-21 14:32  robert

	* From Pjotr Svetachov, "I think I spotted some unneeded ref_ptrs
	  in the cullvisitor. The call
	  pushModelViewMatrix or pushProjectionMatrix will already keep the
	  reference when adding it to the MatrixStack. In
	  CullVisitor::apply
	  methods for the billboard and the camera you already take a
	  pointer
	  instead of a ref_ptr."

2014-07-21 13:45  robert

	* Added setting of glPixelStore before glTexSubImage2D call.

2014-07-21 13:43  robert

	* From Jaap Gas, "I want to submit a bugfix for a crash occurring
	  in osgText/Glyph.cpp if
	  the scene tree contains (large) 2D textures from images with
	  STRIDE.
	  
	  ============================================================================
	  #0 0x00007fffe8ea4350 in __memmove_ssse3 () from /lib64/libc.so.6
	  #1 0x00007fffe52ced76 in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #2 0x00007fffe52d8e86 in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #3 0x00007fffe53dd8be in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #4 0x00007fffe53c2643 in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #5 0x00007fffe53c7fdd in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #6 0x00007fffe53cbabf in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #7 0x00007fffe53cc1fa in ?? () from
	  /usr/lib64/libnvidia-glcore.so.310.44
	  #8 0x00007ffff30092fd in osgText::GlyphTexture::apply
	  (this=0x1bb8cf0, state=
	  ...)
	  at
	  /d43/jaap/dev/jaapOSG/build/OpenSceneGraph3.3.1/src/osgText/Glyph.cpp:234
	  #9 0x00007ffff56c30b6 in osg::State::applyAttributeOnTexUnit
	  (this=0x125f180,
	  unit=0, attribute=0x1bb8cf0, as=...)
	  at
	  /d43/jaap/dev/jaapOSG/build/OpenSceneGraph3.3.1/include/osg/State:1713
	  #10 0x00007ffff56c2f3f in osg::State::applyTextureAttribute
	  (this=0x125f180,
	  unit=0, attribute=0x1bb8cf0)
	  at
	  /d43/jaap/dev/jaapOSG/build/OpenSceneGraph3.3.1/include/osg/State:411
	  #11 0x00007ffff30204da in osgText::Text::drawTextWithBackdrop
	  (this=0x1baed70,
	  state=..., colorMultiplier=...)
	  ==============================================================================
	  
	  The crash disappears if I either (1) disable the use of images
	  with stride
	  in the (public) osgGeo-library, or (2) add the following bugfix
	  to Glyph.cpp.
	  This combination gives me the confidence that I understand where
	  this problem
	  originates from, without trying to understand the full OpenGL
	  details.
	  
	  ===============================================================================
	  @@ -221,7 +223,12 @@
	  imageData[i] = 0;
	  }
	  
	  + glPixelStorei(GL_UNPACK_ALIGNMENT,1);
	  
	  + #if !defined(OSG_GLES1_AVAILABLE) &&
	  !defined(OSG_GLES2_AVAILABLE)
	  + glPixelStorei(GL_UNPACK_ROW_LENGTH,getTextureWidth());
	  + #endif
	  +
	  // allocate the texture memory.
	  glTexImage2D( GL_TEXTURE_2D, 0, GL_ALPHA,
	  getTextureWidth(), getTextureHeight(), 0,
	  ================================================================================
	  
	  I have copied (and adapted) the added lines above from the same
	  source file,
	  where they were used in front of a similar call to
	  glTexSubImage2D(.) around
	  line 515.
	  "

2014-07-21 12:21  robert

	* Initial work on integtasting osgUI into Present3D

2014-07-21 12:18  robert

	* Fixed indentation

2014-07-21 09:35  robert

	* Added debug messages

2014-07-18 17:17  robert

	* Added serailizer support for NodeVisitor, UpdateVisitor,
	  CullVisitor and EventVisitor

2014-07-14 15:59  robert

	* Added readScript/writeScript methods to ReaderWriter

2014-07-14 14:09  robert

	* Renamed osgDB::PropertyInterface to osgDB::ClassInterface to
	  better reflect it's functionality

2014-07-04 16:45  robert

	* Added preliminary support for writing VolumeSettings to disk from
	  within Present3D in response to pressing and releasing 'Ctrl-S'.

2014-07-03 16:36  robert

	* Updated iso and mip shaders from OpenSceneGraph-Data.

2014-07-03 13:06  robert

	* Added virtual destructors

2014-07-03 13:05  robert

	* Fixed line endings

2014-07-03 13:01  robert

	* Changed enum usage to use the new osgVolume::VolumeSettings
	  versions and added support for reading a VolumeSettings file.

2014-07-03 10:01  robert

	* Refactor VolumeSettings so that it's subclassed from
	  osgVolume::Property

2014-07-02 16:26  robert

	* Added osgVolume::VolumeSettings object

2014-07-02 15:34  robert

	* Changed the default image output format to .osgb as .dds isn't
	  able to represent signed byte, short and int data correctly.

2014-07-02 14:14  robert

	* fixed handlng of file type of nested files within a .osgx, .osgt
	  and .osgb file.

2014-07-02 10:25  robert

	* From Laurens Voerman, "just like ClusterCullingCallback (fixed in
	  r14322) visual studio likes an explicit implementation of run()
	  for InteractiveImageHandler.
	  
	  The warning is (14 times):
	  include\osgViewer/ViewerEventHandlers(542): warning C4250:
	  'osgViewer::InteractiveImageHandler' : inherits
	  'osgGA::EventHandler::osgGA::EventHandler::run' via dominance
	  (src\osgViewer\StatsHandler.cpp)
	  include\osgGA/EventHandler(45) : see declaration of
	  'osgGA::EventHandler::run'
	  
	  
	  attached a zipped version of
	  include\osgViewer\ViewerEventHandlers"

2014-07-01 07:31  robert

	* Added #include <stdint.h> to address compile issue on some Linux
	  distro's.

2014-06-30 15:31  robert

	* Add dds no flip on write option to prevent output of .dds volume
	  from being flipped by the dds plugin.

2014-06-30 13:24  robert

	* REmoved debug cout

2014-06-30 10:13  robert

	* From Mikhail Izmestev, "Attached fix to avoid vector reallocs on
	  push_back in StateGraph::moveStateGraph."

2014-06-30 09:12  robert

	* Updated ChangeLog and AUTHORS file

2014-06-30 08:56  robert

	* Updated version number

2014-06-30 08:46  robert

	* From Pjotr Svetachov, "Here is a small fix for a overflow when
	  editing large 3d volume data."

2014-06-30 08:20  robert

	* Removed space from #include.

2014-06-30 07:37  robert

	* From Alexander Sinditskiy, build fix to allow building against
	  versions older than librsvg-2.36.2

2014-06-28 06:22  robert

	* Replaced using NodeCallback::run with explict run()
	  implementation.

2014-06-27 15:57  robert

	* From Pjotr Svetachov, "I made a small change to
	  DataOutputStream.cpp which makes saving Geodes possible again.
	  This is only half a fix as it only will save a Drawable that is
	  part of a Geode. But this change does not require a version bump
	  of the .ive format. I tried it with a few datasets we have here
	  with the 3.2 stable branch and the trunk with this patch and
	  there was no difference in the .ive files that were produced."

2014-06-27 15:55  robert

	* Removed unused method.

2014-06-27 15:48  robert

	* From Laurens Voerman, "attached is a modified version of
	  src/osgUtil/Tessellator.cpp
	  current code checks for a Nullpointer and on notify level info or
	  above will inform you with a crash, by dereferencing it."

2014-06-27 15:39  robert

	* Updated AUTHORS file

2014-06-27 15:38  robert

	* Added an OSG_INIT_SINGLETON_PROXY to make sure that the
	  ApplicationUsage singleton gets intialized before usage.

2014-06-27 15:36  robert

	* Updated AUTHORS file

2014-06-27 15:30  robert

	* Added a render order sort to the list of Cameras being tested by
	  the *Viewer::generatePointerData(..) method to ensure that the
	  highest Camera gets focus.

2014-06-26 15:54  robert

	* Update ChangeLog for dev release

2014-06-26 14:16  robert

	* Revised KdTreeBuilder so that is used the new
	  apply(osg::Geometry&) method rather than expanding an osg::Geode.

2014-06-26 11:49  robert

	* From Sebastian Messerschmidt, "I've applied a simple fix for the
	  backward animation support in osg::Sequence.
	  It will simply use the sign of the speed set in the getNextValue.
	  Attached file is against trunk."

2014-06-26 11:11  robert

	* From Lauren Voerman, "In order to speed up loading large scenes
	  (especially from network disk) I added code to our viewer to
	  setup multiple database-pagers and request the files trough a
	  database-request:
	  databasePager->setUpThreads(16, 1);
	  
	  We experienced problems with multiple databasepagers loading
	  files in parallel, when two threads start to load the same file
	  (usually a texture referenced by multiple models). The second
	  thread to add the file to the cache (sometimes) manages to do so
	  while the refcount from the cached object still is zero, causing
	  the object loaded to be destroyed.
	  Sometimes the second thread manages to ref() the object before
	  Referenced::signalObserversAndDelete does the final recount
	  check, causing a warning:
	  "Warning Referenced::signalObserversAndDelete(,,) doing delete
	  with _refCount=1"
	  
	  With a deleted object added to the scenegraph we get some
	  undesired results, I think the program only crashes if the object
	  was a Node, and just has some untextured surfaces if it was a
	  texture, but I'm not completely sure.
	  
	  Attached is a modified version of the Registry.cpp, returning the
	  object in cache and let the duplicate loaded object to be
	  destroyed.
	  
	  A more efficient option would be to add some sort of blocking
	  entry to the objectcache to stop the second thread from reading
	  the file, and just wait until the first thread added it to the
	  cache. If you think that's worthwile we would be happy to
	  implement that version. A bit tricky to implement and test,
	  that's why I submit a simple version that stops my program from
	  crashing."

2014-06-26 11:09  robert

	* Removed erroneous character

2014-06-26 10:53  robert

	* From Farshid Lashkari,
	  "I noticed that Text3D objects would change there z alignment
	  depending on the alignment mode. I'm not sure if this was
	  intentional or just a simple mistake. My expectation was that the
	  front of the object would always stay aligned to the 0 z-plane,
	  regardless of the alignment mode. I've attached an updated
	  version that retains a consistent z-alignment."
	  "I just now noticed another issue with Text3D objects. It was not
	  properly computing the bounding box when non-axis aligned
	  rotations were being applied. In this case all corners of the
	  bounding box need to be transformed in order to get the correct
	  containing box. I've attached the updated file."
	  "The incorrect bounding box problem also applies to regular Text
	  objects. I've attached the fix for that as well as the original
	  Text3D fix."

2014-06-26 10:45  robert

	* From Pjotr Svetachov, "For a scene with a lot of animated agents
	  I did some small
	  optimizations to reduce cpu overhead:
	  1) Avoid a load-hit-store in UpdateBone.
	  b->getMatrixInBoneSpace()
	  returns the same matrix that was just stored with b->setMatrix()
	  2) Avoid calling element->isIdentity() for the whole transform
	  stack
	  (can be expensive is element is a matrix)
	  3) Make the key frame interpolator use binary search instead of a
	  linear one. This is very noticeable in scenes where some geometry
	  has
	  long repeating animations that start at the same time, you will
	  see
	  the update time grow then reset and grow again."

2014-06-26 10:24  robert

	* From Laurens Voerman, "while debugging ImageSequence I had a
	  crash, due to the very large frametimes caused by halting the
	  program. The problem is that when the frame time exceeds the
	  length of the entire image sequence, a looping sequence will try
	  to read it's _imageDataList beyond its size.
	  fix attached for src/osg/ImageSequence.cpp"

2014-06-26 10:05  robert

	* From Laurens Voerman, "while testing databasepager stuff I
	  noticed that the various loaders (osg/ive/osgx) do not pass the
	  current options to the imagePager, therefore the images cannot be
	  found if not in the global OSG_FILE_PATH. Attached is a fix,
	  containing modified versions of
	  
	  From Robert Osfield, add check to only apply Options object when
	  a valid Option object is assigned.

2014-06-26 09:38  robert

	* From Farshid Lashkari, "I've attached a small fix for the ply
	  loader to support Windows style line endings when reading the
	  header."

2014-06-26 09:33  robert

	* From Aurelien Albert, "This submission fix all my problems with
	  reading / writing "osgb" files inside "osga" archive with final
	  archive size > 2 Go, with Windows OS (didn't tested with Linux)"

2014-06-25 16:05  robert

	* From Riccardo Corsi, "there's an inconsistency between the
	  behavior of the method and the
	  debug message it prints out on the console.
	  
	  Around line 1040 of Registry.cpp (see code below) the method
	  returns
	  "simpleFileName" but prints about returning "filename".
	  
	  In attachment the modified file, based on osg 3.2.0
	  ricky
	  
	  
	  <code>
	  if(fileExists(simpleFileName))
	  {
	  OSG_DEBUG << "FindFileInPath(" << filename << "): returning " <<
	  filename << std::endl;
	  return simpleFileName;
	  }
	  </code>
	  "

2014-06-25 15:55  robert

	* From Auelien Albert, "I'm working on an application which use 3ds
	  file format as input and use the name of the material to "map"
	  specific data with 3d geometry.
	  
	  The osg 3ds plugin modify the exported materials name in the same
	  way it modifies the node names.
	  
	  I've added an option to preserve originals materials names, with
	  the assurance of unique material names are preserved."

2014-06-25 15:47  robert

	* Refactored the way that hole are pruned from the occluder hole
	  list.

2014-06-25 11:07  robert

	* From Laurens Voerman, "a minor patch for osgconv to make sure the
	  helptext is printed if you run "osgconv -h" with OSG_NOTIFY_LEVEL
	  set too low.
	  applys to both trunk and stable branch."

2014-06-25 10:45  robert

	* From Mikhail Izmestev, "Attached fix to avoid vector usage in
	  StateGraph::prune and reduce heap allocations."
	  
	  Notes from Robert Osfield, ammended the erase so that it
	  explictly increments the iterator before the erase call.

2014-06-25 09:58  robert

	* changed debug message to use OSG_DEBUG

2014-06-25 09:57  robert

	* From Alexander Sinditskiy, "My changes added support for
	  gltexstorrage2d for texture2d.
	  
	  Initially I described issue in message:
	  http://forum.openscenegraph.org/viewtopic.php?t=13820
	  It solves issue with compiling texture using ico from image with
	  mipmaps
	  
	  I added enviroment variable OSG_GL_TEXTURE_STORAGE_ENABLE to
	  control usage of glTexStorage2d. Initially it is disabled.
	  
	  It used only if image have mipmaps.
	  
	  Another issue is converting from internalFormat + type to sized
	  internal format. I created sizedInternalFormats[] struct where
	  sized internal formats are ordered from worse->best.
	  also this struct have commented lines. Commented formats are
	  listed in
	  http://www.opengl.org/wiki/GLAPI/glTexStorage2D
	  but looks like not using in osg."
	  
	  Note from Robert Osfield. Changed the env var control to
	  OSG_GL_TEXTURE_STORAGE and made it's value true by default when
	  the feature is supported by the OpenGL driver. To disable to
	  use of glTexStorage2D use OSG_GL_TEXTURE_STORAGE="OFF" or
	  "DISABLE"

2014-06-25 08:21  robert

	* From Björn Blissing, "I found a minor error in documentation in
	  include/osg/Math.
	  Function: absolute() had the same description as the function
	  minimum()
	  
	  I removed the erroneous text."

2014-06-25 08:18  robert

	* From Björn Blissing, "Fix to support correct shininess and
	  transparency in FBX plugin"

2014-06-24 19:57  robert

	* From Pjotr Svetachov, "There were some modes missing when
	  exporting to .ogst so I added them."

2014-06-24 14:58  robert

	* From Farshid Lashkari, "I've attached a small for the osg
	  ReaderWriter. It was performing a case sensitive comparison to
	  the file extension to determine whether to write the file in
	  ascii or binary. This meant that if the filename was "model.OSGT"
	  it would be treated as binary, instead of ascii. I've updated the
	  plugin to ignore case."

2014-06-24 11:24  robert

	* Merged fix to merge geometries.

2014-06-23 12:02  robert

	* Fixed nested callback calling.

2014-06-16 16:16  robert

	* Fixed check against totaly number of vertices

2014-06-16 08:54  robert

	* From Aurelien Albert, "I've got some issues using osgb files
	  within an big osga archive (file size > 2Go).
	  
	  Issue is described here :
	  http://forum.openscenegraph.org/viewtopic.php?t=13914
	  
	  Here is a fix, using "std::streampos" standard type for stream
	  positions up to 64bits.
	  "

2014-06-13 17:17  robert

	* Added osgUI::ColorPalette class

2014-06-13 17:16  robert

	* Fixed typo in parameter name

2014-06-12 16:00  robert

	* Removed generation of scroll event on the X11 button release
	  event as X11 was generating both a pair of press/release events
	  for a single scroll when movement.

2014-06-12 15:24  robert

	* Added if () blocks to
	  State::convertVertexShaderSourceToOsgBuiltIns() to ensure that
	  only parts of the shader than need replacing are replaced.

2014-06-12 14:12  robert

	* Improved positioning of combo box popup items

2014-06-12 14:05  robert

	* Added frame support to ComboBox.
	  
	  Improved the alingment support for text

2014-06-11 16:31  robert

	* Added handling of AligmentSettings of Text layout

2014-06-11 10:55  robert

	* Implemented more robust intersection handling for mouse
	  interactions. Wired up even handling of ComboBox popup.

2014-06-10 08:50  robert

	* Added using Callback::run() method to Drawable::CullCallback

2014-06-09 13:46  robert

	* Fixed handling of Drawable callbacks and
	  NumChildrenRequiringEventTraversal

2014-06-06 15:05  robert

	* Removed redudent NodeVisitor::s/getUserData() as osg::Object
	  provide this.
	  
	  Added using run entry to InteractiveImageHandler to quieten
	  warning

2014-06-06 09:12  robert

	* Added using NodeCallback::run() to avoid warnings

2014-06-06 09:01  robert

	* Added missing OSG_EXPORT

2014-06-05 16:26  robert

	* Refactored Callback system in osg::Node, osg::Drawable,
	  osg::StateSet and osg::StateAttribute to use a new osg::Callback
	  base class.

2014-06-04 08:59  robert

	* Updated shaders from OpenSceneGraph-Data sources

2014-06-03 15:05  robert

	* From Pjotr Sventachov and Robert Osfield, added callback unit
	  test to osgcallback example, to use test run osgcallback --test,
	  if everything is functioning then test1 to test7 messages should
	  be reported to the console.

2014-06-03 09:52  robert

	* Reverted change of Node::ParentList from being a vector<Node*>
	  back to a vector<Group*>

2014-06-03 09:23  robert

	* Refactor osg::Geode to subclass from osg::Group and reuse the
	  NodeList children container

2014-06-02 16:20  robert

	* Removed OSG_USE_BOUND and associated osg::Bound adapter class to
	  avoid problems with BoundingBox::expandBy/expandByRadius()
	  implementation choosing a null BoundingBox from
	  the osg::Bound class causing crashes.

2014-06-02 08:13  robert

	* From Roni Zanolli, build fix for iPhone

2014-05-30 16:44  robert

	* Implemented basic frame graphic

2014-05-29 15:21  robert

	* Futher work on ComboBox/Popup

2014-05-29 10:51  robert

	* Added beginnings of ComboBox popup functionality.

2014-05-28 10:18  robert

	* Added cached Depth and ColorMask to reduce the amount of
	  duplicate state in the osgUI subgraph

2014-05-28 10:06  robert

	* Replaced Widget::GraphicsSubgraph with GraphicsSubgraphMap to
	  allow finer control of when the rendering subgraphs are done.

2014-05-27 14:14  robert

	* Improved handling of text

2014-05-26 16:32  robert

	* Removed Dialog/Popup::open/close() methods as they are replaced
	  by the setVisible() method

2014-05-26 16:27  robert

	* Implemented Widger::Visible and Enabled usage

2014-05-26 16:15  robert

	* Added Visible and Enalbed properties to Widget

2014-05-26 16:15  robert

	* Fixed missing initilaizer

2014-05-26 15:58  robert

	* Added item serializer

2014-05-23 18:59  robert

	* Implemented clipping of widget to the widgets extents.

2014-05-23 15:00  robert

	* Implemented scheme for making sure nested widgest overdraw parent
	  widgets graphics

2014-05-23 15:00  robert

	* Added wrappers for open and close methods

2014-05-22 10:02  robert

	* Added osgUI::Widget::set/getGraphicsSubgraph() to hold the
	  subgraph that does the rendering portion of widgets

2014-05-21 16:15  robert

	* Addd method implementation in serializers

2014-05-21 10:17  robert

	* Fixed handling of traverse

2014-05-21 09:45  robert

	* Improved handling of callback object to open the door to use of
	  general osg::CallbackObject as mechnisms for something simialr to
	  Qt's signal/slot mechanism.

2014-05-21 09:07  robert

	* Added osg::runNamedCallbackObjects(..) convinience method for run
	  all named osg::CallbackObjects attached to an osg::Object

2014-05-21 09:06  robert

	* Renamed callbacks to avoid overlap with Node callbacks

2014-05-20 16:09  robert

	* Moved the _boundingSphere set method into the update section of
	  the Drawable::getBoundingBox() method
	  
	  Added an UpdateVisitor::apply(Drawable&) implementation.

2014-05-20 15:34  robert

	* From Pjotr Svetachov, "I stumbled on a little bug with the new
	  drawables. I was distributing points data into different
	  drawables that I used in a LOD later. When simplifying the system
	  to not use geodes anymore I came upon the following bug:
	  If Drawable::getBoundingBox would compute an invalid bounding box
	  (if it was for example empty) it would make a bounding sphere
	  with a infinite radius which counts as a valid sphere in osg.
	  
	  Attached is a small fix."

2014-05-20 08:35  robert

	* Improved the handling of updating of text

2014-05-20 08:35  robert

	* Added shell of Popup class

2014-05-20 08:34  robert

	* Added check against whether an event has been handled or not
	  before actioning escape/quit.

2014-05-19 10:11  robert

	* Add shell of Dialog class

2014-05-19 09:30  robert

	* Added handling of up/down key to ComboBox

2014-05-16 19:24  robert

	* Added initial cut of ComboBox

2014-05-16 10:38  robert

	* Added initial shell of PushButton implementation

2014-05-15 16:30  robert

	* Added support for intesecting Drawable that are attached directly
	  to the scene graph without an osg::Geode

2014-05-15 14:57  robert

	* From Sebastian Messerschmidt, "There was some small error due to
	  MS non-conformity handling comments correctly."

2014-05-15 14:45  robert

	* From Pjotr Svetachov, build fixes for VisualStudio

2014-05-15 13:34  robert

	* Added osgGA dependency

2014-05-15 13:22  robert

	* Placed the #include<osg/Node> within #ifdef OSG_USE_BOUND to
	  prevent unncessary inclusion of Node header when OSG_USE_BOUND is
	  false.

2014-05-15 09:26  robert

	* Added Node::asDrawable() and Node::asGeometry() methods to
	  provide a low cost way of casting a node to Drawable and
	  Geoemtry.
	  
	  Changed the Group::computeBound() method so that it takes account
	  of the a Drawable's BoundingBox.

2014-05-14 16:52  robert

	* Fixed the bounding sphere computation and handling of Drawable as
	  the root of the scene graph

2014-05-14 16:01  robert

	* Further work on Bound class/Node::getBound() and
	  Drawable::getBound() and usage in OSG codebase

2014-05-14 16:00  robert

	* Cleaned up code

2014-05-14 10:19  robert

	* 

2014-05-13 08:43  robert

	* Changed the Node::ParentList to be a list of osg::Node rather
	  than osg::Group, and added addChild, removeChild, replaceChild
	  virtual method to Node to enable code
	  to user code compile with minimal modifications to account for
	  the new change to the Node ParentList.

2014-05-12 12:10  robert

	* From Farshid Lashkari, "As discussed, I've added the ability to
	  handle Drawable objects within the NodeVisitor class. Here is an
	  overview of the changes:
	  
	  - Added apply(Drawable) and apply(Geometry) to NodeVisitor
	  
	  - Added accept(NodeVisitor) method to Drawable/Geometry
	  
	  - Added traverse(NodeVisitor) to Geode which calls
	  accept(NodeVisitor) on all Drawables
	  
	  - Updated CullVisitor to use new apply(Drawable) to handle
	  drawables. The apply(Billboard) method still manually handles the
	  drawables since it is depends on the billboard settings. I needed
	  to disable the traverse within billboard to prevent duplicate
	  traversal of drawables.
	  
	  - Update other osgUtil node visitors (GLObjectsVisitor,
	  IncrementalCompileOperation, ..) to use new apply(Drawable)
	  method.
	  "

2014-05-12 11:27  robert

	* Added beginnings of new osgUI library, a replacement for
	  osgWidget that works fully in 3D/stereo and is scriptable.

2014-05-06 16:38  robert

	* Replaced obsolete __linux usage.

2014-05-06 09:43  robert

	* From Stephan Huber, "Xcode changed the default
	  std-lib-implementation again. Now it’s GNU++98 instead of C++11.
	  I adapted the cMakeList.txt files accordingly to add this new
	  option so we can set it explicitly and link against
	  3rdparty-c++-libs."

2014-05-06 08:37  robert

	* From Stephan Huber, "Please revert the change to
	  FindQuickTime.cmake as this breaks compilation for IOS and
	  possibly OS X."

2014-05-02 09:12  robert

	* From Farshid Lashkari, "fix for the Collada loader where it would
	  access a null string in some cases"

2014-05-02 09:11  robert

	* From Ali Botorabi, "recently I ran into a problem with
	  Microsoft's Appverifier while using OpenThreads on win32
	  platform. The Appverifier complained about an invalid thread
	  handle during starting of a new thread. After looking closer into
	  the problem it seemed that indeed a potential root of problem may
	  be in the thread startup code. See the line below in
	  Win32Thread.cpp (line number 347):
	  
	  pd->tid.set(
	  (void*)_beginthreadex(NULL,static_cast<unsigned>(pd->stackSize),ThreadPrivateActions::StartThread,static_cast<void
	  *>(this),0,&ID));
	  
	  the method "pd->tid.set" sets the thread id, however via the
	  startup function "ThreadPrivateActions::StartThread" that thread
	  id is used (see further down the call hierarchy the line "int
	  status = SetThreadPriority( pd->tid.get(), prio);".
	  
	  Until now I never ran into any problem in debug or release
	  builds, though. It seems that furtunately the tid.set method was
	  executed always before the tid.get method in the startup code.
	  However, this may make trouble in the furture. A simple solution
	  is the following: just replace the line above with following two
	  lines:
	  
	  pd->tid.set(
	  (void*)_beginthreadex(NULL,static_cast<unsigned>(pd->stackSize),ThreadPrivateActions::StartThread,static_cast<void
	  *>(this),CREATE_SUSPENDED,&ID));
	  ResumeThread(pd->tid.get());
	  
	  
	  The trick is just starting the thread in suspended mode so the
	  StartThread function does not get executed and we can safely
	  store the tid by pd->tid.set. Then start the Thread by calling
	  ResumeThread."

2014-05-01 15:50  robert

	* From Stephan Huber, fix for OSX build

2014-04-30 13:19  robert

	* Renamed the new include/osg/OpenGL automatically configured
	  header file to include/osg/GL replacing the original hand built
	  GL header

2014-04-30 11:51  robert

	* From Sebastian Messerschmidt, "attached is the compile/linker fix
	  for multiple definitions of getTypeEnum when compiling the Lua
	  with VisualStudio and potentially other compilers.
	  "

2014-04-29 15:14  robert

	* From Pjotr Svetachov, "have added some missing serializers for
	  RigGeomery. Withouth them I
	  ran into two issues.
	  
	  At first you get a bunch of warnings that
	  osg::ComputeBoundCallback
	  and osg::UpdateCallback were unsupported wrapper classes when
	  converting fbx models with skeletal animation to osg(t/b).
	  
	  The second issue was that when reading, the readers fail to read
	  the
	  ComputeBoundCallback and UpdateCallback and set them to NULL
	  which
	  messes up the RigGeometry.
	  
	  Because a RigGeometry makes his own classes in the constructor it
	  might be preferable to not write them at all, because now those
	  classes are being made two times when reading a RigGeometry. But
	  after
	  thinking about this that would place too much limits on them (you
	  won't be able to share or name them and save that information or
	  make
	  a new inherited class from them and write that one) So I ended up
	  thinking the best way was to just write the files.
	  "

2014-04-29 13:41  robert

	* From Pjotr Svetachov, "Today I found a bug in the IutputStream
	  class when saving array
	  attributes in vec3b format. It looks like my compiler takes the
	  wrong
	  overload and outputs integers instead of characters. The problem
	  is
	  that vec3b is of type signed char and that is not the same as
	  char (
	  see
	  http://stackoverflow.com/questions/436513/char-signed-char-char-unsigned-char
	  ) and visual studio 2013 will promote it to integer when choosing
	  an
	  overload.
	  It looks like that the InputStream class already takes care of
	  this
	  issue (if it didn't it would have read everything ok and I would
	  have
	  not even stumbled upon this bug. :) )"

2014-04-29 12:19  robert

	* From Mattias Helsing, "I finally got to fix the cmake Modules
	  that have duplicates in later
	  version of cmake. See attached submission. I have tested the ones
	  that
	  I compile myself (GDAL, Freetype, ZLIB) on ubuntu 12.04 with
	  cmake-2.8.7."

2014-04-29 12:18  robert

	* From Paul Martz, "There is no standard place for gl/glcorearb.h
	  on Windows. Previously, the only way to get OSG to build for core
	  profile was to append an additional include directory ("/I") onto
	  the CFLAGS variables This submission adds a FindGLCORE.cmake
	  script so that the path to gl/glcorearb.h can be specified with a
	  variable, GLCORE_ROOT, either in CMake or the environment.
	  
	  Currently this submission is Windows-only. I don't think OSX or
	  Linux require any help in locating gl/glcorearb.h. But if they
	  do, this submission can be easily modified.
	  
	  Files:
	  - "CMakeLists.txt" is the top-level file.
	  - FindGLCORE.cmake" and "OsgMacroUtils.cmake" go in CMakeModules.
	  "

2014-04-28 14:58  robert

	* From Pjotr Svetachov, "I had the osgvolume example crash on me
	  when loading large volume
	  datasets due to an overflow in image.cpp after a unneeded cast
	  from
	  unsigned int to int. Here is a small fix."

2014-04-28 14:57  robert

	* From Jason Beverage, "Here is a fix for a small race condition in
	  osgDB::makeDirectory. It attempts to create all the directories
	  in the given path and stops attempting to make directories when
	  one of them fails. I've added a check to see if the failure
	  occurred b/c the directory was created by another thread or
	  process.
	  
	  We were running into issues occasionally in osgEarth where
	  multiple threads were writing out files like /1/2/3.jpg and
	  /1/3/4.jpg. Both threads would try to create the /1 directory and
	  only one of them would succeed. So the first thread would write
	  out the full /1/2/3.jpg while the second thread wouldn't create
	  the /1/3 directory b/c /1 was already created and the writing of
	  /1/3/4.jpg would fail.
	  "

2014-04-28 11:53  robert

	* Fixed type error

2014-04-25 08:57  robert

	* From Pjotr Svetachov, "For me osgviewer.cpp and Renderer.cpp were
	  not compiling (visual studio 2013 with profile GL2) because they
	  were still using GLuintEXT. So I changed that, see the attached
	  files.
	  
	  I also noticed that the generated OpenGL header were not copied
	  to the installation directory so my own application could not
	  find it."

2014-04-25 08:56  robert

	* Reordered the configuiration file blocks to make it more
	  understandable

2014-04-25 08:18  robert

	* From Paul Martz, fixed placement of OpenGL header so that it gets
	  generated and placed in the build directory as per the Config
	  file

2014-04-24 17:26  robert

	* From Farshid Lashkari, "I've attached a small fix to the Collada
	  loader which prevents a null pointer access in some cases."

2014-04-24 17:23  robert

	* From Lionel Lagarde, "In the ::apply method, when the image data
	  need to be re-uploaded, the Texture2DArray checks if the
	  TextureObject can be re-used. The test was made using the
	  constant 1 instead of the real texture depth, so the
	  TextureObject was never re-used."

2014-04-24 17:14  robert

	* From Kristofer Tingdahl, "I and my team have gone over the code
	  again, and we feel that we are comfortable in our current
	  proposal for change. It goes deeper than it did before, and I
	  explain why:
	  
	  There was code in the osgViewer/Viewer.cpp and
	  osgViewer/CompositeViewer.cpp that transformed the Y-coordinates
	  of an event. The code in the composite viewer did however miss
	  the touch-data of the event. I thought that it should really be
	  the GUIEventAdapter that should know about this, and hence I
	  added the
	  GUIEventAdapter::setMouseYOrientationAndUpdateCoords which is
	  re-computing the coordinates. First I simply added a boolean to
	  the setMouseYOrientation function:
	  
	  setMouseYOrientation( MouseYOrientation, bool updatecooreds=false
	  );
	  
	  but then the serializer complained.
	  
	  This function is called from both the Viewer and the
	  CompositeViewer. We have not tested from the viewer, but I cannot
	  see it would not work from visual inspection.
	  
	  The other change is in
	  MultiTouchTrackballManipulator::handleMultiTouchDrag. I have
	  removed the normalisation. The reason for that is that it
	  normalised into screen coordinates from 0,0 to 1,1. The problem
	  with that is that if you have a pinch event and you keep the
	  distance say 300 pixels between your fingers, these 300 pixels
	  represent 0.20 of the screen in the horizontal domain, but 0.3 of
	  the screen in the vertical domain. A rotation of the
	  pinch-fingers will hence result in a zoom in, as the normalised
	  distance is changing between them.
	  
	  A consequence of this is that I have changed the pan-code to use
	  the same algorithm as the middle-mouse-pan.
	  
	  The rest of it is very similar from previous revision, and there
	  has been some fine-tuning here and there.
	  
	  "

2014-04-24 10:49  robert

	* From Mattias Helsing, "Seems I was only half right given what you
	  asked for. CMP0017 only
	  says that modules that are found and ran from cmake modules dir
	  should
	  prefer cmake-provided modules. find_package() and include() still
	  look
	  in CMAKE_MODULE_PATH first.
	  
	  After some investigating I've come up with a proposal examplified
	  in
	  the attached FindGDAL.cmake script. It simply calls the cmake
	  provided
	  FindGDAL.cmake if it exists and returns if it succeeds in finding
	  GDAL
	  using that, otherwise continue with our local cmake code.
	  Pro: Wont clutter our root CMakeLists.txt
	  Con: If we begin to write more advanced Findxxx modules (using
	  COMPONENTS, REQUIRED etc.) we may have to revise this scheme.
	  "

2014-04-24 10:38  robert

	* Fixed reference invalidation bug.

2014-04-24 07:22  robert

	* Fixed typo in OPENSCENEGRAPH_OPENGL_HEADER name

2014-04-24 07:20  robert

	* Removed header as this CMake generated configuration file is not
	  required to be part of svn repository

2014-04-23 19:30  robert

	* Added src/osg/OpenGL.in configuration file and include/osg/OpenGL
	  header files

2014-04-23 09:08  robert

	* Introduced new scheme for setting up which version of
	  OpenGL/OpenGL ES the OSG is compiled for.
	  
	  To select standard OpenGL 1/2 build with full backwards and
	  forwards comtability use:
	  
	  ./configure
	  make
	  
	  OR
	  
	  ./configure -DOPENGL_PROFILE=GL2
	  
	  To select OpenGL 3 core profile build using GL3/gl3.h header:
	  
	  ./configure -DOPENGL_PROFILE=GL3
	  
	  To select OpenGL Arb core profile build using GL/glcorearb.h
	  header:
	  
	  ./configure -DOPENGL_PROFILE=GLCORE
	  
	  To select OpenGL ES 1.1 profile use:
	  
	  ./configure -DOPENGL_PROFILE=GLES1
	  
	  To select OpenGL ES 2 profile use:
	  
	  ./configure -DOPENGL_PROFILE=GLES2
	  
	  
	  Using OPENGL_PROFILE will select all the appropriate features
	  required so no other settings in cmake will need to be adjusted.
	  The new configuration options are stored in the
	  include/osg/OpenGL header that deprecates the old include/osg/GL
	  header.

2014-04-14 16:16  robert

	* Fixed comment

2014-04-13 16:04  robert

	* Renamed FindFreeType.cmake to FindFreetype.cmake to enable CMake
	  build to pick up on CMake's own FindFreetype.cmake when it's
	  available.

2014-04-09 17:40  robert

	* From Paul Cheyrou-Lagreze, "Attached is fix/feature for FBX
	  osgplugins against latest trunk:
	  
	  - ReaderWriterFBX.cpp: add "z up scene axis" support: FBX
	  provides facility to convert model scene axis during conversion.
	  Currently fbx plugin convert axis to fbx:opengl axis system
	  (which is arbitrarily at Y up, as opengl is in reality axis
	  agnostic) and sometimes what is needed is Z up so added an option
	  for Z up conversion
	  
	  - FindFBX.cmake: add support for latest fbx sdk ( 2014.2 )"

2014-04-09 17:20  robert

	* Disabled warnings to address issues in FBX headers that generate
	  lots of warnings that we can't fix.

2014-04-08 19:42  robert

	* Added extra search paths to add compatibility with Kubuntu/Ubuntu
	  14.04 now locaton for freetype

2014-04-08 17:45  robert

	* Updated ChangeLog and fixed Contributors list

2014-04-08 12:00  robert

	* From Remo Eichenberger, "I have extended the TIFF plugin that
	  allows you to write LZW or JPEG compressed TIFF's. Options are:
	  
	  tiff_compression = lzw | jpeg"

2014-04-08 11:48  robert

	* From Sebastian Messerschmidt, "n the trunk version the
	  osgGA::GUIActionAdapter has additional functions for
	  lineIntersection which use osgGA::GUIEventAdapter&, but the class
	  declaration is neither forwarded, nor is the header included.
	  Using the trunk together with osgEarth 2.5 will fail to build,
	  due to the missing type.
	  
	  Attached is the file forward declaring osgGA::GUIEventAdapter."

2014-04-08 11:17  robert

	* From Pjotr Svetachov, "We had a small problem converting skeleton
	  animations from fbx to osgt
	  format. Turned out that the serializer didn't handle bone names
	  with
	  spaces very well (the 3ds studio max biped for instance has
	  spaces by
	  default). Here is a small fix for the problem."

2014-04-08 11:08  robert

	* From Pjotr Svetachov, previous obj "commit broke compilation
	  under visual studio 2013. To use std::not1 you need to include
	  the functional header. Here is a fix."

2014-04-07 15:04  robert

	* Fixed build when using of double BoundingBox/BoundingSphere

2014-04-07 14:17  robert

	* From Jan Peciva, "I am sending four fixes to obj plugin:
	  
	  - materialName used to be not stripped of whitespace, making
	  number of models
	  fail to load materials; now fixed
	  - stripping was considering spaces only, thus models using tabs
	  had problems
	  to load correctly; fixed
	  - fixed references to textures; they did not performed conversion
	  to native
	  directory separators
	  - make d (dissolve) takes precedence over Tr (transparency);
	  there seems to be
	  a confusion about the Tr item - some claiming 1 to be opaque and
	  0
	  transparent, while number of models uses exactly the opposite. d
	  (dissolve),
	  if present in the model, does not suffer from this confusion,
	  thus using it
	  instead fixes the problem for many many models.
	  
	  I put many comments to the file concerning d and Tr item as
	  others may further
	  investigate. Let me know in the case of any problems."

2014-04-07 14:11  robert

	* From Marcel Pursche, "The problem is that when OpenThreads is
	  build with the Linux pthreads implementation all threads inherit
	  the processor affinity from their parent thread.
	  This behavior is also described in the pthreads man page
	  (http://man7.org/linux/man-pages/man3/pthread_create.3.html):
	  
	  >
	  > Linux-specific details
	  > The new thread inherits copies of the calling thread's
	  capability
	  > sets (see capabilities(7)) and CPU affinity mask (see
	  > sched_setaffinity(2)).
	  >
	  
	  To prevent this behaviour I wrote a patch that explicitly sets
	  the affinity mask to all cores of the system, if no specific
	  affinity was defined with PThread::setProcessorAffinity(unsigned
	  int) .
	  
	  Thank you!
	  "

2014-04-07 14:03  robert

	* From Bjorn Blessing, "I got bored of the constant reports of
	  “missing chunk 0xA08A” when reading 3ds-files. After a bit of
	  research I discovered that this property is related to the
	  advanced transparency settings for the material in 3D studio. In
	  this case the falloff parameter. These controls affect the
	  opacity falloff of a transparent material. And the property
	  chooses whether falloff is in or out. I have added the property
	  to the file reader BUT no changes are made to make this property
	  propagate into the osgMaterial. But at least we get rid of this
	  annoying error message."

2014-04-07 13:52  robert

	* From Bjorn Hein, "please find attached a small fix for
	  RayIntersector.cpp.
	  
	  * Changes are made against trunk
	  * Reason: crashes when using specific constructor from
	  RayIntersector
	  * Info: Line 42: added in constructor
	  RayIntersector::RayIntersector(const Vec3d& start, const Vec3d&
	  direction) missing initialisation of _parent
	  "

2014-04-07 13:48  robert

	* From Paul Martz, "We discussed the issue of GL_RED_SNORM and
	  GL_RG_SNORM some time ago, but the issue was never completely
	  resolved. Please see the attached submission to fix the issue.
	  
	  osg/GL2Extensions was incorrectly defining GL_RED_SNORM and
	  GL_RG_SNORM as part of the definitions for OpenGL v3.1. However,
	  a quick review of the 3.1 spec indicates that these are not part
	  of the 3.1 standard.
	  
	  My attached change moves these definitions out of the #ifndef
	  GL_VERSION_3_1 conditional block, and defines them conditionally
	  if not already defined. This allows the DDS plugin to build for
	  GL3.
	  "

2014-04-04 11:25  robert

	* Fixed iso surface shaders

2014-04-01 18:56  robert

	* Improved the setting of sample density/ratio so that they are
	  consistent

2014-04-01 18:33  robert

	* Fixed handling of volume tiles with a region.

2014-03-27 12:47  robert

	* Added cube and hull rendering support

2014-03-19 17:56  robert

	* Restructured the handling of TileData to make it more extensible
	  and flexible.

2014-03-18 18:14  robert

	* Addd ExteriorTransparencyFactorProperty for support of upcomming
	  functionality of rendering a cube volume with a hull volume
	  inside it.

2014-03-17 15:54  robert

	* Added support for animating volume hulls.

2014-03-13 14:02  robert

	* From Stephan Huber, "attached is a fix for the rest-http-plugin
	  which should fix the font-issue reported by Phil. The old
	  implementation did forward all requests to the internal
	  http-server via user-events. This prevented error-reporting for
	  missing files, as the request was accidentally handled by the
	  plugin. As a request for missing font-file succeeds and returned
	  an empty file, the curl-plugin hands the data happily to the
	  freetype-plugin which failed trying to load an empty font-file,
	  obviously.
	  
	  My fix was to rename the standard request handler to a
	  specialized user-event-handler which handles only requests for
	  "/user-event“
	  
	  So fonts should work on iOS when loaded remotely, even when a
	  local file is available and with the resthttp-plugin serving the
	  presentation.
	  "

2014-03-13 13:59  robert

	* From Stephan Huber, fix for building lua plugin from local source

2014-03-13 10:28  robert

	* Added support for directly invoking scripts using <run-script>
	  and <run-script-file> to enable scripts to interact with each
	  other.

2014-03-12 11:01  robert

	* Improved support for passing events between scripts and Present3D
	  application

2014-03-11 10:52  robert

	* Added PresentationInterface class to make it more convinient to
	  access the current presentation from scripting languages

2014-03-10 19:08  robert

	* Added scripting support for JumpData, KeyPosition, HomePosition
	  and parts of SlideEventHandler that enable dispatching of user
	  created events.

2014-03-07 11:09  robert

	* Added ability to replace callback objects via lua scripts to
	  allow one to override callbacks.
	  
	  Added fallback for osgGA::Widget::Extents.

2014-03-06 10:27  robert

	* Added support for osg::Image to the lua plugin.

2014-03-04 13:36  robert

	* Implement add, set and get methods for StateSet.

2014-03-04 13:35  robert

	* Relaxed the handling of Image objects

2014-03-04 13:34  robert

	* Fixed handling of OverrideValue

2014-02-28 17:38  robert

	* From Stephan Huber, fix for handling font paths on a local
	  machine when other files have been source from a remote machine.

2014-02-27 10:02  robert

	* Added MapReverseIterator implementation.

2014-02-26 18:18  robert

	* Added MapIteratorObject and support for it in the lua plugin to
	  provide map iterator functionality.

2014-02-26 11:01  robert

	* Added Map serializer size() method and support for it in the lua
	  plugin. Renamed functions in lua plugin to be more consistent.

2014-02-26 08:26  robert

	* Added support for vector and map containers in
	  osgDB::Serailizer's and lua plugin.

2014-02-24 10:19  robert

	* Added Vector serialization and support in lua plugin top enable
	  script users to set/get vector properties such as osg::Array,
	  osg::PrimitiveSet and children lists.

2014-02-13 18:52  robert

	* Fixed handling of enums in Lua plugin.
	  
	  Fixed computation of getNumPrimitives() so that it returns 0 when
	  PrimitiveSet is zero.
	  
	  Added missing properties to PrimitiveSet serializers

2014-02-13 11:01  robert

	* Added inital cut of PrimitiveSetSet wrappers to scripting

2014-02-12 18:10  robert

	* Added full range of Array subclasses to wrappers

2014-02-12 18:03  robert

	* Added initial support for wrapping osg::Array in a way that can
	  be used via scripting.

2014-02-11 18:18  robert

	* Fixed handling of assignment of User Object's that replace
	  existing Object with the specified propertyName.

2014-02-11 18:07  robert

	* Improved support for setting/getting properties via the
	  osg::UserDataContainer.

2014-02-11 10:56  robert

	* Quitened down debug messages

2014-02-11 09:43  robert

	* Changed implementation of enums to use strings as lua type to
	  make it easier to do comparisons and track values

2014-02-10 18:07  robert

	* Implemented Widget::handle, handleImplementation, traverse and
	  travseImplementation() wrappers to enable them to be extended via
	  scripting

2014-02-10 16:44  robert

	* Added support for serailizing and scripting BoundingBox and
	  BoundingSphere objects

2014-02-08 17:53  robert

	* Fixed handling of setting member variables via the Serializers
	  when the value is the default.
	  
	  Added support for more features of the osgDB::Widget class.
	  
	  Fixed handling of boolean values in the Lua plugin

2014-02-08 10:39  robert

	* Added support for enum's in the Lua script integration

2014-02-08 10:38  robert

	* Fixed export

2014-02-07 16:06  robert

	* Fixed handling of returns when invoking a script, removed some
	  debug messages, added a warning message when detecting erronous
	  types.
	  
	  Added FocusBehaviour enum to osgGA::Widget serialization

2014-02-07 10:46  robert

	* Added initial Widget wrapper

2014-02-06 17:32  robert

	* Moved experimental Widget class to osgGA
	  Add computeIntersections() to the osgGA::GUIActionAdapter base
	  class to enable intersection tests without needing to directly
	  link to osgViewer.

2014-02-06 17:04  robert

	* Added osg::CallbackObject suport to the experiment Widget base
	  class to enable script language extension of widgets

2014-02-06 11:25  robert

	* Added support for casting objects to allow one to access a parent
	  classes methods.

2014-02-05 11:08  robert

	* Tweaked the detection of when the position transform for the hull
	  is required.

2014-02-05 11:07  robert

	* Added support for a <hull> tag that can be used within <volume>
	  tag.

2014-02-05 11:04  robert

	* Improved the white space trimming

2014-02-04 16:49  robert

	* Added lua-5.2.3 as source code so it can be optinally built as
	  part of the lua plugin, making it possible to work out of the box
	  across all platforms with needing lua as an external dependency.
	  
	  Added the Cmake option OSG_USE_LOCAL_LUA_SOURCE to control
	  whether to build and use the Lua source code in the lua plugin,
	  or look for lua as an external dependency.

2014-02-04 16:46  robert

	* Added test code for nesting a <hull> within a volume tag.

2014-02-04 11:24  robert

	* From Stephan Huber, added support for compile source code of lua
	  with the lua plugin

2014-02-03 15:35  robert

	* Fixed error in the computation of tex coords of Maximum Intensity
	  Projection + Transfer Function rendering.

2014-01-31 19:18  robert

	* Replaced C cast to long with a static_cast<const void*>() to
	  avoid a build error under Mingw 64.

2014-01-31 16:20  robert

	* Added osg::CallbackObject to be used to extend C++ class from
	  scripting languages by providing callback objects assigned to the
	  osg::Object UserDataContainer, with the CallbackObject's Name
	  used to map the "method" provided by the CallbackObject. The
	  CallbackObject is implemented by the script engine to provide the
	  neccessary glue to invoking the script with the appropriate input
	  parameters and handling the output parameters.
	  
	  To the Lua plugin added support for assigned lua functions to C++
	  osg::Objects via the new osg::CallbackObject mechanism. To invoke
	  the scripts function from C++ one must get the CallbackObject and
	  call run on it.
	  
	  Renamed ScriptCallback to ScriptNodeCallback to avoid possibly
	  confusion between osg::CallbackObject and the ScriptNodeCallback.

2014-01-29 11:01  robert

	* Updated ChangeLog

2014-01-28 16:49  robert

	* From Kristofer Tingdahl, made method virtual

2014-01-28 16:48  robert

	* Fixed MingW build's handling of debug d postfix.

2014-01-28 15:28  robert

	* Removed the invocation of gcc on all platforms

2014-01-28 11:01  robert

	* From Kristofer Tingdahl, "the vertical bar is upside down, and
	  hence not as the documentation says it should be. This is
	  corrected with this patch"
	  
	  From Robert Osfield, changed the example so that the vertical and
	  horizon scalar bars are rotated to the XZ plane so you can see
	  them with the default viewer's camera orientation.
	  Tweaked the positioning of title text of vertic scalar bar to
	  avoid overlap of text.

2014-01-27 15:43  robert

	* Removed unimplemented method

2014-01-24 17:31  robert

	* From Laurens Voerman, "I experienced a crash in
	  Geometry::fixDeprecatedData(), on certain files, and brought the
	  problem down to a very simple test file, attached as test3.zip.
	  
	  There are two problems:
	  1> for DrawElementsUShortPrimitiveType (and UInt) the
	  source_pindex still equals -1 and causes a crash
	  in DrawElementsUBytePrimitiveType source_pindex is incremented,
	  and in DrawElementsU(Short/Int)PrimitiveType primitiveNum is
	  incremented, but never used
	  
	  2> The drawelements need to be rewritten as the vertices are
	  reordered.
	  
	  created a patch for osg stable branch(r14038): attached as
	  Geometry-osg-3.2.zip
	  and for svn brach(r14044): attached as Geometry_osg_svn.zip"

2014-01-24 17:06  robert

	* From Aurelien Albert, "In the "apply" method of
	  osg::FrameBufferObject, the draw buffers are always enabled, even
	  if the target is only "READ_FRAMEBUFFER".
	  
	  This can lead to inconsistency if you bind a framebuffer with
	  multiple attachments in DRAW mode and then a framebuffer with
	  different attachment count in READ mode (for example to manually
	  "blit" from a FBo to another).
	  
	  On some ATI cards (at least RADEON HD) this also leads to an
	  "incomplete " FBO status
	  
	  I've added a test to enable drawbuffers only if target is "DRAW"
	  or "READ_DRAW", this solves my problems on ATI cards."

2014-01-24 16:45  robert

	* From Michael Schanne, "small fix for a duplicate OR operand in
	  KdTree.cpp."

2014-01-24 16:28  robert

	* From Torben Dannahuer, "modified findcollada.cmake which can now
	  detect Boost 1.55 libraries, which are used by Collada in my
	  3rdParty package"

2014-01-24 16:24  robert

	* From Torben Dannhauer, VisualStudio 2013 build fixes

2014-01-24 16:19  robert

	* From Kristofer, "The osgSim::ScalarBar has a problem in that if
	  the scalarbar has a color in one end that co-incides with the
	  background color, one cannot see where the scalarbar ends. With
	  this patch, we add a line around the perimiter of the bar to mark
	  it.
	  
	  Secondly, we thought the text-annotation missed ticks that mark
	  out precisely where on the bar the texts relate to, so we added
	  that as well."

2014-01-24 16:01  robert

	* From Marc Helbling, "I am sending a small fix in the PLY
	  pseudo-loader; the extension was checked in plyfile.cpp thus
	  preventing the loading of any .PLY file (extension in uppercase).
	  The extension filtering is already handled by
	  ReaderWriter::acceptsExtension in a case unsensitive way."

2014-01-24 15:40  robert

	* Fixed warnings

2014-01-24 14:26  robert

	* Changed the handling of single window configurations so that
	  simply reuse the View::getCamera() instead of creating a slave.

2014-01-24 12:01  robert

	* Added a getModeUsage() method that prevents any mode being
	  automatically associated with these Texture types that are only
	  usable using non fixed function pipeline.

2014-01-24 11:37  robert

	* Fixed crash when reading a viewer configuration file where the
	  EventVisitor was being re-assigned but left a dangling pointer

2014-01-24 10:10  robert

	* From Stephan Huber, "attached is a new zip containing two small
	  fixes:
	  * forwarded touch-events do have a correct input-range from 0 ..
	  1
	  * I refactored sending touch-events per osc so the receiver can
	  detect a TOUCH_ENDED better"

2014-01-23 19:55  robert

	* Fixed warnings

2014-01-23 16:48  robert

	* From Kristofer Tingdahl,"we have a bunch of classes that inherit
	  osg::Node, and they create their own, internal geometry which is
	  passed into the render bucket at the cull-traversal. Last week,
	  we realised that these classes are not accounted for when doing
	  an ComputeBoundVisitor- traversal, as there is no specialization
	  in ComputeBoundVisitor for them.
	  
	  One solution is naturally to create a new class that would
	  inherit the osg::ComputeBoundVisitor, and use that. I don't like
	  that idea as the ComputeBoundVisitor does actually have what I
	  need - it is only hidden in a protected function.
	  
	  I am therefor suggesting a slight generalization of the
	  ComputeBoundVisitor with the attached patch, which is tested.
	  
	  The patch has two parts:
	  we add applyBBox() so that one can use that in a customized
	  traverse-function and add a bbox to the visitor. I considered
	  calling this function expandByBBox(), but I though applyBBox was
	  better.
	  The MatrixStack is made available to the outside world. That
	  enables a traverse-function to do whatever it wishes.
	  I do actually only need one of the two, as I can implement what I
	  wish either way, but adding getMatrixStack() will make more
	  generic expansions possible.
	  "
	  
	  From Robert Osfield, changed the name of the new applyBBox(..)
	  method to applyBoundingBox(..) to keep it's naming more
	  consistent with the rest of the OSG.

2014-01-23 15:37  robert

	* From Stephan Huber, "attached are some fixes to the osc-plugin
	  and the touch-implementations for iOS and os x and other small
	  bugfixes. These fixes will normalize the orientation of the touch
	  points, and transmitting the touch points over osc via the
	  TUIO-protocol works now more robustly between two
	  osg-applications.
	  
	  I added a new tag to p3d called forward_touch_event_to_device and
	  renamed the existing forward_event_to_device to
	  forward_mouse_event_to_device. This new tag will transmit touches
	  to the virtual trackpad as touch events. I added the
	  MultitouchTrackball to the p3d-app so zooming and moving a model
	  remotely should now work, if you use
	  forward_touch_event_to_device. I kept (and fixed)
	  forward_mouse_event_to_device for background compatibility, so
	  old presentations works as in previous versions, without the
	  ability to zoom + scale. of course.
	  
	  forward_touch_event_to_device needs some more testing, (e.g. with
	  image-streams and keystone, afaik there’s no support for
	  touch-events...) but for a first version it works nice.
	  "

2014-01-23 10:56  robert

	* Removed debug message

2014-01-23 10:50  robert

	* Changed the TransprencyProperty range to 0 to 2.0 to enable
	  forcing opaque qualities on fragments

2014-01-23 10:11  robert

	* Cleaned up debug message.

2014-01-23 10:09  robert

	* Cleaned up the Qt find package, and made changed the default
	  threading model to SingleThreaded when using Qt5 to avoid crash
	  due to regresssion since Qt4.

2014-01-23 09:41  robert

	* Added clean up of osg::Program that are applied by the
	  GLObjectsVisitor, which addresses a state leak that creates GL
	  error once the main scene graph is rendered.

2014-01-23 07:59  robert

	* Added GL_TEXTURE_2D_MULTISAMPLE to texture mode list.

2014-01-22 17:29  robert

	* Made protected methods virtual to allow subclassing to customize
	  more aspects of the window setup.

2014-01-22 16:29  robert

	* Refactored .p3d loader to make it less strict about the tag,
	  property and value strings when matching them to supported
	  values.
	  
	  Examples of supported matches are:
	  
	  <Slide> and <slide> will be treated the same
	  <bgcolor>WHITE</bgcolor> and <bgcolor>White</bgcolor> will be
	  treated the same
	  <text alignment="TOP_LEFT"</text> and <text alignment="top
	  left"</text>, <text alignment="TopLeft"</text> will all be
	  treated the same

2014-01-22 11:25  robert

	* Added support for sampleRatio and sampleRatioWhenMoving <volume>
	  properties

2014-01-21 18:58  robert

	* Build fixes for when ref_ptr<> automatic type conversion is
	  turned off

2014-01-21 18:48  robert

	* Added support for osgVolue::SampleRatioProperty. Fixed build
	  errors when compiling with ref_ptr<> automatic type conversion.

2014-01-21 18:31  robert

	* Build fixes for when ref_ptr<> has no auto type conversion

2014-01-21 17:27  robert

	* Fixed build error

2014-01-21 17:00  robert

	* Fixed build error due to typo.

2014-01-20 17:23  robert

	* Integrated multipass volume rendering shaders from
	  OpenSceneGraph-Data

2014-01-20 17:03  robert

	* Changed the default directory for the output files to be the
	  current working directory,
	  with the --write-to-source-file-directory added to allow one to
	  have the original behaviour
	  of writing to the same directory as the original source file.

2014-01-20 16:21  robert

	* Removed nolonger used code paths

2014-01-20 15:54  robert

	* Disable depth test for rendering of hull backface

2014-01-20 15:10  robert

	* From Stephan Huber, "recent commits regarding GLuint64EXT broke
	  the build for GLES1 and GLES2. Attached you’ll find a fix which
	  hopefully work for every platform."

2014-01-20 11:00  robert

	* From Kristofer Tingdahl, reimplement of AntiSquish node to avoid
	  the use of an update callback.
	  
	  From Robert Osfield, small ammendments to clean up header.

2014-01-20 10:40  robert

	* From Roni Zanolli,Added use of Qt's new devicePixelRatio() method
	  to assist with handling the upscalling of resolution on iPhone
	  for "retina" displays.
	  
	  From Robert Osfield, changed Roni's code to use a #define
	  GETDEVICEPIXELRATIO to access the versioned Qt devicePixelRatio()
	  method to avoid duplication of the Qt version checking.

2014-01-17 18:20  robert

	* Fixed warning

2014-01-17 18:20  robert

	* From Stephan Huber, fix for OSX build issue

2014-01-17 14:02  robert

	* From Kristoger Tingdahl, "the patch I sent to
	  src/osgQt/CMakeModules.txt did not do the work on windows. I have
	  fixed that, and also made it more generic so there is no special
	  handling of qt5.2, but all qt5 are the same.
	  
	  I have tested this on:
	  
	  mac/qt5.2
	  linux/qt5.2
	  windows/qt5.2, and
	  mac/qt5.1
	  
	  All platforms perform as expected.
	  
	  The previous fix removed the -f flag to the moc-pre-processor,
	  but on windows, it turned out that -f "osgQt/QGraphicsViewer" was
	  needed.
	  
	  This becomes an include-statement in the file generated by moc
	  which is needed for compiling it. I ask you consider this patch
	  for the trunk and the 3.2 branch.
	  
	  
	  Secondly, I wonder if it would be possible to apply my patch for
	  FindRSVG.cmake from 22nd November in the 3.2 branch.
	  
	  In short, the version of librsvg must be equal or higher to 2.35:
	  
	  PKG_CHECK_MODULES(RSVG librsvg-2.0>=2.35)
	  "

2014-01-17 13:59  robert

	* From Jordi Torres, "We have a code using gcc with -Wextra flag
	  and using OSG as a third party library. It does not compile when
	  importing <osgViewer/Viewer> failing in EventHandler and
	  GUIEventHandler:
	  
	  ....
	  
	  GUIEventHandler: In copy constructor
	  'osgGA::GUIEventHandler::GUIEventHandler(const
	  osgGA::GUIEventHandler&, const osg::CopyOp&)':
	  
	  /include/osgGA/GUIEventHandler:56:9: error: base class 'class
	  osg::Object' should be explicitly initialized in the copy
	  constructor [-Werror=extra]
	  
	  It seems the diamond problem:
	  
	  A = osg::Object
	  / \
	  / \--> Virtual inheritance
	  B C
	  \ /
	  \ /
	  D = EventHandler
	  |
	  |
	  E = GUIEventHandler
	  
	  The most derived class(E) handles the instantiation of A
	  (osg::Object), but all have to be responsible in case they are
	  the ones instantiated.
	  
	  
	  In case A is not initialized in the copy constructor of derived
	  classes the default constructor will be called, which seems a
	  bug.
	  
	  I've added osg::Object to the initalization list of EventHandler
	  and GUIEventHandler copy constructors, because both classes are
	  instantiables.
	  "

2014-01-17 13:54  robert

	* From Jordi Torres, "Fixed a typo in
	  ReaderWriterCURL::ReaderWriterCURL() changed Psuedo for Pseudo."

2014-01-17 12:40  robert

	* Fixed handling of background colours.

2014-01-16 17:26  robert

	* Removed old redundent TexGen usage.

2014-01-16 17:17  robert

	* Added hull="hul-filename" property support to <volume> tag that
	  can used thus:
	  
	  <layer>
	  <volume renderer="MultiPass"
	  hull="cow.osgt.0,-2,-4.trans.50,50,50.scale">CardiacCT</volume>
	  </layer>

2014-01-16 16:08  robert

	* Added support for controlling the extents of the volume rendering
	  by nesting the hull underneath VolumeTile. Currently only
	  supported by the new osgVolume::MultipassTechnique

2014-01-09 11:13  robert

	* From Paul Martz, build fix for Windows GL3 build

2014-01-09 09:41  robert

	* Added per TileData RTT Camera in prep for rendering backface of
	  volume to a depth texture

2014-01-08 15:56  robert

	* Changed near/far values to use CullVisitor::value_type and use
	  std::numeric_limits<>.

2014-01-08 10:33  robert

	* From Farshid Lashkari, "I've attached a fix for the Collada
	  loader that prevents a crash with some files containing textures.
	  I also converted an OSG_NOTICE to OSG_INFO to be consistent with
	  other log messages within the loader."

2014-01-08 10:31  robert

	* Removed more odd characters

2014-01-08 10:28  robert

	* Removed more odd characters

2014-01-08 10:24  robert

	* Removed odd characters

2014-01-08 10:16  robert

	* Moved destructor to protected

2014-01-07 19:06  robert

	* Refined the GLint64 definitions

2014-01-07 18:32  robert

	* Removed duplicated instances of GLint64EXT declarations

2014-01-07 16:43  robert

	* Removed execute properties via svn propdel svn:executable file

2014-01-07 16:29  robert

	* From Farshid Lashkari, "I've attached a small change to the DAE
	  writer to support writing out unknown transform types. It will
	  essentially treat it as a matrix transform, using the the local
	  to world matrix value."

2014-01-07 16:18  robert

	* Bumped SO_VERSION number of OpenThreads to avoid conflicts with
	  Debian SO_VERSION bump

2014-01-07 16:15  robert

	* From Sebastian Messerschmidt, "Original shader was not running on
	  various NVidia cards due to old syntax in shader."

2014-01-07 11:01  robert

	* Added State::getMaxTextureCoords() and
	  State::getMaxTextureUnits() inline methods.

2014-01-06 17:19  robert

	* Added support for Switch::set/getValue()

2014-01-06 16:58  robert

	* Added Group::setChild(..) and Geode::setDrawable(..)
	  MethodObjects

2014-01-06 15:46  robert

	* Removed the prototype MethodObject classes

2014-01-06 15:45  robert

	* Moved osgDB::MethodObject from lua plugin into osgDB, added
	  support for running methods via the osgDB::PropertyInterface
	  class.
	  
	  Updated lua plugin to use new osgDB::PropertyInterface to run
	  methods.
	  
	  Added addChild/removeChild() etc to Group.cpp, and
	  addDrawable/removeDrawable() etc. to Geode.cpp serializers.

2014-01-06 10:23  robert

	* Renamed the OSGSIM cmake variable to OSGSIM_LIBRARY to be
	  consistent with the rest of the variables.

2014-01-03 14:36  robert

	* Fixed build of V8 and Python plugins

2013-12-25 17:36  robert

	* Preliminary support for wrapping methods in the lua script
	  plugin.

2013-12-20 09:57  robert

	* Added <switch> tag to .p3d to allow one to provide multiple ways
	  to render children within a layer.

2013-12-19 17:13  robert

	* From Kristofer Tingdahl, "the syntax of the moc executable has
	  changed between 5.1.1 and 5.2.0 versions of qt (see below). The
	  difference is that the <file> argument has become mandatory after
	  the -f option.
	  
	  Hence, moc will complain when osg throws in a -f without anything
	  after it. Hence I propose removing the -f on Qt5 builds. I have
	  tested building without -f on both qt520 and qt511, and that
	  works well.
	  
	  The attached src/osgQt/CMakeLists.txt that can be patched into
	  3.2 safely. For the trunk, I would consider dropping the check on
	  the version, and simply remove the option on qt5. I have tested
	  that on qt5.1.1, and that worked fine. Question is however if it
	  works on qt5.0. Probably it does, so the question is simplicity
	  of CMakeList.txt vs safety."

2013-12-19 15:10  robert

	* From Sylvain Marie, When compiling OSG for the iOS simulator,
	  providing both -miphoneos-version-min and
	  -mios-simulator-version-min doesn’t please clang (tested on OS X
	  10.9.0 with Xcode 5.0.1).
	  Here is a small change (against commit
	  da597ab16945c572a2ad2f4f26fcef38ed21b074) in the CMakeLists.txt
	  to avoid this situation.

2013-12-19 13:53  robert

	* From Michal Durkovic, "I’m building current trunk on Mac OS X
	  10.9 and have encountered this error during linking of osgdb_lua
	  plugin:
	  
	  
	  
	  Undefined symbols for architecture x86_64:
	  
	  "lua::LuaScriptEngine::pushValue(osg::Quat const&) const",
	  referenced from:
	  
	  PushStackValueVisitor::apply(osg::Quat const&) in
	  LuaScriptEngine.o
	  
	  "lua::LuaScriptEngine::pushValue(osg::Plane const&) const",
	  referenced from:
	  
	  PushStackValueVisitor::apply(osg::Plane const&) in
	  LuaScriptEngine.o
	  
	  ld: symbol(s) not found for architecture x86_64
	  
	  clang: error: linker command failed with exit code 1 (use -v to
	  see invocation)
	  
	  
	  
	  Looks like LuaScriptEngine was missing implementation of those 2
	  member functions. Fixed src/osgPlugins/lua/LuaScriptEngine.cpp
	  file in attachment.
	  
	  "

2013-12-19 13:49  robert

	* From Stephan Hunber, "attached you’ll find some changes to
	  osg/p3d:
	  
	  * a new command-line-option to present3d and a new option to the
	  p3d-plugin to suppress any found <env> tags
	  * a new command-line-option to present3d to forward mouse-events
	  via osgGA::Device (defaults to off) so we can test the
	  interface-files with present3d better
	  * I added a new attribute forward_to_devices for click_to_event
	  to forward the event to all attached devices instead of handling
	  the event locally. This will fix the annoyance with the new
	  interface-files when toggling polygon-mode or switching light
	  on/off.
	  
	  Here’s an example:
	  
	  <click_to_event forward_to_devices="true">0x72</click_to_event>
	  "

2013-12-19 13:44  robert

	* From Stephan Hunber, "I found some time and ported
	  osgDB::FileUtils and DarwinUtils across new apis to fix the
	  warnings about deprecated api-usage.
	  
	  * osgDB::FileUtils uses now the Cocoa-API to determine the paths
	  of the application-support-folder
	  * DarwinUtils uses now modern functions of the quartz-api to get
	  and set screen-resolutions. Removed some of the osg-deprecated
	  stuff.
	  "

2013-12-19 10:02  robert

	* Implemented support for calling scripts from with Present3D.

2013-12-17 12:18  robert

	* Added support for new osgVolume::MultiPassTechnique to Present3D.
	  To use add property renderer="MultiPass":
	  
	  <volume renderer="MultiPass">MyVolumeData</volume>

2013-12-17 10:52  robert

	* Added experimental image 3d downsample function.

2013-12-16 11:28  robert

	* Removed the unused Texture::Extensions::numTextureUnits()

2013-12-13 12:38  robert

	* Implemented ability to switch between different shaders with new
	  MultipassTechnique

2013-12-12 09:53  robert

	* Added SampleRatioWhenMoving property and support to new
	  osgVolume::MultipassTechnique.

2013-12-12 09:51  robert

	* Applied unquie CullVisitor::Identifier rather than reusing the
	  cloned one.

2013-12-11 17:20  robert

	* Changed epsilon to 1e-5 to address picking problems with planaer
	  objects

2013-12-11 12:00  robert

	* Added initial support for 1D transfer functions to
	  MultipassTechnique

2013-12-10 13:38  robert

	* Added support for handling viewports with offset origins, and
	  with it split stereo.

2013-12-10 10:43  robert

	* Introduced SampleRatioValueProperty for more intuitive control of
	  how many samples to take when volume rendering

2013-12-09 10:39  robert

	* Improvements to new MultipassTechnique

2013-12-06 19:31  robert

	* Further work on new MultipassTechnique/VolumeScene.

2013-12-06 09:35  robert

	* From Mike Krus, compile fix to enable compiling across a wider
	  set of versions.

2013-11-26 19:03  robert

	* Added support for using shaders to render the RTT textures with
	  depth

2013-11-26 10:38  robert

	* Replaced readShaderFile() usage to readRefShaderFile()

2013-11-25 17:36  robert

	* Added initial render to texture functionality into
	  osgVolume::VolumeScene

2013-11-22 10:27  robert

	* Warning fixes

2013-11-22 09:48  robert

	* From Kristofer Tingdahl, Build fix for svg plugin that makes sure
	  the version of librsvg is at sufficient, and fixed a missing
	  virtual destructor warning.

2013-11-22 09:38  robert

	* Removed trailing spaces, added missing return to last lines

2013-11-21 18:17  robert

	* Added new osgVolume::VolumeScene and
	  osgVolume::MultipassTechnique class shells that will be filled
	  out to provide multi-pass volume rendering that handles mixing of
	  3D meshes with volume rendering and segmentation of volumes via a
	  user defined hull mesh.

2013-11-21 14:21  robert

	* From Stephan Huber, "CLang / LLVM on OS X seems to have a problem
	  compiling the osgGA-serializer. (It was reported before on the
	  list, but the error is hard to track as it shows up only
	  sometimes)
	  
	  I fixed the compile-error with a dedicated destructor of
	  osgGA::GUIEventHandler"

2013-11-21 14:08  robert

	* From Farshid Lashkari, " recently encountered an issue attempting
	  to load an IVE file generated by an older version of OSG. The
	  file contained dxt1 compressed image data with mipmaps. The
	  loaded model would cause crashes when passing the mipmap data to
	  glCompressedTexImage2D. It seems that the size of the data array
	  within the IVE file did not match the computed size from
	  Image::getTotalSizeInBytesIncludingMipmaps(). This essentially
	  made the mipmap offsets invalid within the Image object.
	  
	  I'm not sure if the IVE was simply generated incorrectly, or if
	  the Image::getTotalSizeInBytesIncludingMipmaps() was modified
	  since the file was generated. Either way, I added a simple check
	  in the IVE loader so that it clears the mipmap offsets if the
	  actual data size does not match the computed data size. This
	  seems like a safe fallback since the mipmap data can be
	  automatically generated, and it fixes the problem in my case.
	  
	  Also, while looking into this issue, I noticed that the
	  osgDB::InputStream class applies the serialized image allocation
	  mode. However, since the serializer is allocating the image data
	  itself, it seems like it should force the allocation mode to
	  USE_NEW_DELETE.
	  "

2013-11-21 13:59  robert

	* From Farshid Lashkari, "I recently encountered an issue
	  attempting to load an IVE file generated by an older version of
	  OSG. The file contained dxt1 compressed image data with mipmaps.
	  The loaded model would cause crashes when passing the mipmap data
	  to glCompressedTexImage2D. It seems that the size of the data
	  array within the IVE file did not match the computed size from
	  Image::getTotalSizeInBytesIncludingMipmaps(). This essentially
	  made the mipmap offsets invalid within the Image object.
	  
	  I'm not sure if the IVE was simply generated incorrectly, or if
	  the Image::getTotalSizeInBytesIncludingMipmaps() was modified
	  since the file was generated. Either way, I added a simple check
	  in the IVE loader so that it clears the mipmap offsets if the
	  actual data size does not match the computed data size. This
	  seems like a safe fallback since the mipmap data can be
	  automatically generated, and it fixes the problem in my case.
	  
	  Also, while looking into this issue, I noticed that the
	  osgDB::InputStream class applies the serialized image allocation
	  mode. However, since the serializer is allocating the image data
	  itself, it seems like it should force the allocation mode to
	  USE_NEW_DELETE.
	  "

2013-11-21 11:02  robert

	* Converted std::max to osg::maximum to fix VS2013 build error

2013-11-21 10:31  robert

	* Added Geometry::drawVertexArraysomplemetation(..) and
	  drawPrimitivesImplemenation(..) methods that are called from
	  drawImplementation(..). These new vertex methods
	  allow subclasses from osg::Geometry to specialize the vertex
	  array setup or how the primitives are dispatched to OpenGL.

2013-11-18 14:21  robert

	* From Stephan Huber, "minor ios-fixes/-enhancements
	  
	  * force _OPENTHREADS_ATOMIC_USE_BSD_ATOMIC for IOS device +
	  simulator as the test does not pick the right implementation
	  * fixed a small compile-bug for iphone-example
	  * added a check to prevent multiple realization of a
	  GraphicsWindowIOS-object
	  "

2013-11-18 13:31  robert

	* From Stephan Huber, compile fix for OpenGL ES on iOS.

2013-11-18 13:25  robert

	* From Stephan Huber, * GUIEventAdapter: add support for getting
	  normalized touch points
	  * MultiTouchTrackball: some code cleanup and support for
	  normalized touch-points
	  * oscdevice: receiving and sending multi-touch-events via the
	  Cursor2D-profile from TUIO
	  * added some documentation

2013-11-18 12:46  robert

	* Added panning and zooming functionality to transfer function UI
	  prototype code.

2013-11-18 12:45  robert

	* Added BoundingBox::contains(const vec_type& v, value_type
	  epsilon) method with new epsilon parameter to make it easier to
	  test for containment in the presence of numerical errors

2013-11-15 16:15  robert

	* Moved Handled propety from GUIEventAdapter to Event base class.
	  
	  Added CameraManipulator::finishAnimation() method to allow
	  application code to stop any animation/throw of manipulators.

2013-11-12 14:21  robert

	* Restored the rescaleToZeroToOneRange() to address rendering
	  issues.

2013-11-11 10:55  robert

	* Removed unused variables

2013-11-08 12:28  robert

	* From Stepan Huber, "attached are my changes for the osc, zeroconf
	  and resthttp-plugin to use the new event-class. I refactored the
	  osgoscdevice-example so that it’s working again. "

2013-11-08 12:26  robert

	* Added support for assinging and display transfer functions

2013-11-08 12:25  robert

	* Quietened down debug messages

2013-11-07 12:37  robert

	* Changed the LineSegmentIntersector to RayIntersector to provide
	  more reliable intersections with flat meshes.

2013-11-07 12:35  robert

	* Added osgUtil::Intersector::PrecisionHint member and set it's
	  default to USE_DOUBLE_COMPUTATIONS, and implemented support for
	  use double or float maths internally in LineSegmentIntersector
	  and RayIntersector classes

2013-11-06 09:50  robert

	* Re-enabled the disable of the transfer function

2013-11-06 09:49  robert

	* Fixed handling of web cams

2013-11-06 09:23  robert

	* Introduced a cast(T) method into the ImageUtils template functor
	  to allow code reading images to handle casting from source data
	  to a form that a user can use more conviently

2013-11-06 09:20  robert

	* Restructed the call to avformat_open_input to provide more
	  information.

2013-11-05 15:23  robert

	* Fixed typo

2013-11-01 14:40  robert

	* From Stephan Huber, "Build Problem with osgGA at MacOS with Xcode
	  5"..."attached you'll find a possible solution for the issue.
	  This will add a new option to cmake called
	  OSG_CXX_LANGUAGE_STANDARD which defaults to C++11. If you set it
	  to C++98 it will setup the project accordingly."

2013-10-28 17:46  robert

	* Added initial shell of new osgtransferfunction example that will
	  be tested bed for upcomming transfer function editing UI.

2013-10-28 12:03  robert

	* From Likasz Izebski, "added support for etc2/eac compression"

2013-10-25 15:47  robert

	* Added explict setting of the PolygonMode to over the distion mesh
	  being toggled to wireframe.

2013-10-25 14:54  robert

	* Introduce new osgGA::Event and osgGA::EventHandler base classes
	  that the old GUIEventAdapter and GUIEventHandler now subclass
	  from.
	  
	  The new osgGA::Event is written to support more generic events
	  than the original GUIEventAdapter which are written for keyboard
	  and mouse events.

2013-10-25 14:46  robert

	* Remoed -fpermissive

2013-10-25 09:02  robert

	* Fixed warning

2013-10-24 20:22  robert

	* Fixed warning

2013-10-24 19:56  robert

	* Removed depreated glib call

2013-10-24 19:32  robert

	* Fixed FileInfo self intialization bug

2013-10-24 17:43  robert

	* Fixed build problems with the
	  OSG_USE_REF_PTR_IMPLICIT_OUTPUT_CONVERSION off

2013-10-24 12:15  robert

	* From Stephan Huber, "attached you’ll find a small enhancement for
	  present3d. Now you can get advanced help via —help-all etc
	  (similar to osgviewer)"

2013-10-24 10:10  robert

	* From Stephan Huber, add support for controlling the
	  OSXMenubarBehavior set by DisplaySettings.

2013-10-24 09:06  robert

	* Cleaned up addChild/getChild/setChild/getNumChildren methods and
	  added readNodeFile, readImageFile and readObjectFile functions

2013-10-23 16:17  robert

	* Added support for
	  Group::addChild/setChild/getChild/getNumChildren.

2013-10-22 19:12  robert

	* Merged changes to DisplaySettings from Stephan Huber in prep for
	  controlling the menu hiding behaviour under OSX.
	  
	  Added new WindowSystemInterface::setDisplaySettings() method to
	  provide a mechanism for passing settings onto the
	  WindowSystemInterface so it can then set up the system
	  appropriately.
	  
	  Added assignment of the DisplaySettings to the
	  WindowSystemInterface in Viewer/ComppsiteViewer::realize().

2013-10-22 18:58  robert

	* Preliminary remapping of internalFormat for GL3 core profile

2013-10-22 16:28  robert

	* Fixed warnings

2013-10-22 11:32  robert

	* From Colin McDonald, "The osgt/osgb file formats output a
	  scenegraph node with the type
	  set to "SCENE" in the file header. But if the file is stored and
	  then extracted again from an osga archive this header info is
	  lost,
	  and the resulting file is just an "OBJECT". Possibly other plugin
	  operations would have the same effect. The osgt/osgb plugin won't
	  then return the scenegraph contents.
	  
	  I have updated the osgt/osgb plugin to return a node from an
	  "OBJECT"
	  file."

2013-10-22 11:26  robert

	* From Colin McDonald, "The osgb file reader uses seek to position
	  within the file.
	  But the nested stream implementation for osga archive files
	  doesn't
	  support seeking. So osgb files can't currently be used in an osga
	  archive e.g. if osgdem is used to output a osgb format database
	  it
	  can't be packaged in an archive file, in the same manner that ive
	  files could.
	  
	  I've added seek support to the osga nested stream
	  implementation."

2013-10-22 11:18  robert

	* Fixed handling of osg::Program so that it's not overriden by
	  shader composition when enabled

2013-10-21 16:35  robert

	* Added State::releaseGLObjects() and
	  ShaderComposer::releaseGLObjects() to avoid problems with cleanup
	  of graphics context

2013-10-21 09:54  robert

	* Build fixes for clang

2013-10-18 09:57  robert

	* From Farshid Lashkari, "previously discussed change to the dae
	  loader which applies the node ID as a "dae_node_id" user value."

2013-10-18 08:37  robert

	* From Vladimir Chebeav, fix for removal of nested callbacks

2013-10-18 07:55  robert

	* From Konstantin Matveyev, "Multiple light fix in FBX-importer"

2013-10-18 07:52  robert

	* From Colin McDonald, "Some missing updates to the serializer
	  static build support."

2013-10-18 07:31  robert

	* From Andreas Henne, "in my application I use the
	  TrackballDragger, the ScaleAxisDragger and the
	  TranslateAxisDragger. Unfortunately these draggers are very thin
	  and they do not provide methods to change their visual
	  appearance. Another problem that I noticed is that lighting on
	  the cones and boxes of the TranslateAxisDragger and
	  ScaleAxisDragger is incorrect when the draggers are scaled due to
	  not normalized normals. This small patch adresses these problems,
	  providing methods to make the draggers thicker. I have attached a
	  zip archive containing the corresponding files and also a
	  modified osgManipulator example that makes use of the
	  modifications. I don't want to retain any copyright."

2013-10-17 18:29  robert

	* Fix for error in getting the uniform block max name length, fix
	  suggested by Christopher Fennell.

2013-10-17 14:02  robert

	* From Stephan Huber, build fix

2013-10-10 20:43  robert

	* Added set/get to the ImageSerializer and removed some redudent
	  comments

2013-10-10 20:42  robert

	* From Pjotr Svetachov, "With the new osg::Geometry the binding for
	  arrays now default to undefined. This breaks previously working
	  code in osgAnimation::RigTransformHardware where the arrays got
	  an undefined bounding and because of this the bone indices and
	  weights were not loaded by the shader. Here is a little patch to
	  fix this."

2013-10-10 14:45  robert

	* From Laurens Voerman, compile fix for VisualStudio

2013-10-10 14:41  robert

	* Laurens Voerman, "my cmake (2.8.10.2 generating for Visual Studio
	  11 Win64) doesn't like
	  include(${CMAKE_MODULE_PATH}/FindPackageHandleStandardArgs.cmake)
	  in CMakeModules/FindLua52.cmake
	  changing to a more common
	  include(FindPackageHandleStandardArgs)
	  solves my problem."

2013-10-10 09:28  robert

	* Added get/set method to Serializer to allow pointer passing
	  without going through InputStream/OutputStream.

2013-10-09 15:32  robert

	* Implemented preliminary readNode/readImage support in the lua
	  plugin allow a lua script to create a scene graph as return it.

2013-10-07 10:05  robert

	* From Stephan Huber, "attached you’ll find a bunch of fixes +
	  enhancements for iOS and OS X based on current trunk. I
	  incorporated + tested the submission from Colin Cochran, so his
	  submission is not needed anymore.
	  
	  * fixed a bug with multi-touch and touch-id-generation on iOS and
	  OS X. (will fix a bug reported by Colin Cochran, without ditching
	  the existing logic)
	  * removed unnecessary warning-flagss when generating
	  xcode-projects via cmake, will enable the usage of
	  OSG_AGGRESSIVE_WARNING_FLAGS
	  * added support for 10.9 (OS X)
	  * new cmake-variable: IPHONE_VERSION_MIN, this will set the
	  deployment-target (previously hard-coded) If you set the
	  IPHONE_VERSION_MIN to something like 7.0 osg gets compiled also
	  for 64bit (amd64)
	  * cmake defaults now to the clang compiler if IPHONE_VERSION_MIN
	  > 4.2
	  * cmake now sets some xcode-settings so the compiler uses the
	  c++98-standard (clang defaults to c++11, w/o this I got a lot of
	  linking errors)
	  * removed include-dir for avfoundation-plugin as not needed on
	  OSX/IOS.
	  * enhanced the ios-example, will now show multitouch-information
	  on a hud (similar to the osgmultitouch-example), and more
	  importantly, will compile + link out of the box
	  * small enhancements for the osc-device-plugin (send only one msg
	  for MOVE/DRAG, even if multiple msgs/event is enabled)
	  * better memory-handling for the zeroconf-plugin
	  * fixed a possible bug in the rest-http-plugin when receiving
	  mouse-events.
	  * incorporated a fix from Colin Cochran "forwarded touch events
	  are not transformed into the GL UIView“
	  "

2013-10-07 09:33  robert

	* Cleaned up line endings

2013-10-04 20:42  robert

	* Added support for automatically select Lua 5.2 is it's available,
	  then falling back to checking for Lua 5.1 otherwise.

2013-10-04 19:48  robert

	* Moved code across to use lua_userdata to manage pointer to
	  osg::Object that is ref()/unref()

2013-10-04 16:30  robert

	* Added support for Lua 5.2 and osg::Object creation from within
	  Lua scripts.

2013-10-04 16:29  robert

	* Added createObject() interface

2013-10-04 16:28  robert

	* Updated version number after 3.3.0 dev release

2013-10-03 16:20  robert

	* Fixed errors in Contributors list

2013-10-03 08:45  robert

	* From Jan Peciva, RayIntersector implementation

2013-10-02 13:59  robert

	* From Colin McDonald and Robert Osfield, "When a serializer shared
	  library is loaded it registers all of
	  the wrappers it contains. The registration creates a prototype
	  object for all of the wrapped classes. For some of the
	  higher-level
	  classes this can be a bit heavy.
	  
	  I noticed a problem with a model which required a single class
	  from
	  osgSim. When osgdb_serializers_osgsim.so was loaded it registered
	  wrappers and created prototype objects for all of the osgSim
	  classes,
	  including osgSim::ScalarBar. The constructor for that class
	  creates
	  several drawables, and loads arial.ttf using the freetype plugin.
	  I
	  don't need that, and don't even ship the font or plugin with my
	  application, resulting in an unexplained warning message loading
	  the model.
	  
	  I've modified the ObjectWrapper class to defer the prototype
	  object
	  creation until if & when actually required."

2013-10-02 11:29  robert

	* From Dmitry Marakasov, "These are FreeBSD bits for
	  src/osgPlugins/osc/osc/OscHostEndianness.h,
	  required to build newever OSG on this OS. Also corrects file name
	  in the error message - I was confused not to find
	  OSCHostEndianness.h
	  after I've got this error.
	  
	  Tested by successfully building OSG 3.2.0 with this patch on
	  FreeBSD
	  9.1."

2013-10-02 11:28  robert

	* Re-ordered the public/protected sections to keep the public
	  section all together

2013-10-02 11:09  robert

	* From Björn Hein, "it seems that for generating "per vertex
	  normals" as stated in the
	  comment, two of them are missing. This results in wrong display
	  of
	  STL-files regarding normals. Following simple fix seems to work:
	  
	  Index: ReaderWriterSTL.cpp
	  ===================================================================
	  --- ReaderWriterSTL.cpp (Revision 13797)
	  +++ ReaderWriterSTL.cpp (Arbeitskopie)
	  @@ -108,6 +108,8 @@
	  ++itr)
	  {
	  perVertexNormals->push_back(*itr);
	  + perVertexNormals->push_back(*itr);
	  + perVertexNormals->push_back(*itr);
	  }
	  
	  geom->setNormalArray(perVertexNormals.get(),
	  osg::Array::BIND_PER_VERTEX);
	  "

2013-10-01 19:34  robert

	* Fixed build with no automatic ref_ptr<> conversion

2013-10-01 19:31  robert

	* Updated AUTHORS files

2013-10-01 19:00  robert

	* Updated ChangeLog in prep for dev release

2013-10-01 17:01  robert

	* From Aurelien Albert, "I'm working with OSG and a customer
	  low-level OpenGL library.
	  
	  To make easier "lazy apply" on the customer OpenGL shaders, the
	  easiest way was to add an accessor to current OSG state's
	  UniformMap.
	  
	  I've also added accessors for modes and texture, since it could
	  be usefull in the same way.
	  
	  All methods are const, so I think there is no side-effects."

2013-10-01 16:20  robert

	* From Björn Blissing, "I propose making the following outputs a
	  little bit more silent. In my mind it would suffice with
	  OSG_DEBUG (compared to OSG_NOTICE) for these information
	  messages."

2013-10-01 09:37  robert

	* From Christopher Baker, submitted by Alberto Luacas, "there is a
	  bug report in the Ubuntu tracker that points to a bug when
	  loading multiple VRML files in parallel. Christopher R. Baker has
	  detected this bug and crafted a patch. In addition, libcoin has
	  to be
	  also built with the "--enable-threadsafe" option.
	  
	  I copy here his report, extracted from
	  (https://bugs.launchpad.net/ubuntu/+source/openscenegraph/+bug/1211993)
	  and attach his fix. All credit is due to him:
	  
	  «
	  There are three instances of a classical method-local-static
	  multithreaded initialization bug in the Inventor plugin for OSG
	  that
	  trigger various memory faults when reading multiple VRML files in
	  parallel via osgDB::readNodeFile. These bugs are of the form:
	  
	  static std::map<Stuff,OtherStuff> myHandyMap;
	  static bool once = true;
	  if(once) { ...fill myHandyMap; once = false }
	  ... use myHandyMap;
	  
	  To repeat: try loading multiple VRML files from multiple threads.
	  The
	  liklihood of the bug depends on many factors, but my application,
	  which
	  parallel-loads some dozens of small (<100K) VRML files on
	  startup,
	  triggers this problem 25% of the time or more.
	  
	  The attached patch (inventor-plugin-multithread.patch) rectifies
	  this
	  problem by:
	  
	  1 - Inheriting MyHandyMap from std::map, then
	  2 - Moving the map initialization into the derived constructor,
	  which
	  3 - Is intrinsically protected from multithread issues by g++
	  (and is
	  part of the C++ standard), unless you pass
	  -fno-threadsafe-statics,
	  which is strongly discouraged by the man page.
	  »
	  "

2013-10-01 09:11  robert

	* From Adrien Grandemange, "On Windows 7 and 8, mouse messages are
	  generated in addition to touch messages, which leads to duplicate
	  PUSH, DRAG and RELEASE events in OSG. Besides, the mouse and
	  touch messages referring to the same user input are not
	  necessarily sent at the same time, due to gesture translation
	  done by Windows by default, such as double-tap => double-click
	  and long-push => right-click.
	  The delay between the 2 types of messages is more noticeable on
	  Windows 8 and leads to serious disruptions in our application.
	  
	  Mouse messages generated by touch input are only present for
	  legacy support. I think they should be filtered out by OSG (real
	  click events originating from a physical mouse will of course
	  still go through).
	  
	  This is what this patch does, according to this suggestion:
	  http://msdn.microsoft.com/en-us/library/dd693088%28v=VS.85%29.aspx
	  (third issue in this page)."

2013-10-01 09:05  robert

	* From Thomas Hogarth, "Attached is a small build fix for
	  PointSprite when compiling under GLES2 (r13788)
	  
	  GL_POINT_SPRITE_OES does not exist in GLES2, instead you just
	  draw using GL_POINTS then use gl_PointSize in a vertex shader to
	  set the size."

2013-09-30 18:32  robert

	* From Jeffrey Kinross, "I ran into an issue with case sensitivity
	  on OS X and the OSXAVFoundation code.
	  In CMakeList.txt there is a case sensitivity issue which a fix
	  was posted by Robert Osfield in the users forum.
	  
	  I also had to rename the files OSXAvFoundationCoreVideoTexture.h
	  and OSXAvFoundationCoreVideoTexture.cpp to
	  OSXAVFoundationCoreVideoTexture.h and
	  OSXAVFoundationCoreVideoTexture.cpp
	  
	  Finally in OSXAvFoundationCoreVideoTexture.cpp the include
	  OSXAVFoundationVideo.H was updated to OSXAVFoundationVideo.h"

2013-09-30 18:15  robert

	* From Farshid Lashkari, "I have a scene that makes heavy use of
	  the StateSet::compare method and my profiler showed that a lot of
	  time was being spent inside it. I made a small change to the
	  method so that it performs a quick size comparison between the
	  attribute/mode lists and bin mode before iterating through all
	  the attributes. This made a noticeable improvement in my scene.
	  I've attached the change."

2013-09-30 10:28  robert

	* 

2013-09-27 18:43  robert

	* Unified Vec/Plane/Quat handling code.

2013-09-27 13:04  robert

	* Added support for getting Vec* and Matrix objects from Lua stack
	  and assigning them as OSG object properties.

2013-09-26 17:27  robert

	* Initial cut of setting and getting osg::Object properties within
	  Lua scripts

2013-09-24 15:17  robert

	* Added support for passing parameters in and out of scripts.
	  
	  Implemented support for osg::ValueObject in LuaScriptEngine.

2013-09-24 15:08  robert

	* Changed NodeVisitor so that is subclasses from osg::Object rather
	  than osg::Referenced to enable it to be used with serialization
	  and scripting

2013-09-24 08:56  robert

	* Removed redundent spaces

2013-09-23 14:10  robert

	* Added test for osgGA::GUIEventAdapter

2013-09-20 15:43  robert

	* Removed unnceccesary setNumChildrenRequiringUpdateTraversal from
	  VolumeTile constructor.

2013-09-20 10:44  robert

	* Added initial cut of white and black lists

2013-09-20 10:25  robert

	* Added compoundClassName() convinience method to standardize the
	  generation of the compoundClassName.

2013-09-20 10:04  robert

	* Added type maps to help with querrying supported type names

2013-09-19 16:19  robert

	* Introduce osgDB::PropetyInterface class that provided a generic
	  interface for get/setting properties on scene graph objects,
	  utilizing the osgDB serializers to do
	  the actual interface query and set/gets.

2013-09-19 16:18  robert

	* Removed unneccessary return

2013-09-11 15:44  robert

	* Added access methods to Serializer to help with using wrappers
	  for other purposes such as script integration.
	  
	  Added Vec*i and Vec*ui support to serializers

2013-09-10 15:17  robert

	* From Giuseppe Donvito, "I'm using OSG 320 and I need to flush a
	  DDS 3D texture on disk.
	  I found a bug on DDS ReaderWriter that generates a false positive
	  on a guard for the size check on writing operation. This is due
	  to a wrong imageSize computation that uses
	  img->getImageSizeInBytes() method instead of
	  img->getTotalSizeInBytes(), that actually ignores the r()
	  dimension, contrariwise taken into account by the function
	  ComputeImageSizeInBytes() later.
	  
	  The line 1062 on file ReaderWriterDDS.cpp should be fixed with:
	  [code]unsigned int imageSize = img->getTotalSizeInBytes();[/code]
	  "

2013-09-10 13:29  robert

	* From Giuseppe Donvito, Fixed typo of "CLEAR_GLOBAL_STATESET =
	  0x16," to indended "CLEAR_GLOBAL_STATESET = "0x10".

2013-09-10 09:23  robert

	* Added osgPresentation::Show node and implementations with basic
	  property reporting for various internal nodes of presentation
	  graph

2013-09-09 16:02  robert

	* From Wang Rui, "The Python header will look for its libraries
	  using "#pragma comment(lib,"python32_d.lib")" for MSVC. So
	  user-specified libraries will not really be set for the
	  osgdb_python plugin. This small fix may help locate the Python
	  libraries after putting the CMakeLists.txt into
	  src/osgPlugins/python
	  
	  "

2013-09-09 14:58  robert

	* From Colin Cochran, OES support for point sprites

2013-09-09 13:33  robert

	* From Colin McDonald, "Add test for GL_EXT_framebuffer_object
	  extension : osg uses osg::FBOExtensions to check if Frame Buffer
	  Objects are
	  available. But this just checks if the fbo functions can be
	  called.
	  It doesn't check if the OpenGL renderer supports fbos. For
	  indirect
	  rendering on linux the client side capability may be different
	  from
	  the display server, which can lead to mipmapped textures failing
	  to
	  render. I've added a fbo extension check.
	  "

2013-09-09 12:44  robert

	* From Ulrich Hertlein, "Patch for FindAVFoundation to work with OS
	  X 10.9"

2013-09-09 12:37  robert

	* From Wang Rui, "Some developers report that the osgviewerMFC
	  example is broken in 3.2, in which depth test is not enabled by
	  default so all models loaded look awkward. I submit this patch to
	  make it work again. I haven't gone deep to check why previous
	  example goes wrong in newer version but I believe the problem was
	  because the newly created camera object missed some important
	  global statesets before set as the main camera."

2013-09-09 12:33  robert

	* From Laurens Voerman, "two minor fixes, both in a CMakeList.txt
	  file,
	  
	  1> osgmultiplemovies example does not use SDL so needs no link to
	  SDL
	  
	  2> Added header files to "Plugins osg" project, so visual studio
	  can find the source of
	  OSG_WARN << "AsciiInputIterator::readProperty(): Unmatched
	  property "
	  "

2013-09-06 09:35  robert

	* Initial cut of Audio/Volume/Movie/Image presentation objects

2013-09-05 10:23  robert

	* From Colin McDonald, "Attached are some fixes to build osg using
	  the Solaris Studio compiler.
	  I've also checked the modified files still build ok with other
	  compilers (Linux gcc, Windows Visual Studio).
	  
	  osgDB/OutputStream.cpp and osgPlugins/lws/SceneLoader.cpp require
	  stdlib.h for atoi use.
	  
	  In osg/Uniform.cpp the compiler complains that base_class is
	  unknown
	  unless I add a class name qualifier.
	  
	  Not a build fix, but I spotted a typo in osgUtil/SceneView."

2013-09-05 10:08  robert

	* From Laurens Voerman, "like the "Bug in ProxyNode serializer"
	  Farshid Lashkari found (svn submit 13754) the PagedLOD serializer
	  attempts to read begin and and brackets.
	  Fix is identical (don't read brackets when num_chidren is zero)
	  and applies both to trunk and 3.2 branch."

2013-09-05 10:04  robert

	* Fixed warnings

2013-09-05 08:42  robert

	* From Alberto Luaces, "current versions of ffmpeg render
	  «url_feof» macro as obsolete. The fix
	  is very simple and it is contained in the attached file."

2013-09-05 08:22  robert

	* Added missing Model.cpp

2013-09-04 17:27  robert

	* Moved the property test from the model to presentation to test
	  out the property inheritance scheme

2013-09-04 16:25  robert

	* Added PrintProperties visitor

2013-09-04 15:39  robert

	* Added PrintPropertiesAction to osgPresentation

2013-09-04 10:33  robert

	* Added Action class NodeVisitor that supports osgPresentation
	  nodes.

2013-09-03 15:50  robert

	* Added test for osgPresentatation::Group::getSupportedProperties()

2013-09-03 10:17  robert

	* Added beginings of Text implementation

2013-09-02 10:56  robert

	* From Farshid Lashkari, "The ProxyNode serializer was not
	  correctly reading the "Children" field. It conditionally writes
	  the begin/end brackets, depending on whether it has children.
	  However, during input it unconditionally attempts to read the
	  begin/end brackets. I've modified the code to only read the
	  brackets if it has children."

2013-09-02 10:56  robert

	* Refactored the use of epsilon in the clamping of the start/end
	  points of the LineSegmentIntersector to better handle numerical
	  precision issues.

2013-09-02 09:12  robert

	* Fixed double copy in StackedTransform copy constructor

2013-09-02 08:29  robert

	* Added IO test for new osgPresentation nodes

2013-09-01 17:24  robert

	* Added Audio, Image, Movie, Model and Volume class to
	  osgPresentation.

2013-08-23 16:47  robert

	* Fixed build

2013-08-23 11:42  robert

	* Added color property to FontData parsing

2013-08-22 13:39  robert

	* Quitened down debug message

2013-08-22 12:37  robert

	* Removed debug messages

2013-08-22 12:07  robert

	* Quitened down debug message

2013-08-22 11:18  robert

	* Quitened down debug message

2013-08-22 10:09  robert

	* Added warning when model file has not be found

2013-08-22 10:05  robert

	* Reduced debug message level, and added a notify message for when
	  an image isn't loaded

2013-08-22 07:49  robert

	* Added test for serializers and fixed serializers

2013-08-21 19:54  robert

	* Added initial classes for present3D refactor

2013-08-18 18:10  robert

	* Moved old osgPresentation source files to
	  osgPresentation/deprecated subdirectory.

2013-08-18 16:59  robert

	* Moved old present3D sources into local deprecated directory to
	  clean up the main present3D source directory for future
	  refactored present3D

2013-08-09 16:51  robert

	* Added initial cut of basic scripting support, introducing an
	  osg::Script object to wrap up the individual scripts,
	  osg::ScriptCallback for assigning a Script as node callback and
	  an osg::ScriptEngine base class that plugins implement to
	  provided support for specific scripting languages.
	  
	  Provided are lua, python and V8 (for javascript) plugins that
	  just open up enough of a link to the respective libs to run a
	  script, there is no scene graph <-> script communication in
	  current implementation.

2013-08-09 11:00  robert

	* Removed CameraNode reference

2013-08-09 07:46  robert

	* Removed unused includes

2013-08-09 07:38  robert

	* Removed old cursor code

2013-08-08 17:21  robert

	* Added translucent version of cushion which isn't depth tested to
	  enable one to see the cursor even when it's behind other objects

2013-08-08 16:49  robert

	* Added osgPresentation::Cursor class to wrap up 3D cursor in the
	  scene functionality

2013-08-07 17:08  robert

	* Added osgpresentation example as a test bed for new
	  osgPresentation object model.
	  
	  First cut of example test bed is to test how easy it is to build
	  against Lua, V8 and Python for purposes of running embedded
	  scripts.

2013-08-05 12:00  robert

	* From Aurelien Albert, "I've go some problem with the method
	  "State_Utils::replace" : if the original_phrase is empty, it
	  leads to an infinite loop.
	  
	  Here is a path to prevent this."

2013-08-01 17:38  robert

	* Added missing initializer for _epsilon

2013-08-01 11:25  robert

	* From Anish Thomas, added catch for to an empty DrawElementsUInt
	  creation.

2013-08-01 10:38  robert

	* Updated ChangeLog and AUTHORS file

2013-08-01 10:28  robert

	* From Ulrich Hertlein, "Based on the exchange on osg-users I went
	  ahead and reworked shp/XBaseParser to avoid
	  weird behaviour (closing stdin) and leaking file descriptors, as
	  well as some const-ness."

2013-08-01 10:04  robert

	* From Sebastian Messerschmidt, "Seems like your re-factoring
	  didn't really produces the correct results.
	  You can check with the tester2.flt provided earlier and check
	  with the result image.
	  I double checked this with OpenFlight creator, and it seems the
	  yaw is broken.
	  
	  With my initial quaternion version is seems correct and if I
	  change the
	  
	  
	  float cos_yaw = cosf(osg::inDegrees(yaw));
	  float sin_yaw = sinf(osg::inDegrees(yaw));
	  
	  to be
	  float cos_yaw = cosf(osg::inDegrees(-yaw));
	  float sin_yaw = sinf(osg::inDegrees(-yaw));
	  
	  it seems to work as well."

2013-08-01 10:00  robert

	* From Tom Jolley, "I found a couple more bugs after closely
	  looking at the small piece of deprecated geometry in my model.
	  There were problems with more than one primitive in a couple
	  places. The first was the number of vertices were not being
	  accumulated for DrawArraysPrimitiveType (caused another crash).
	  The second is I had to move target_vindex and source_pindex
	  before the PrimitiveSetList loop so they don't get reset on the
	  next primitive (otherwise you end up with a lot of zeros in per
	  vertex lists)."

2013-08-01 07:19  robert

	* Added osg::RenderInfo::pushRenderBin()/popRenderBin() and
	  RenderInfo::getRenderBinStack() and getCameraStack() access
	  methods for getting access to the current RenderBin/RenderStage.

2013-07-31 13:11  robert

	* Added Intersector::get/setEpsilon(double) to allow users to
	  control what epsilon is used by the LineSegmentIntersector when
	  doing testing of itersections with bounding boxes

2013-07-31 07:11  robert

	* From Aurelien Albert, "Here is the code to get access to OpenGL
	  handle of an osg::FrameBufferObject"

2013-07-31 06:56  robert

	* From Tom Jolly, "I ran across this error reading one of our older
	  files. An iterator was being changed inside a loop that caused a
	  crash."

2013-07-31 06:42  robert

	* From Sergey Kurdakov, fixed GLES2 invalid enumerant warning by
	  disabling the check against GL_MAX_TEXTURE_COORDS under GLES.

2013-07-30 06:39  robert

	* Changed default cull mask to match the left cull mask so that
	  mono rendering of presentations with left/right stereo
	  images/movies works fine.

2013-07-30 06:36  robert

	* Removed trailing spaces

2013-07-30 06:12  robert

	* Merged from OSG-3.2 branch the removal of check for Asio under
	  Windows

2013-07-24 17:30  robert

	* Changed default of serialize draw to off

2013-07-24 14:24  robert

	* Pulled in READE, NEWS and AUTHORS changes from OSG-3.2 branch.

2013-07-24 13:02  robert

	* Added GL2Extensions::isDrawBuffersSupported() and usage of this
	  in FrameBufferObject.cpp to prevent crash under GLES2 when users
	  attempt to use MRT when it's not supported

2013-07-24 12:51  robert

	* Updated NEWS from OSG-3.2 branch

2013-07-24 12:48  robert

	* Fixed warning

2013-07-24 12:25  robert

	* Updated SO version for post 3.2 era.

2013-07-24 12:17  robert

	* Added getCallbacks() methods

2013-07-23 18:11  robert

	* From Rocco Martino, build fix for compiling against ffmpeg/trunk

2013-07-23 15:28  robert

	* Added NOT ANDROID to force use of posix API when building for
	  Android under Windows

2013-07-23 10:24  robert

	* Added lazy setting of the UserDataContainer to avoid unncessarily
	  create a UserDataContain when an empty description list is passed
	  to Node::setDescriptions(..)

2013-07-23 09:54  robert

	* Fixed crash when open(..) returns an error.

2013-07-23 05:25  robert

	* From Torben Dannhauer, "Please find attached further changes to
	  make library auto detection
	  functional again for some libraries:
	  
	  Find3rdPa..: Fix to find libxml2
	  FindCollada: Rearranged to handle different MSVC versions more
	  effective.
	  This file is already prepared for the upcoming VS 2013.
	  FindNVTT: introduced management of debug libraries (also auto
	  detected).
	  "

2013-07-22 13:31  robert

	* From Andreas Ekstrand, "Attached is a small modification of the
	  Collada writer that protects from crashes due to valArray being
	  NULL in some situations."

2013-07-22 10:15  robert

	* Added FRAME_BUFFER_OBJECT enum

2013-07-22 10:15  robert

	* Updated OpenThreads version

2013-07-19 21:05  robert

	* From Christian Ruzicka, "with the current touch implementation on
	  iOS the touches are not forwarded to parent views because the
	  base implementation is not called. Also see the "Best Practices"
	  in the iOS documentation for event handling:
	  
	  http://developer.apple.com/library/ios/#documentation/EventHandling/Conceptual/EventHandlingiPhoneOS/multitouch_background/multitouch_background.html
	  
	  "If you handle events in a subclass of any other UIKit responder
	  class:
	  - You do not have to implement all of the event handling methods.
	  - In the methods you do implement, be sure to call the superclass
	  implementation. For example, [super touchesBegan:touches
	  withEvent:event]."
	  
	  I added the missing lines and tested it with OSG 3.1.9 and iOS
	  SDK 6.1."

2013-07-19 20:59  robert

	* Added default setting of BIND_PER_VERTEX when applying
	  Geometry::setTexCoordArray()

2013-07-19 17:00  robert

	* Updated OpenThreads version to be in sync with OSG version

2013-07-19 14:55  robert

	* Updated version number for svn/trunk to 3.3.0 for all new feature
	  development

2013-07-19 14:07  robert

	* Updated AUTHORS file for new 3.2 branch

2013-07-19 14:06  robert

	* Updated version number to 3.2.0-rc1 in prep for create the 3.2
	  branch, and 3.2.0-rc1

2013-07-19 10:31  robert

	* Update ChangeLog and AUTHORS files for 3.1.10 dev release

2013-07-19 10:17  robert

	* Updater version for 3.1.10 dev release

2013-07-19 10:11  robert

	* Removed #if 0 #endif block

2013-07-19 09:43  robert

	* Fixed problem with the osgviewerQt code override the default
	  View::Camera without setting it's default state on it's StateSet
	  like View does by default.

2013-07-19 06:56  robert

	* From Johannes Scholz, "as we need to dynamically add and remove
	  Effects to and from our Application, I created a small patch for
	  osgFX/Registry to add the osgFX::Registry::removeEffect(effect*)
	  method and extended osgFX::Registry::Proxy to call removeEffect
	  upon its destruction."

2013-07-19 06:39  robert

	* From Wang Rui, "A very small clerical error in the
	  src/osgViewer/CMakeLists.txt makes MinGW/Cygwin builds fail. Now
	  it is fixed and now OSG works well again with Cygwin. :-) The OSC
	  plugin also needs a small fix to compile with Cygwin, as attached
	  file src/osgPlugins/osc/osc/OscHostEndianness.h shows."

2013-07-19 06:20  robert

	* From Mathieu Marache, "we found that events where not caught when
	  running in ON_DEMAND frame scheme : GraphicsWindow::checkEvents()
	  always return false and GraphicsWindowQt doesn't overload it.
	  
	  here is a simple fix that will return if the list is empty or not
	  and will match the comment in checkEvents()

2013-07-18 20:17  robert

	* Added a dirty() call to Image::setData(..)

2013-07-18 16:29  robert

	* From Torben Dannhauer, "after being absent for more than 12
	  month, I'm very pleased to present my
	  new 3rdparty package (V8).
	  
	  This package is compiled with Visual Studio 2012 Update 3. Some
	  community
	  members complained that these package is very large (indeed), so
	  I
	  introduced 2 versions:
	  - The small version contains the dependencies for several image
	  file formats
	  ( tiff, png, gif, jpeg), as well as zlib, minizip, curl,
	  freetype, glut,
	  gdal and openSSL
	  - The full version will include all libraries which were include
	  in the
	  previous releases of my 3rd party package.
	  
	  Some of the included libraries are released in newer versions, so
	  I adapted
	  the attached CMake module to find these renamed files.
	  
	  I hope you can merge this minor changes soon, since I plan to
	  publish the
	  small 3rdparty package today.
	  "

2013-07-18 16:27  robert

	* From Lionel Lagarde, "The extension name is misspelled. It
	  conflicts with GLEW."

2013-07-02 19:24  robert

	* Updated AUTHORS and ChangeLog for 3.1.9 dev release

2013-07-02 14:35  robert

	* From Laurens Voerman, "With fstream inheritaince now removed the
	  warning can be enabled again."

2013-07-02 14:17  robert

	* From Laurens Voerman, "some of my ive files now generate a
	  warning:
	  Warning, can't assign attribute binding as no has been array
	  assigned to set binding for.
	  
	  I think those are ive's with bumpmaps, but I have not checked
	  yet. The problem is in
	  OpenSceneGraph\src\osgPlugins\ive\Geometry.cpp
	  where the code tries to set Normalize and Binding for a missing
	  Array.
	  I think that code can safely be skipped, considering the write
	  function has a hardcoded write when the array is missing.
	  (introduced in svn rev 13488)
	  
	  modified file (OpenSceneGraph\src\osgPlugins\ive\Geometry.cpp)
	  attached in Zip"

2013-07-02 14:02  robert

	* From Laurens Voerman, "Recent changes cause a few warnings in
	  MSVC 2012
	  svn 13587 From David Callu, warning fixes and removal of spaces
	  at end of lines.
	  
	  this can be fixed by adding a space before the comment opening
	  /*.
	  full modified file
	  (openscenegraph\src\osgplugins\osg\BinaryStreamOperator.h)
	  attached in zip
	  
	  Regards, Laurens.
	  
	  
	  openscenegraph\src\osgplugins\osg\BinaryStreamOperator.h(71):
	  warning C4138: '*/' found outside of comment
	  (OpenSceneGraph\src\osgPlugins\osg\ReaderWriterOSG2.cpp)
	  openscenegraph\src\osgplugins\osg\BinaryStreamOperator.h(73):
	  warning C4138: '*/' found outside of comment
	  (OpenSceneGraph\src\osgPlugins\osg\ReaderWriterOSG2.cpp)
	  openscenegraph\src\osgplugins\osg\BinaryStreamOperator.h(211):
	  warning C4138: '*/' found outside of comment
	  (OpenSceneGraph\src\osgPlugins\osg\ReaderWriterOSG2.cpp)
	  openscenegraph\src\osgplugins\osg\BinaryStreamOperator.h(213):
	  warning C4138: '*/' found outside of comment
	  (OpenSceneGraph\src\osgPlugins\osg\ReaderWriterOSG2.cpp)"

2013-07-02 13:45  robert

	* Restructed handling of the _currentShaderCompositionUniformList
	  in State::apply() and State::apply(const StateSet*) so that it
	  can be used even when shader composition isn't enabled.

2013-07-02 10:32  robert

	* From Aurelien Albert, "Recently I had to integrate a client
	  OpenGL library with OSG. For textures and other StateAttribute
	  I've done that by subclassing osg::StateAttribute and this works
	  well.
	  
	  But for glPrograms, in order to get all osg's uniform management
	  system to work, I had to subclass
	  osg::program::PerContextProgram.
	  
	  Here is a modified version of this class, which add some
	  "virtual" method to allow easy subclassing."

2013-07-02 09:44  robert

	* From Pjotr Svetachov, "The binding of arrays is always set to
	  BIND_UNDEFINED when using the array constructor because the
	  binding parameter is ignored. Here is a fix."

2013-07-02 09:27  robert

	* Added SceneView::Options enum enetries APPLY_GLOBAL_DEFAULTS and
	  CLEAR_GLOBAL_STATESET to control whether a
	  _globalStateSet->clear() and _globalStateSet->setGlobalDefaults()
	  should be called.
	  
	  osgViewer::Renderer doesn't use these enum settings so now no
	  longer has a calls StateSet::clear() or
	  StateSet::setGlobalDefaults() on the osg::Camera's StateSet.
	  Previously these were being
	  called and breaking the ability to attached state to Camera's
	  StateSet.

2013-07-01 16:15  robert

	* From Pjotr Svetachov, "In a submission on June 27th a lot of new
	  array types were added. This modified the osg::Array::Type enum.
	  Because of this s_ArrayNames array in Array.cpp is now not in
	  sync. This can lead to corrupt exports or crashes when writing
	  .osg files because the change added new types in the middle of
	  the enum instead of at the end.
	  
	  Attached is a new Array.cpp to reflect the new array types."

2013-07-01 12:16  robert

	* Updated AUTHORS, ChangeLog for dev release

2013-07-01 10:22  robert

	* Removed BIND_INSTANCE_DIVISOR as they don't yet have any
	  implementation backend to support them.

2013-07-01 09:12  robert

	* From David Callu, "Here a fix for FindFBX.cmake
	  
	  under linux, library name to look for must be fbxsdk instead of
	  libfbxsdk."

2013-07-01 09:10  robert

	* From David Callu, "Here a CMakeLists.txt modified with
	  OSG_AGGRESSIVE_WARNING_FLAGS defined when Clang compilator is
	  used"

2013-07-01 09:09  robert

	* Fixed debug build compile problem

2013-07-01 08:21  robert

	* Reverted the usage of OSG_UNUSED and OT_UNUSED as in hindsight
	  these should never have been merged. Adding code to quieten
	  inappropriate warnings is a bad programming practice and does not
	  desrve a place in the OSG code base.

2013-06-28 15:44  robert

	* From John Kaniarz, "This patch modifies ReaderWriterPNG.cpp to
	  1. Check the bit depth of the passed Image and return an error if
	  not 8 or 16. (not fully featured, but still an improvement over
	  hard coded 8bit for everything)
	  2. Endian swap 16bit image data when on a little endian
	  architecture.
	  "

2013-06-28 14:47  robert

	* From Alberto Luaces, "Documentation for -p and --speed options in
	  osgviewer"

2013-06-28 14:38  robert

	* From Marcel Pursche, fixed checking of destination dimensions in
	  osg::copyImage.

2013-06-28 14:32  robert

	* From Lilin Xiong, "When writing proxyNode to ive file, we forget
	  "LoadingExternalReferenceMode ". Add some code to fix this.
	  
	  if (out->getVersion() >= VERSION_0045)
	  {
	  out->writeInt(getLoadingExternalReferenceMode());
	  }
	  
	  if (in->getVersion() >= VERSION_0045)
	  {
	  setLoadExternalReferenceFiles(
	  (osg::ProxyNode::LoadingExternalReferenceMode)in->readInt() );
	  }
	  "

2013-06-28 14:21  robert

	* From Gill Peacegood, "fix for a memory leak in the
	  DelaunayConstraint class"

2013-06-28 14:08  robert

	* From Laurens Voerman, "the current version of BufferObject causes
	  a huge amount of warnings in Visual Studio 2012 like:
	  
	  OpenSceneGraph/include\osg/BufferObject(701): warning C4138: '*/'
	  found outside of comment
	  (E:\osg\osgSvn\OpenSceneGraph\src\osg\Array.cpp)
	  
	  adding a space before /* fixes the problem
	  void removeClient(osg::Object * /*client*/) { --_numClients; }
	  "

2013-06-28 14:07  robert

	* Fixed handling of DISPLAY=127.0.0.1:2 usage.

2013-06-28 13:43  robert

	* From Aurelien Albert, Added support for glPrimitiveRestartIndex.
	  
	  "The idea of this new OpenGL feature is :
	  
	  - set RestartIndex = "n"
	  - draw elements strip
	  -> when the index is "n", the strip is "stopped" and restarted
	  
	  It's very usefull for drawing tiles with a single strip and a
	  "restart" at the end of each row.
	  
	  The idea a an OSG StateAttribute is :
	  
	  Usually we use to build geometry from code, because software
	  modelers rarely support it (and 3d file formats doesn't support
	  it) :
	  
	  -RootNode <= "PrimitiveRestartIndex=0" // So now, we know that
	  our restart index is 0 for all drawables under this node
	  |
	  - Drawable 1 : triangles => as usual
	  |
	  - Drawable 2 : triangles strip => as usual
	  |
	  - Drawable 3 : triangles strip + "GL_PRIMITIVE_RESTART" mode = ON
	  => use the restart index
	  |
	  - Drawable 4 : triangles strip + "GL_PRIMITIVE_RESTART" mode = ON
	  => use the restart index
	  |
	  - Drawable 5 : triangles strip => as usual
	  
	  
	  With a StateAttribute, it's easy for the developper to say "0
	  will be my restart index for all this object" and then activate
	  the mode only on some nodes.
	  
	  The main problem is if you set and restart index value which is
	  not included in the vertex array (for exemple set restart index =
	  100 but you have only 50 vertex). There is no problem with
	  OpenGL, but some OSG algorithms will try to access the
	  vertex[100] and will segfault.
	  
	  To solve this, I think there is two ways :
	  
	  1/ add restart index in osg::PrimitiveSet and use this value in
	  all algorithms. It's a lot of work, maybe dangerous, and it
	  concern only a few situations : developpers who use this
	  extension should be aware of advanced OpenGL (and OSG) data
	  management
	  
	  2/ use a StateAttribute, and choose a "correct" restart index. In
	  my applications, I always use "0" as a restart index and
	  duplicate the first vertex (vertex[0] = vertex[1]). So there is
	  no difference for OpenGL and all OSG algorithms works properly.
	  "

2013-06-28 12:45  robert

	* Added handling of an odd number rows in the capsule rendering and
	  primitive calculation.

2013-06-28 12:00  robert

	* From David Callu, warning fixes and removal of spaces at end of
	  lines.

2013-06-28 10:59  robert

	* From David Callu, "in
	  osgViewer::WoWVxDisplay::WoWVxDisplay(unsigned int type=20,
	  unsigned int screenNum=0)
	  screenNum is unused.
	  
	  fix attached.
	  "

2013-06-28 10:51  robert

	* From David Callu, added support for glVertexAttribLPointer and
	  glVertexAttribIPointer, utilized via
	  osg::Array::setPreserveDataType(true);

2013-06-28 08:57  robert

	* From David Callu, serializer support for new Vec* and Vec*Array
	  classes

2013-06-28 08:11  robert

	* 

2013-06-27 17:37  robert

	* From David Callu, "Added Vec3ub, Vec3us, Vec4us, Vec2ub and
	  Vec2us classes"

2013-06-27 16:44  robert

	* From Lionel Lagarde, "Support for paging and shared PBO"
	  
	  "The attached file contains:
	  - a per-context read counter in GLBufferObject::BufferEntry
	  - a global client counter in BufferData
	  - the glue between Texture* and Image client counter
	  "

2013-06-27 15:18  robert

	* From Aurelien Albert, added passing on of the gl array normalize
	  to OpenGL when uses vertex attribute aliasing.

2013-06-27 14:46  robert

	* Replaced deprecatated osg::Geometry::get*Binding() calls.

2013-06-27 13:37  robert

	* Added Geometry::containsDeprecatedData() / fixDeprecatedData()

2013-06-27 10:58  robert

	* Removed deprecated usage of osg::Geometry::get*Binding()

2013-06-27 09:59  robert

	* Replaced deprecated osg::Geometry::set*Binding() usage.

2013-06-27 09:54  robert

	* Replaced deprecated osg::Geometry::set*Binding() usage

2013-06-27 09:54  robert

	* Replaced deprecated osg::Geometry::set*Binding() usage.

2013-06-27 08:44  robert

	* Replaced deprecated osg::Geometry::set*Binding() usage

2013-06-27 08:30  robert

	* Replaced deprecated Geometry::set*Binding()

2013-06-26 18:06  robert

	* Replaced deprecated Geometry::set*Binding() usage

2013-06-26 17:58  robert

	* Removed deprecated Geometry::set*Binding() usage

2013-06-26 17:54  robert

	* Added osg::getBinding(osg::Array* array) convinience function
	  that returns the Array::getBinding() is the array is not NULL,
	  otherwise returns BIND_OFF.

2013-06-26 17:45  robert

	* Replaced deprecated osg::Geometry::set*Binding() usage

2013-06-26 17:44  robert

	* Replaced deprecated osg::Geometry::set*Binding() calls.

2013-06-26 16:16  robert

	* From Sebastian Messerschmidt, "I've taken some time and
	  refactored some places where the old set*Binding were used."

2013-06-26 13:00  robert

	* From Aurelien Albert, "This submission allow the user to specify
	  how to setup VertexAttributeAliasing.
	  
	  I think this is necessary on OpenGL 3.2+ since this is no more
	  "default" locations in the OpenGL specs.
	  
	  The default behaviour stay the same.
	  
	  There is a few new methods on osg::State :
	  
	  - resetVertexAttributeAlias : reset all vertex alias to osg's
	  default ones
	  - set**Alias : set a vertex attribute alias configuration
	  - setAttributeBindingList : set the attribute binding list (allow
	  to specify an empty list if you're using "layout" qualifier in
	  glsl code to specify the bindings. This save some CPU
	  operations)"

2013-06-26 12:59  robert

	* Removed unused methods

2013-06-26 12:33  robert

	* Removed spaces from end of line

2013-06-26 12:33  robert

	* Fixed bug in TemplateTargetAttributeDispatch that was causing a
	  crash with the osgsimplegl3 example

2013-06-26 09:04  robert

	* From Pjotr Svetachov and Robert Osfield, "the index mesh and
	  vertex pre-transform optimizers can rearrange or change the size
	  of arrays assigned to a geometry. This leads to crashes or
	  corrupt geometry when using shared arrays.
	  
	  Attached a fix that duplicates shared geometry arrays."

2013-06-26 08:53  robert

	* Removed Geometry::fixDeprecatedData() as it won't work on const
	  Geometry

2013-06-26 07:08  robert

	* From Mathias Froehlich, "The attached file replaces the
	  deprecated geometry use in osgSim.
	  The per primitive use is changed to full per vertex arrays."

2013-06-25 16:19  robert

	* Removed #include<osg/Notify> as it's nolonger required in the
	  header

2013-06-25 16:10  robert

	* With assistance from Sukender, moved the depreacted osg::Geometry
	  vertex indices and AttributeBinding definitions out into a
	  separated namespace/class so to use
	  deprecated features you should now use deprecated_osg::Geometry
	  in place of osg::Geometry.

2013-06-25 11:13  robert

	* From Christian Buchner, "Here is a strongly overhauled version of
	  the original osgoit ("order independent transparency") by Mathias
	  Fröhlich. I called this version myosgoit. It looks very nice,
	  just build and run it!
	  
	  This version adds:
	  
	  - an encapsulation of the entire Depth Peeling procedure into a
	  class (not currently a scene graph node) for easier integration
	  in other projects.
	  
	  - compositing with opaque (solid) geometry is possible and the
	  opaque model is only rendered once. This needs to performs some
	  depth buffer blitting between FBOs.
	  
	  - mix and match with GLSL shaders in the transparent objects is
	  possible, as demonstrated with a 3D heat map intersecting an
	  opaque truck model.
	  
	  
	  Some Drawbacks:
	  
	  - the display framebuffer does not receive any depth information
	  from the compositing camera. This could be fixed by compositing
	  with a GLSL shader and writing to FragDepth."
	  
	  From Robert Osfield, ported the code to work under Linux and
	  without the automatic ref_ptr to C* conversion.

2013-06-25 09:52  robert

	* From Alberto Luacas, "current Doxygen warns against the use of
	  obsolete fields:
	  DETAILS_AT_TOP, SHOW_DIRECTORIES, HTML_ALIGN_MEMBERS.
	  
	  I have removed those in the configuration files."

2013-06-24 12:51  robert

	* From Cedric Pinson, "I fixed a little issue with the lightwave
	  scene loader. On the version 5 there are id on the command
	  LoadObjectLayer in the scene file and of this version the current
	  code use this field as a part of the filename, and it fails
	  because the file is not found.
	  I just added a field version_ to read it at the beginning and
	  added extra code to check it and read the extra field if needed
	  and read the good filename"

2013-06-24 12:31  robert

	* From Christian Ruzicka, "when MSAA is activated on iOS, the
	  stencil attachment is not added (Stencil buffer is not working at
	  all). Attached are the needed changes to make MSAA + stencil
	  working on iOS.
	  
	  Tested with OSG 3.1.7 and iOS SDK 6.1."

2013-06-24 12:30  robert

	* Updatd SO_VERSION to reflect changes in ABI from merging
	  submissions.

2013-06-24 12:27  robert

	* From Sukender, "I recently pulled from the GIT mirror and found
	  that "OSG_USE_DEPRECATED_GEOMETRY_METHODS=OFF" hides a little
	  mistake: there is a "#include <osg/Notify>" inside the "osg"
	  namespace, in inlude/osg/Geometry.
	  "

2013-06-24 11:40  robert

	* From Mourad Boufarguine, "Attached is a fix for the ply reader to
	  use the output of osgDB::findDataFile.
	  
	  "

2013-06-24 11:39  robert

	* From Luc Frauciel, "You'll find attached a modification of
	  DXWriter to support Material color:
	  If a material is present, the diffuse color is affected to
	  current layer."

2013-06-24 11:14  robert

	* From Lars Nillson, "The change in this submission is to take care
	  of the setting given by a call to
	  setMaximumNumOfObjectsToCompilePerFrame(…).
	  
	  
	  Sometimes if you give a low number, more than the expected number
	  of objects are compiled."

2013-06-24 11:03  robert

	* Convert usage to use const versions of containers

2013-06-24 09:59  robert

	* From Frederic Morin, "Current behaviour uses SDKSettings.plist to
	  determine osx version but
	  this file is only available when XCode is installed.
	  
	  This version works also when Command Line Tools for XCode are
	  installed (minimum build env for osx without XCode)
	  
	  See https://github.com/openscenegraph/osg/pull/8 for patch
	  details
	  Patch: https://github.com/openscenegraph/osg/pull/8/files"

2013-06-24 09:51  robert

	* From Farshid Lashkari, "I've attached a small patch that extends
	  the Image::readImageFromCurrentTexture method to support more
	  depth texture pixel formats (16, 24, 32, 32F). In order to
	  compile, I moved some depth pixel format definitions from
	  FrameBufferObject to Image.
	  "

2013-06-24 09:31  robert

	* From Christian Noon, "Got a simple patch for correcting a problem
	  with the USE_COMPRESSOR_WRAPPER() macro in the osgDB::Registry.
	  The problem is that the wrapper declaration doesn't match the one
	  defined in the REGISTER_COMPRESSOR() method in the
	  osgDB::ObjectWrapper method. This patch fixes the wrapper
	  declaration so they both match properly. I ran into this problem
	  using compressed files in an iOS application where all the
	  libraries and plugins need to be built statically."

2013-06-24 09:12  robert

	* From Nick Black, "Hey there! avcodec_open() has been deprecated
	  for some time, and indeed has
	  been removed in the most recent versions of libavcodec/ffmpeg.
	  You're
	  already using avcodec_open2() elsewhere, but one appears to have
	  been
	  missed. The change is trivial:
	  
	  [skynet](0) $ svn diff
	  Index: src/osgPlugins/ffmpeg/FFmpegDecoderAudio.cpp
	  ===================================================================
	  --- src/osgPlugins/ffmpeg/FFmpegDecoderAudio.cpp (revision 13355)
	  +++ src/osgPlugins/ffmpeg/FFmpegDecoderAudio.cpp (working copy)
	  @@ -109,7 +109,7 @@
	  // m_context->flags |= CODEC_FLAG_TRUNCATED;
	  
	  // Open codec
	  - if (avcodec_open(m_context, p_codec) < 0)
	  + if (avcodec_open2(m_context, p_codec, NULL) < 0)
	  throw std::runtime_error("avcodec_open() failed");
	  }
	  
	  [skynet](0) $
	  
	  I've applied similar changes this year to many other packages,
	  including
	  cheese, blender, linphone, ad nauseam. It's been tested by
	  verifying that
	  with my patch, OSG builds against the newest libavcodec and
	  ffmpeg, whereas
	  otherwise it does not.
	  
	  The modified src/osgPlugins/ffmpeg/FFmpegDecoderAudio.cpp is
	  attached. It
	  originates in svn trunk revision 13355. Thanks!"

2013-06-24 09:02  robert

	* Introduced typedef's to make the code more readble and
	  maintanable

2013-06-24 08:48  robert

	* From Wang Rui, "The file attached includes two new features for
	  the serialization IO functionality. First, custom serializer
	  version control should work now, just by defining a new
	  REGISTER_CUSTOM_OBJECT_WRAPPER macro. For example:
	  
	  // A custom class
	  namespace CustomDomain {
	  
	  class MyGroup : public osg::Group
	  {
	  public:
	  META_Node( CustomDomain, MyGroup );
	  
	  void setMyName( const std::string& n );
	  const std::string& getMyName() const;
	  
	  void setMyID( int id );
	  int getMyID() const;
	  
	  ...
	  };
	  
	  }
	  
	  // The serialization wrapper using a custom domain name
	  REGISTER_CUSTOM_OBJECT_WRAPPER( MyDomain,
	  CustomDomain_MyGroup,
	  new CustomDomain::MyGroup,
	  CustomDomain::MyGroup,
	  "osg::Object osg::Node osg::Group CustomDomain::MyGroup" )
	  {
	  ADD_STRING_SERIALIZER( MyName, std::string() );
	  {
	  UPDATE_TO_VERSION_SCOPED( 1 ); // Updated for a new domain
	  version
	  ADD_INT_SERIALIZER( MyID, 0 );
	  }
	  }
	  
	  Save the class instance as follows:
	  osgDB::writeNodeFile( *myGroup, "serializer_test.osgt", new
	  osgDB::Options("CustomDomains=MyDomain:1") );
	  
	  The output file will include the domain version definition and
	  all the class data, and can be read back. We can also force
	  setting the domain version by the CustomDomains option while
	  reading the saved files. If we save the class instance without
	  any options, MyID will be ignored because the default domain
	  version is 0.
	  
	  This may help third-party libraries like osgEarth to maintain
	  their own serializers without regarding to the OSG soversion
	  changes.
	  
	  Another feature added is a more robust binary format, which in
	  fact adds a size-offset at each block's beginning. When there are
	  problems or unsupported data types while reading, we can now
	  directly jump to the block end indicated by the offset value. So
	  a .osgb file will automatically ignore bad data and read remains
	  as normal (at present it will fail at all). This feature will not
	  break the backward compatibility, and can be disabled by setting
	  "RobustBinaryFormat=false" while writing out.
	  
	  Hope these changes can work smoothly with present and future
	  community projects. Maybe we should also consider have an
	  osgserializer example to test and demonstrate all things we can
	  do now."

2013-06-24 08:22  robert

	* From Wang Rui, "Sorry for my very slow response because of some
	  personal issues. I found that new Geometry serializers can't work
	  with old .osgb files. The modified FastPathHint serializer
	  doesn't correctly read from the stream and thus jumbles following
	  inputs. The file attached can be placed in
	  osgWrappers/serializers/osg to fix that problem.
	  
	  "

2013-06-24 08:19  robert

	* From Wang Rui, "The osgdb_ffmpeg plugin may not work with latest
	  ffmpeg windows sdk and will say "The procedure entry point xxx
	  could not be located in xxx.dll" instead. The following link
	  describes the reason (maybe a certain optimization problem of the
	  VS compiler):
	  http://forum.videolan.org/viewtopic.php?f=32&t=98097
	  
	  After adding the /OPT:NOREF, the problem has gone.
	  
	  "

2013-06-24 08:18  robert

	* From Farshid Lashkari, "In many game engines it is common to set
	  the W component of the tangent vector to -1 if the UVs are
	  mirrored and 1 if not. I've updated the
	  osgUtil::TangentSpaceGenerator class to do the same."

2013-06-21 19:35  robert

	* Updated version number after dev release

2013-06-21 19:35  robert

	* Removed spaces from end of lines

2013-06-21 14:37  robert

	* Fixed author name error introduced by xxdiff

2013-06-21 14:30  robert

	* Reapplied AUTHORS changes

2013-06-21 14:29  robert

	* Update ChangeLog and AUTHORS.txt for release

2013-06-21 14:17  robert

	* Removed unneccessary handling of BIND_PER_PRIMITIVE on output
	  code

2013-06-21 13:59  robert

	* From Pjotr Svetachov, introduced use of
	  osg::observer_ptr<osg::Camera> in place of osg::Camera*

2013-06-21 13:41  robert

	* From Stephan Huber, "attached you'll find the missing
	  readObject-implementations for the imageio-plugin as suggested by
	  Remo Eichenberger."

2013-06-21 12:10  robert

	* From Laurens Voerman, build fix

2013-06-21 10:59  robert

	* Build fixes for new osg::Geometry

2013-06-21 10:14  robert

	* Converted osg::Geometry::ArrayData usage across to osg::Array.

2013-06-21 10:03  robert

	* From Laurens Voerman, "I just tested openGL quadbuffered stereo
	  with the osgviewer, the mouse works again, so does the
	  keystonecorrection, but the right-eye render to texture camera
	  appears not to clear it's color buffer.
	  I found the problem in src\osgViewer\View.cpp, fix attached."

2013-06-21 09:53  robert

	* From Mathieu Marache, I needed to modify the FindCOLLADA.cmake to
	  enable its compilation under macosx.

2013-06-21 09:47  robert

	* Converted ArrayData usage across to set*Array() usage with new
	  binding parameter

2013-06-21 09:43  robert

	* Added new osg::Array::Binding parameter to
	  osg::Geometry::set*Array(osg::Array* array, osg::Array::Binding
	  binding=osg::Array::BIND_UNDEFINED) methods to make it easier for
	  the user
	  to set the binding without the need to call the deprecated
	  osg::Geometry::set*Binding(osg::Geometry::AttributeBinding)

2013-06-21 09:40  robert

	* Removed spaces at ends of lines

2013-06-21 09:17  robert

	* From FrancoisTigeot, "OpenSceneGraph 3.0.1 doesn't build out of
	  the box on DragonFly and needs
	  a few modifications to these files:
	  - applications/present3D/Cluster.cpp
	  - src/osgDB/FileUtils.cpp
	  
	  The changes are needed to fix a few platform specific things such
	  as the
	  absence of stat64, int/socklen_t differences, etc... and are in
	  the same
	  line as Linux, Apple and FreeBSD specific checks.
	  
	  I have attached the modified files; the original patches to 3.0.1
	  are
	  also visible here if you find it more convenient:
	  http://dl.wolfpond.org/dports/graphics.osg/dragonfly/patch-applications_present3D_Cluster.cpp
	  http://dl.wolfpond.org/dports/graphics.osg/dragonfly/patch-src_osgDB_FileUtils.cpp
	  
	  With these changes, osg 3.0.1 is able to be built and packaged on
	  DragonFly
	  whereas it previously failed to compile."

2013-06-21 08:56  robert

	* From Matthias Helsing, "Here is the changed source to prefer
	  using _NET_WM_STATE_ABOVE but fall back to XRaiseWindow should
	  the Atoms not be supported. I'm not sure how many might be using
	  the raiseWindow feature but I needed it for a splash on Ubuntu
	  12.04."

2013-06-21 08:37  robert

	* From Farshid Lashkari, "I've updated the dds, png, and jpeg
	  plugins to support writing images with the GL_DEPTH_COMPONENT
	  pixel format. They will simply treat it the same as the
	  GL_LUMINANCE pixel format."

2013-06-21 08:03  robert

	* From Jan Ciger, " I have put there in the comment a nicer way of
	  doing version
	  checks, but that needs at least CMake 2.6.2."

2013-06-20 16:44  robert

	* Fixed the handling the mouse min/max ranges of slave Cameras that
	  have a parent Camera with a viewport.

2013-06-20 15:48  robert

	* Temporarily commented out call to
	  view.assignStereoOrKeystoneToCamera() for implementing stereo as
	  this was causing problem in trackball manipulation

2013-06-20 15:18  robert

	* Added local namespace for util functions, and fixed the return
	  type of checkDeprecatedData()

2013-06-20 12:15  robert

	* From Vladimir Chebaev, "I worked with osg::Particle and see that
	  this class has setter osgParticle::setTextureTileRange and has no
	  getters for startTile and endTile. This can be very
	  uncomfortable.
	  I attached file with two getters."

2013-06-20 10:59  robert

	* Commented out verbose debug messages for shader composition

2013-06-20 10:42  robert

	* Updated ChangeLog and AUTHORS file

2013-06-20 10:05  robert

	* From Juan Manuel Alvarez, "When handling keyboard events on
	  osgQt, if a key is kept pressed, multiple sequences of KEYDOWN ->
	  KEYUP events are fired.
	  
	  This is because Qt auto repeats keyboard events, so multiple
	  calls are made to GLWidget::keyPressEvent and
	  GLWidget::keyReleaseEvent by Qt, and subsequently translated to
	  OSG events.
	  
	  The way to solve this is ignoring key released auto repeated
	  events (see
	  http://qt-project.org/doc/qt-4.8/qkeyevent.html#isAutoRepeat), so
	  multiple KEYDOWN events are fired, but only one KEYUP.
	  
	  I attach a modified osgQt/GraphicsWindowQt.cpp with this change."

2013-06-20 09:30  robert

	* From Jan Ciger, compilation fix for Qt 5.0.2

2013-06-20 09:27  robert

	* From Laurens Voerman, build fix for VS.

2013-06-19 17:28  robert

	* Removed svn:executable property.

2013-06-19 17:26  robert

	* Removed svn:executable property

2013-06-19 17:25  robert

	* Removed svn:executable property.

2013-06-19 16:24  robert

	* Cleaned up usage of BIND_PER_PRIMITIVE where possible.

2013-06-19 12:32  robert

	* From Magnus Kessler, typo fixes to doxygen docs and comments

2013-06-19 12:28  robert

	* From Magnus Kessler, "gcc-4.8 flagged this:
	  
	  src/osgUtil/tristripper/src/tri_stripper.cpp:375:40: warning:
	  typedef
	  ‘tri_node_iter’ locally defined but not used
	  [-Wunused-local-typedefs]
	  typedef triangle_graph::node_iterator tri_node_iter;
	  ^
	  ---
	  src/osgUtil/tristripper/src/tri_stripper.cpp | 1 -
	  1 file changed, 1 deletion(-)
	  
	  diff --git a/src/osgUtil/tristripper/src/tri_stripper.cpp
	  b/src/osgUtil/tristripper/src/tri_stripper.cpp
	  index 2f5a7f3..3396881 100644
	  --- a/src/osgUtil/tristripper/src/tri_stripper.cpp
	  +++ b/src/osgUtil/tristripper/src/tri_stripper.cpp
	  @@ -372,7 +372,6 @@ inline tri_stripper::const_link_iterator
	  tri_stripper::BackLinkToNeighbour(const
	  
	  void tri_stripper::MarkTriAsTaken(const size_t i)
	  {
	  - typedef triangle_graph::node_iterator tri_node_iter;
	  typedef triangle_graph::out_arc_iterator tri_link_iter;
	  
	  // Mark the triangle node"

2013-06-19 12:27  robert

	* Converted tabs to four spaces

2013-06-19 12:19  robert

	* From Jan Ciger, "I have found a problem when building OSG with Qt
	  5 support. Qt has the
	  following in the qopengl.h header:
	  
	  # include <QtGui/qopengles2ext.h>
	  # ifndef GL_DOUBLE
	  # define GL_DOUBLE GL_FLOAT
	  # endif
	  # ifndef GLdouble
	  typedef GLfloat GLdouble;
	  # endif
	  
	  Unfortunately, when building for normal OpenGL (not GL/ES!) on
	  Windows
	  with MSVC2012, GLdouble is not defined (it is not a macro but
	  typedef)
	  and the code above produces a conflicting definition, making the
	  compile fail. I am attaching a bit hackish workaround for this
	  problem
	  in osg/GL "

2013-06-19 10:56  robert

	* Build fixes for new deprecated osg::Geometry functions

2013-06-18 19:09  robert

	* Added #define OSG_USE_DEPRECATED_GEOMETRY_METHODS usage into code
	  to allow code to compile enen when CMake configuration has set
	  the #define to off in include/osg/Config.

2013-06-18 17:49  robert

	* Moved the assignment of the normal binding to after the
	  setNormalArray call

2013-06-18 17:48  robert

	* Moved the Geometry::set*Binding to after the set*Array() to
	  prevent problems when using the deprecated functionality.

2013-06-18 15:54  robert

	* Removed BIND_PER_PRIMITIVE reference

2013-06-18 15:03  robert

	* Moved the set binding and normalize for VertexAttrib to after the
	  VertexAttrib array assignment

2013-06-18 14:52  robert

	* Changed header guard back to original, and removed deprecated
	  enum

2013-06-18 14:22  robert

	* Fixed order of binding.

2013-06-18 11:49  robert

	* Removed experiment GeometryNew as it's no longer required.

2013-06-18 11:18  robert

	* Clean up up osg::Geometry, removing long deprecated support for
	  array indices and BIND_PER_PRIMITIVE binding that forced OpenGL
	  slow paths. osg::Geometry is now smaller and only supports OpenGL
	  fasts paths.
	  New methods osg::Geometry::containsDeprecatedData() and
	  osg::Geometry::fixDeprecatedData() provide a means for converting
	  geometries that still use the array indices and
	  BIND_PER_PRIMITIVE across to complient
	  versions.
	  
	  Cleaned up the rest of the OSG where use of array indices and
	  BIND_PER_PRIMITIVE were accessed or used.

2013-06-14 09:43  robert

	* Fixed TextBase::computeBound() so it take into account all
	  corners of the text box thus ensuring proper handling of rotated
	  text

2013-06-12 12:49  robert

	* From Martin Naylor, replace osgDB::fstream with an osgDB::open()
	  call.

2013-06-11 10:52  robert

	* Introduced new osg::PatchParameter StateAttribute class to wrap
	  up glPatchParameter associated state.
	  Note, osg::Program::setParameter(GL_PATCH_VERTICES,num); is
	  nolonger support and should be replaced by using the new
	  PatchParameter class.

2013-06-11 10:49  robert

	* Fixed indentation

2013-06-11 09:05  robert

	* Refactored the way the ReadResult/WriteResult lists are handled,
	  with them now being sorted so that the Read/WriteResult with
	  highest numerical value ReadStatus/WriteStatus is returned.
	  Changed the enum order of ReadStatus/WriteStatus to ensure that
	  the more relevant errors are last and with the highest numerical
	  value

2013-06-10 14:34  robert

	* From Kristofer Tingdahl, with additions from Riccardo Corsi and
	  Robert Milharcic, support for Qt5 build

2013-06-10 10:37  robert

	* Fixed remove and add callback so they properly handle nested
	  callbacks

2013-06-07 10:54  robert

	* From Marcin Prus, "I don't know if you seen my second reply to
	  your information about merging my Image and dds plugin changes. I
	  found one problem in your latest submit. In
	  ReaderWriterDDS::ComputeImageSizeInBytes pixelFormat and
	  pixelType are not passed into
	  osg::Image::computeImageSizeInBytes.
	  
	  It's
	  return osg::Image::computeImageSizeInBytes(width, height, depth,
	  packing, slice_packing, image_packing);
	  but I think it should be
	  return osg::Image::computeImageSizeInBytes(width, height, depth,
	  pixelFormat, pixelType, packing, slice_packing, image_packing);"

2013-06-07 10:52  robert

	* From Mathias Froehlich, "attached is a change to osgsharedarray
	  to move completely to the fast geometry
	  path. Also the arrays are moved back to static storage since this
	  is the data
	  that is actually referenced in draw. So the change moving this
	  onto the stack
	  that happend somewhere before broke this."

2013-06-06 08:23  robert

	* Replaced OpenThreads::Mutex with a OpenThreads::ReentrantMutex to
	  allow draw callbacks to use Renderer.

2013-06-05 07:55  robert

	* Reorder member variables to ensure better packing in memory.

2013-06-05 07:27  robert

	* Moved the Array::AttribDivisor into the Array::Binding enum to
	  avoid conflicts in settings between Binding and AttribDivisor.
	  
	  Removed the vertify bindings/shared arrays handling from
	  GeometryNew

2013-06-04 19:04  robert

	* Updates to GeometryNew, Array and ArraDispatchers to clean up
	  GeometryNew so that is no longer uses ArrayData.

2013-06-04 14:55  robert

	* Added s/getNormalize(), s/getPreserveDataType(),
	  s/getAttribDivisor() and s/getBinding() to osg::Array base class
	  in preperation for refactor of osg::Geometry and introduction of
	  new features.

2013-06-04 14:43  robert

	* Removed now redundent osggeodemo

2013-06-04 13:29  robert

	* Removed geo plugin as the modelling tool it was assocaited is
	  long defunct.

2013-06-04 10:06  robert

	* Cleaned up BIND_PER_PRIMITIVE and array indice usage

2013-06-04 09:32  robert

	* Introduced GeometryNew which is a cleaned up version of Geometry
	  that removes support for array indices.
	  GeometryNew is only temporary and will be renamed to Geometry on
	  the completion of refactoring work and feedback from community.
	  Ported osggeometry across to use GeometryNew.

2013-06-04 09:29  robert

	* Removed deprecated usage of osg::Geometry indices and
	  BIND_PER_PRIMITIVE

2013-06-03 15:10  robert

	* From Aurelien Albert, Added support for texture swizzle.

2013-06-03 14:38  robert

	* Updated version and so_version in prep for 3.1.8 developer
	  release

2013-06-03 14:27  robert

	* From Laurens Voerman, "Autodesk released a new version of their
	  FBX Software Development Kit (web page
	  http://usa.autodesk.com/adsk/servlet/pc/item?siteID=123112&id=10775847).
	  The API has changed quite a bit, so lots of changes had to be
	  made in the osg readerwriter. The preious version of the FBX SDK
	  (2013.3) already deprecated a lot of the names and functions. The
	  code I submit now still compiles against 2013.3 (possibly needs a
	  #define FBX_NEW_API). Not sure if that's useful, but it might
	  ease the transition."

2013-06-03 14:04  robert

	* From Laurens Voerman, "while updating dependencies I found a
	  problem with libgif 5 from
	  http://sourceforge.net/projects/giflib/
	  a change in version 5.0.0 required a call to the fuction
	  "DGifOpen" to pass an int ref for an error code.
	  My fix ignores the error, just fixes the compile."

2013-06-03 14:01  robert

	* From Sergey Polischuk, "this patch fixes light id in gl modes for
	  osg::LightSource's readed from fbx (previously all lightsources
	  were setting GL_LIGHT0 mode, while osg::Lights were using
	  different id's), and enables GL_LIGHT# on root node for all
	  lights contained in model
	  "

2013-06-03 13:13  robert

	* Added Vec*b, Vec4ub, Vec*s, Vec*i, Vec*ui serializers

2013-06-03 12:19  robert

	* Added Vec2i, Vec2ui, Vec3i, Vec3ui, Vec4i and Vec4ui headers to
	  CMake header list

2013-06-03 11:38  robert

	* From Art Tevs, int and uint Vec classes

2013-06-03 09:19  robert

	* From Aurelien Albert, "This submission is made against trunk
	  version and add the loading of "glVertexAttribDivisor"
	  extension."

2013-05-31 10:28  robert

	* From Laurens Voerman, "I made some changes to the top level
	  CMakeLists.txt that might be usefull to other visualstudio users.
	  1> Disable project grouping for VCExpress users: the version I
	  proposed previously in
	  Re: [osg-submissions] Cmake patch to support folders in IDE (29
	  Feb 2012)
	  
	  2> Remove FIND_PACKAGE(OpenAL): not used in any project
	  
	  3> add /wd4250 for Visual Studio 2012:
	  suppress the errors caused by a microsoft fix for a bugfix.
	  ref: "Warning messages VS2012..." on osg-users (30 May 2012)
	  "

2013-05-31 10:23  robert

	* From Ulrich Hertlein, "attached is a patch that fixes another
	  clang++ compiler warning when returning
	  std::vector::size() as 'unsigned int'.
	  "

2013-05-30 09:07  robert

	* From Wang Rui, "The osgdb_nvtt plugin needs to be updated to work
	  with the latest NVTT library, which changes the interface
	  slightly (adding a new pure virtual method endImage()). I've
	  modified the source file and attached it here."

2013-05-28 19:16  robert

	* Renamed PanoramicSphericalDisplay.cpp to fix a typo

2013-05-28 16:39  robert

	* Updated ChangeLog and Contributors list

2013-05-28 15:43  robert

	* From Farshid Lashkari, "The logic for handling opacity maps in
	  the 3ds reader seems to be incorrect. It checks whether the
	  diffuse texture contains transparency, instead of the opacity
	  texture. If the diffuse does not contain an alpha channel it
	  outputs the warning:
	  
	  The plugin does not support images without alpha channel for
	  opacity
	  
	  This seems to indicate that the check for alpha should be against
	  the opacity map. I've attached the updated file.
	  
	  "

2013-05-28 15:40  robert

	* From Michael Bach Jensen and Robert Osfield, "As discussed
	  (http://forum.openscenegraph.org/viewtopic.php?t=12027) here is
	  my submission :-)
	  
	  The following change to State.cpp fixes the case where textures
	  in a stateset along with a compute shader program did not make
	  those textures available to the shader, since it got evaluated
	  before the texture bind(s)."
	  
	  Note from Robert, Michael only change State::apply(StateSet*) so
	  I also applied the same reversal in apply of texutre modes/state
	  into the State::apply() method for consistency.

2013-05-28 15:18  robert

	* Replaced the initialization of the strarray to use reseve instead
	  of a initial size provided in the constructor as this was leading
	  to a bug in output.

2013-05-28 14:40  robert

	* Fixed date typo

2013-05-28 14:35  robert

	* From Farshid Lashkari, "I just started looking into the shader
	  composition feature. I enabled shader composition on the
	  osg::State object and noticed a 6x increase in draw time. I
	  figured that the default composer might have performance issues,
	  so I created a custom ShaderComposer that overrides
	  "getOrCreateProgram" and does nothing. This still resulted in a
	  performance drop.
	  
	  I looked into the "State::applyShaderComposition" method and
	  noticed that it will print debug information to the osg::INFO
	  stream. I commented that line out and the performance drop was
	  gone.
	  
	  I'm not sure if the printing was accidentally left in or is meant
	  to be enabled. I've modified the function to only call the print
	  function if INFO logging is enabled. I've attached the change."

2013-05-28 14:14  robert

	* From Marcin Prus and Robert Osfield, moved the key parts of the
	  .dds plugins computeRowWidthInBytes implementation into the
	  osg::Image::computeImageSizeInBytes(..) to
	  address bugs in the computation of image size.

2013-05-28 11:47  robert

	* From Sukender, "Added ".dds" file deletion on writing failure."

2013-05-28 11:46  robert

	* From Sukender, "Added vertical flipping to the writer depending
	  on the Image::getOrigin() value (= flip the image when
	  Image::BOTTOM_LEFT). Most of the time this will not change DDS
	  writing (= no v-flip), as it seems images are rarely
	  "BOTTOM_LEFT". To skip this behaviour, the "ddsNoAutoFlipWrite"
	  option was added.
	  I also moved a few lines of code about "dds_flip" option, and
	  made options reading more like in other ReaderWriters."

2013-05-28 11:44  robert

	* From Diane Delallée & Sukender, "Added some support of
	  non-modulus-4 dimensions in S3TC-DXTC images (previous
	  implementation seem just not to handle these properly).
	  - Added missing packing value on S3TC images. Images are coded
	  with 4x4 blocs, whatever the image size. So there is an
	  horizontal packing of 4 pixels (2 bytes in DXT1, 4 bytes in
	  DXT2-5).
	  - Added crash guard against writing corrupted S3TC images.
	  Notes:
	  - What is missing is a support of "lines packing" in osg::Image
	  (see code comments).
	  - S3TC-DXTC vertical flipping crashes (access violation) with
	  some unusual dimensions (see code). I could not implement missing
	  cases, so I added guards to avoid crashing."

2013-05-28 11:25  robert

	* From Diane Delallée and Sukender, "1. Image.cpp
	  Failure to perform a vertical flip on S3TC-DXTC now simply leaves
	  the original image instead of corrupting it.
	  Image.cpp was sometimes performing a "normal" (= for uncompressed
	  images) vertical flip on S3TC-DXTC images, producing weird
	  results.
	  Actually, code was trying a "DXTC vertical flip" and relied on
	  the result to call a "normal vertical flip". But when the "DXTC
	  v-flip" encounters an error, this is is not necessarily because
	  the image is not S3TC (ex: unhandled image dimensions)!
	  So now the code simply does "if dxtc, then flip_dxtc; else
	  flip_normal;".
	  
	  Note from Robert Osfield, moved the isDXT function into the
	  dxt_tool file and namespace.

2013-05-28 10:46  robert

	* Fixed the computation of the spot light direction.

2013-05-28 09:20  robert

	* Fixed View::setUpViewInWindow() parameter

2013-05-28 08:38  robert

	* Added an OSG_INIT_SINGLETON_PROXY(..) to initialize the static
	  s_GLExtensionDisableString variable

2013-05-27 09:10  robert

	* Updated AUTHORS file

2013-05-27 09:07  robert

	* Updated AUTHORS file

2013-05-27 09:05  robert

	* Updated ChangeLog and AUTHORS file

2013-05-27 08:13  robert

	* From Martin Naylor, "I am receiving 1 build error whilst building
	  the SVN, its in osgforest as follows:
	  
	  error C2065: 'GL_RGBA32F' : undeclared identifier
	  
	  Shoudlnt that be GL_RGBA32F_ARB as defined in texture header?
	  
	  Attached is the easy fix :)."

2013-05-27 08:10  robert

	* Moved quad buffer definitions into include/osg/Camera

2013-05-26 10:44  robert

	* Updated AUTHORS file

2013-05-26 10:27  robert

	* Updated ChangeLog

2013-05-25 10:09  robert

	* From Farshid Lashkari, " small update to TangentSpaceGenerator to
	  support QUAD_STRIP primitive types."

2013-05-24 17:16  robert

	* Resrtuctured the use of static's in the Uniform::getNameID()
	  method to avoid problems under Android.

2013-05-24 17:06  robert

	* From Jordi Torres, "We must use JNI_FALSE instead of false in JNI
	  code. Otherwise the examples will not compile. This patch should
	  be applied to osgAndroidExampleGLES1/jni and
	  osgAndroidExampleGLES2/jni. the osgNativeLib.cpp is the same. "

2013-05-24 09:43  robert

	* Removed redudent code

2013-05-24 09:35  robert

	* Fixed panning bug, when using RUN_ON_DEMAND, that resulted in the
	  camera being thrown off towards infinity.
	  
	  The solution for to refactor the way that events are checked so I
	  add a bool return type to checkEvents() method across
	  osgViewer::GraphcisWindow, osgGA::Devive and
	  osgViewer::Viewer/CompositeViewer classes

2013-05-23 18:29  robert

	* Added repolation of the _deadparts stack which would otherwise
	  been invalidatd by the depth sort of particles.

2013-05-23 15:55  robert

	* From Pawel Ksiezopolski, Added example of using
	  osg::TextureBuffer + GLSL to render forest.

2013-05-23 14:14  robert

	* From David Fries, "This updates the CMakeLists.txt instructions
	  for the commands
	  to make the doxygen documentation."

2013-05-23 12:29  robert

	* Refactored the idle mechanism to fix problems with the vnc thread
	  going idle when it shouldn't have.

2013-05-23 10:25  robert

	* Added assigned of the InteractiveImageHandler as a cull callback
	  to enable the interactive image to know when it's being actively
	  used as part of rendering a frame.

2013-05-22 15:48  robert

	* Quitened down debug messages

2013-05-22 13:16  robert

	* Removed debug messages

2013-05-22 13:09  robert

	* From Nico Kruithof, "For the VNC server, it seems that the wrong
	  include path is used.
	  
	  Instead of
	  INCLUDE_DIRECTORIES(${LIBVNCCLIENT_INCLUDE_DIR})
	  the CMake variable
	  INCLUDE_DIRECTORIES(${LIBVNCSERVER_INCLUDE_DIR})
	  should be used.
	  
	  Attached is a fix for src/osgPlugins/vnc/CMakeLists.txt"

2013-05-22 12:49  robert

	* From Pawel Ksiezopolski, first email: "This submission adds
	  texture buffer object ( defined in GL_ARB_texture_buffer_object
	  extension ) to the osg::Texture* family.
	  
	  TextureBuffer objects may use osg::Texture::bindToImageUnit(), so
	  GLSL shaders are able to use not only texelFetch() function , but
	  also functions defined in GL_ARB_shader_image_load_store
	  extension : imageLoad(), imageStore(), imageAtomicAdd() etc."
	  
	  second email: "After a while I found that
	  osg::Texture::applyTexParameters() used with TextureBuffer may
	  cause some OpenGL errors ( applying texture filters and wraps to
	  TextureBuffer makes no sense ) so I fixed it."

2013-05-22 11:06  robert

	* From Jan Ciger, "Here is a little patch to fix a bug in the
	  InfluenceMap serialization. The names of the maps weren't quoted
	  properly and therefore it was breaking loading of rigged models
	  exported from e.g. Blender. Also names that contained spaces
	  wouldn't have been parsed properly. "

2013-05-22 10:28  robert

	* From David Callu, "ust a simple IF ENDIF mismatch in last commit
	  (I use git so no available SVN commit number ) :
	  
	  CMake Warning (dev) in CMakeLists.txt:
	  A logical block opening on the line
	  
	  /home/ledocc/work/perso/osg_Workspace/osg/CMakeLists.txt:823 (IF)
	  
	  closes on the line
	  
	  /home/ledocc/work/perso/osg_Workspace/osg/CMakeLists.txt:893
	  (ENDIF)
	  
	  with mis-matching arguments.
	  
	  I remove ENDIF argument, it is no longer needed by cmake"

2013-05-21 17:41  robert

	* From Farshid Lashkari, "I'm working on a custom ShaderComposer
	  and I need access to the full StateSetStack of the State object
	  within the getOrCreateProgram() method. The problem is that
	  "State::apply(const StateSet* dstate)" does not add the specified
	  stateset to the stack. I'm not sure if this was intentional, but
	  I've updated the function to push/pop the stateset.
	  
	  I hope the change seems reasonable. I searched the entire code
	  base for code that accesses the StateSetStack, and noticed
	  RenderBin and RenderStage use it. However, I don't think that
	  code would ever be called from within the State::apply()
	  function, so I'm fairly confident the change should be safe."

2013-05-21 10:22  robert

	* From Valeriy Dubov, fix for Android build under OSX

2013-05-21 09:48  robert

	* From Alexander Sinditskiy, "I just noticed that Dragger allways
	  handle events even when
	  handle(const PointerInfo&, const osgGA::GUIEventAdapter&,
	  osgGA::GUIActionAdapter&)
	  returns false.I think it is not correct...i think handled should
	  be changed only when it is really handled."

2013-05-21 09:44  robert

	* Added use of SingleWindow for when only one screen is used

2013-05-20 19:24  robert

	* Refactored the support for stereo and keystone RTT setup so that
	  it can be applied to an existing Camera.

2013-05-20 14:17  robert

	* Added support for controlling border and override redirect to the
	  SingleWindow View::Config

2013-05-20 10:23  robert

	* Added a dedicated RTT texture for each of the left and right eyes
	  when doing ANAGLYPHIC stereo to avoid issues with scene graphs
	  containing ClearNode's such as when using in Present3D

2013-05-16 15:52  robert

	* Added support for setting the left/right cull masks

2013-05-16 14:51  robert

	* Changed the default of OSG_SPLIT_STEREO_AUTO_ADJUST_ASPECT_RATIO
	  to OFF

2013-05-16 14:11  robert

	* Fixed stereo offsets of HORIZONTAL_SPLIT and VERTICAL_SPLIT
	  stereo modes

2013-05-16 14:07  robert

	* Reverted back to changes before experiements with ViewConfig

2013-05-16 10:28  robert

	* Cleaned up the WoWVxDisplay command line parsing

2013-05-16 10:11  robert

	* Renamed osgViewer::Config osgViewer::ViewConfig and moved it's
	  declaration into include/osgViewer.

2013-05-16 09:08  robert

	* Added WoWVxDisplay view config

2013-05-15 16:15  robert

	* Created a dedicated include/osgViewer/config and
	  src/osgViewer/config directories to place all the Config classes.

2013-05-15 12:50  robert

	* Added support for osgViewer::Config in osgViewer::Viewer command
	  line parsing

2013-05-15 11:31  robert

	* Introduced osgViewer::Config base class and beginnigs of various
	  Config implementations.
	  Introduced osgViewer serializers plugin for serialization support
	  for osgViewer::Config implementations and Keystone

2013-05-14 16:23  robert

	* From Lionel Lagarde, "When a function do:
	  
	  OSG_DEBUG << "Hello world!\n";
	  
	  the underlying stream is not automatically flushed. It is flushed
	  if endl is queued instead of \n:
	  
	  OSG_DEBUG << "Hello world!" << std::endl;
	  
	  
	  The notify macros do:
	  stream->setCurrentSeverity(severity);
	  return *stream;
	  
	  So, if a function do:
	  
	  OSG_DEBUG << "This is a debug message\n";
	  OSG_NOTICE << "This is a notice message" << std::endl;
	  
	  the debug message will be classified as a notice message.
	  
	  It is a problem when the application uses a NotifyHandler. The
	  notify
	  method of the handler is called with:
	  
	  severity = NOTICE
	  message = "This is a debug message\nThis is a notice message"
	  
	  The attached Notify.cpp contains an automatic flush of the stream
	  when
	  the current severity changes.
	  
	  "

2013-05-14 16:18  robert

	* From Michael Kapelko, "The provided patch (against SVN revision
	  13380) adds missing constness to returning calls (without it the
	  user code does not compile)."

2013-05-14 16:15  robert

	* From Farshid Lashkari, "The tga image loader was not properly
	  reading in 16-bit images. Fix is attached."

2013-05-14 16:12  robert

	* From Ulrich Hertlein, "Attached is a patch that introduces
	  'static_cast<unsigned int>' on some instances where
	  the code returns '.size()' of a std::vector. This caused some
	  warnings when using clang++
	  on OS X."

2013-05-14 13:35  robert

	* Updated ChangeLog

2013-05-14 13:34  robert

	* Updated version after dev release

2013-05-13 13:12  robert

	* Added OSGUTIL_EXPORT for Windows build

2013-05-13 12:08  robert

	* Updated version number for dev release

2013-05-13 11:59  robert

	* Updated ChangeLog for dev release

2013-05-13 11:51  robert

	* Updated links to svn repository

2013-05-13 11:02  robert

	* Fixed build for when automatic type conversion isn't enabled for
	  ref_ptr<>

2013-05-13 09:53  robert

	* Fixed the render order to the Render To Texture cameras used in
	  stereo keystoning.

2013-05-13 09:49  robert

	* Improved the use of the Keystone's defined in the DisplaySettings
	  object.

2013-05-13 09:18  robert

	* Added to Viewer::realize() automatic setup using Keystone when
	  available and enabled, and when no other window setup has been
	  selected.

2013-05-10 17:59  robert

	* Added DisplaySettings::KeystoneHint flag that can be set via
	  --keystone-on and --keystone-off command line parameters, and the
	  OSG_KEYSTONE env var

2013-05-10 16:06  robert

	* Added keystone file handling

2013-05-10 11:56  robert

	* Added --keystone <filename> command line support into
	  DisplaySettings, and added OSG_KEYSTONE_FILES env var support
	  into osg::DisplaySettings.

2013-05-10 10:00  robert

	* Moved Keystone support from osgkeystone example into
	  osgViewer::View

2013-05-09 15:18  robert

	* Moved Keystone class into osgViewer library.

2013-05-07 14:43  robert

	* Cleaned up event handler and namespaces in prep for integrating
	  keystone functionality into osgViewer

2013-05-07 13:34  robert

	* Added keystone support for left eye, right eye and quad buffer
	  stereo

2013-05-07 11:13  robert

	* Added keystone setup to vertical split stereo suport and cleaned
	  up the horizontal split stereo code

2013-05-03 20:12  robert

	* Commented out debug output

2013-05-03 19:26  robert

	* Introduced new scheme for handling mouse events with osgViewer.
	  The new scheme enables robust event handling even when using
	  distortion correction render to texture Cameras.

2013-04-26 10:00  robert

	* As a test of new repository updated date in README.txt

2013-04-18 17:02  robert

	* Refactored Keystone setup as a step toward integrating Keystone
	  correction with stereo

2013-04-18 09:47  robert

	* Implemented stereo support into osgkeystone as a testbed for
	  moving stereo support from SceneView into osgViewer

2013-04-17 11:04  robert

	* Implemented initial cut of anaglyphic stereo

2013-04-16 09:26  robert

	* Changed point to osg::ref_ptr<> to prevent memory leaks.

2013-04-15 14:21  robert

	* Preperation for adding stereo support direclty into osgViewer.

2013-04-12 13:01  robert

	* Added support for enable/disabling the keystone editing using the
	  Ctrl-g key to toggle the UI and grid on/off.

2013-04-12 09:05  robert

	* Moved keystone event handler onto the keystone distortion Camera.

2013-04-12 08:52  robert

	* Refactoed the grid rendering so that it's now implemented as part
	  of the distortion mesh pass, leaving the main scene graph alone.

2013-04-11 17:12  robert

	* Add support for a finer grained mesh on the distortion mesh for
	  higher quality results.

2013-04-11 16:07  robert

	* Moved the keystone geometry computation into a
	  Keystone::compute3DPositions(..) method

2013-04-10 16:36  robert

	* Removed old experimental keystone code to clean up the example

2013-03-28 10:46  robert

	* Changed the way that the keystone geometry is calculated.

2013-03-27 16:29  robert

	* Added keypad control of corner points

2013-03-26 17:03  robert

	* Moved local variable into local scope to avoid it being created
	  when not used.

2013-03-26 16:47  robert

	* Introduced shearing of the image

2013-03-26 11:00  robert

	* Improved the setup of the keystone distortion correction mesh.

2013-03-21 16:42  robert

	* Updated developer release number

2013-03-21 16:22  robert

	* Added check against isVertexBufferObjectSupported() in
	  set*Pointer() methods

2013-03-21 11:35  robert

	* Added keystone grid to aid editing

2013-03-20 14:03  robert

	* Added arrow key support. Added support for using ctrl and shift
	  keys to modulate how senstive the mouse and key movement is when
	  modifying the keystone parameters.

2013-03-19 16:43  robert

	* Improve corner point tracking/keystone computation

2013-03-19 12:44  robert

	* Added event handle for interactive setting of keystone variables

2013-03-15 17:35  robert

	* Experiments with modifying the projection matrix to provide
	  keystoning.

2013-03-14 16:24  robert

	* Initial skeleton of new osgkeystone example

2013-03-11 17:16  robert

	* From Aurelien Albert, "There is a little bug in the
	  osg::Group::insertChild method :
	  
	  If the index is more than the size of _children vector, the new
	  child is pushed at the end of the vector, but the index value is
	  unmodified, so an incorrect value is passed to the
	  "childInserted" method."

2013-02-22 17:42  robert

	* From Chris Hanson, " Adds missing copy for _bbox member variable
	  to copy constructor:
	  
	  LightPointNode::LightPointNode(const LightPointNode& lpn,const
	  osg::CopyOp& copyop):
	  osg::Node(lpn,copyop),
	  _bbox(lpn._bbox),
	  _lightPointList(lpn._lightPointList),
	  _minPixelSize(lpn._minPixelSize),
	  _maxPixelSize(lpn._maxPixelSize),
	  _maxVisibleDistance2(lpn._maxVisibleDistance2),
	  _lightSystem(lpn._lightSystem),
	  _pointSprites(lpn._pointSprites)
	  {
	  }
	  
	  
	  Lacking this causes _bbox to be uninitialized after LOD changes
	  when paged databases refer to shared subgraphs.
	  
	  "

2013-02-13 16:29  robert

	* From Lukasz Izdebski,"added support for gl_SampleMaski."

2013-02-13 16:03  robert

	* From Jordi Torres, "This error occurs when compiling current OSG
	  with the NDK >=r8c:
	  
	  android-ndk-r8d/build/gmsl/__
	  gmsl:512: *** non-numeric second argument to `wordlist' function:
	  ''. Stop.
	  
	  This is discussed in this thread[1].
	  The solution is to add <uses-sdk android:minSdkVersion="8" /> to
	  the manifest as the OSG library will only run in devices with
	  Android>=2.2 (Froyo) with API level 8 [2].
	  
	  The fix does not affect to older sdk's.
	  
	  Thanks to Jan Ciger for spotting the bug and find a possible
	  solution. "

2013-02-12 15:44  robert

	* From Jordi Torres, Android build fix

2013-02-12 15:40  robert

	* From Jordi Torres, fix for Android build

2013-02-12 15:18  robert

	* From Stephan Huber, fixed bug in setting _numMessagesPerEvent and
	  added more debug information

2013-02-07 19:16  robert

	* From Mike Connell, "3 smaller fixes for the 3DS loader (against
	  trunk)
	  
	  1. Respect "noMatrixTransforms" option for matrices attached to
	  meshes, not only those attached to nodes
	  
	  2. traverse_nodes variable did the exact opposite of it's
	  description.
	  
	  3. Always try to load referenced textures, even if we can't find
	  the files (in order to the the registry's ReadFileCallback have a
	  stab at it)
	  "

2013-02-07 11:10  robert

	* From Lukasz Izdebski , "I added write and read numInstances in
	  PrimitiveSet."

2013-02-07 11:08  robert

	* Updated SO version in prep for serialization foramt change

2013-02-07 08:46  robert

	* Updated AUTHORS list

2013-02-06 16:04  robert

	* From Wee See, Support for importing OpenFlight Surface Material
	  Codes using osg::Object::UserValue. Notes from Wee See:
	  
	  See attached my ported code, which fulfills:
	  
	  - using of setUserValue()/getUserValue()
	  - user-value will be attached to Geode or Drawable
	  - actually 3 values will be added: SMC (surface), FID (feature)
	  and IRC (IRcolor). Its UserValue-names are < UA:SMC >, < UA:FID >
	  and < UA:IRC > (without spaces!)
	  - user-value will be attached to Geode or Drawable
	  - has an option (named preserveNonOsgAttrsAsUserData) for control
	  whether the UserValues should be attached (Default: no UserValues
	  will be attached)
	  
	  Reading out this values is very simple. Here is an example
	  (uservalue-name without spaces!):
	  
	  signed short smc;
	  if (myGeode.getUserValue("< UA:SMC >", smc))
	  {
	  doSomethingWithTheGeodeAndItsSmc(myGeode, smc);
	  }
	  else
	  {
	  // geode has no SMC
	  }

2013-02-06 14:50  robert

	* From Aurelien Albert, "This line,I use the
	  "useVertexAttributeAliasing" mode in my application, and color
	  arrays are not normalized, so shaders get [0.0-255.0] values
	  instead of [0.0-1.0] values.
	  This patch fix this."
	  
	  and those below, will be ignored
	  ----
	  
	  M include/osg/State

2013-02-06 14:49  robert

	* Added TODO note about RGB -> RGBA

2013-02-06 12:46  robert

	* From David Longest, "I have updated the FFmpeg plugin to support
	  the 1.0 release version of FFmpeg. The files attached were
	  modified in order to facilitate the update. Below are the details
	  for all changes made.
	  
	  
	  
	  Header update
	  
	  FindFFmpeg.cmake has been changed in order to support the new
	  header include format for FFmpeg. In the 1.0 release, a new file
	  had been added with the name “time.h” in the avutil library. The
	  previous method of adding includes caused conflicts with the ANSI
	  C “time.h” file. Now the include directive will only use the main
	  include folder. All files using the old include format have been
	  updated to reflect the change.
	  
	  
	  
	  Added __STDC_CONSTANT_MACROS define to CMakeLists.txt
	  
	  Since there is no guarantee that FFmpegHeaders.hpp will be
	  included before stdint.h is included, the define has been moved
	  from FFmpegHeaders.hpp to be part of the CMakeLists.txt for the
	  FFmpeg plugin. This will allow the define to work on all
	  compilers regardless of include order.
	  
	  
	  
	  Replaced AVFormatParameters with AVDictionary
	  
	  AVFormatParameters is no longer supported in FFmpeg and has been
	  replaced with a key/value map of strings for each setting.
	  FFmpegParameters and FFmpegDecoder has been updated to reflect
	  this.
	  
	  
	  
	  Replaced av_open_input_file with avformat_open_input
	  
	  FFmpeg now opens files using avformat_open_input. Since the
	  av_open_input_file method is deprecated, the FFmpegDecoder class
	  has been updated to reflect this change.
	  
	  
	  
	  Added custom AVIOContext field to options
	  
	  Since some formats and inputs may not be supported by FFmpeg, I
	  have added a new parameter that allows a user to allocate their
	  own AVIOContext. This class will allow for creating a read, seek,
	  and write callback if they desire.
	  
	  
	  
	  Checking for start_time validity
	  
	  It is possible for some file formats to not provide a start_time
	  to FFmpeg. This would cause stuttering in the video since the
	  clocks class would be incorrect.
	  
	  
	  
	  Removed findVideoStream and findAudioStream
	  
	  The new FFmpeg release already has a function that will find the
	  best audio and video stream. The code has been replaced with this
	  function.
	  
	  
	  
	  Updated error reporting
	  
	  Some functions would not log an error when opening a file or
	  modifying a file failed. New logs have been added as well as a
	  function to convert error numbers to their string descriptions.
	  
	  
	  
	  decode_video has been replaced
	  
	  The old decode_video function would remove extra data that some
	  decoders use in order to properly decode a packet. Now
	  av_codec_decode_video2 has replaced that function.
	  
	  
	  
	  Picture format changed from RGBA32 to RGB24
	  
	  Since most video will not contain an alpha channel, using a 24
	  bit texture will use less memory."

2013-02-06 12:02  robert

	* Simplified include/osg/Math to use Standard C++ maths headers -
	  <cmath> and <cfloat>

2013-02-06 11:16  robert

	* Fixed warning

2013-02-06 09:20  robert

	* From Stephan Huber, fixed for Windows 64bit build

2013-02-05 18:22  robert

	* Added .get()'s to fix compilation when ref_ptr<> type conversion
	  is disabled

2013-02-04 16:25  robert

	* Updated ChangeLog

2013-02-04 14:42  robert

	* Updated version number after 3.1.4 developer release

2013-02-04 13:28  robert

	* From Jordi Torres, "The info about cdash reports was outdated.
	  Now it points to the right URL.
	  BTW I have checked it out and the cdash server is working ok
	  again. "

2013-02-04 13:28  robert

	* Fixed warning

2013-02-04 13:27  robert

	* Fixed warnings

2013-02-04 13:11  robert

	* Fixed warning

2013-02-04 12:50  robert

	* Fixed warning and converted tabs to four spaces

2013-02-04 12:38  robert

	* Fixed warnings

2013-02-04 12:01  robert

	* Fixed warning

2013-01-31 16:26  robert

	* Standardized use of GL_HALF_FLOAT_NV and GL_HALF_FLOAT_ARB to
	  GL_HALF_FLOAT

2013-01-31 11:09  robert

	* From Stephan Huber, introduction of message id scheme were osc
	  messages are sent with an unique id, and can be dispatched
	  multiple times to workaround network packet losses.

2013-01-30 11:31  robert

	* Added handling of movies into Timeout

2013-01-30 10:49  robert

	* Added disabling of the traversal of the Timeout in update when
	  the timout is not displayed and disabled traversal by the
	  SlideEventHandler.

2013-01-30 10:40  robert

	* Fixed the erronous header so that it is OSGPL like the rest of
	  the osgAnimation.

2013-01-30 10:21  robert

	* From Stephan Huber, "As I have not all referenced image-data,
	  SlideShowConstructor crashed on my end. Attached is a fix for
	  that crash."

2013-01-28 14:56  robert

	* From Wang Rui, "I've fixed the bug of writing/reading scenes
	  including the ImageSequence serializer. Current trunk version
	  will fail when handing image sequences because it forces to set
	  className to "osg::Image" in InputStream.cpp. I have to read a
	  value saved in file instead so I must add a hardhanded version
	  checking for backward compatibility.
	  
	  Now we can work with ImageSequence objects, in both osgt and osgb
	  files."

2013-01-28 14:30  robert

	* From Laurens Voerman, "I have implemented and tested (on windows
	  only) your suggestion for resetCullingMask(), it's far less
	  intrusive than my previous submission.
	  attached are the changes to current svn (28 Jan 2013 / rev
	  :13312).
	  "

2013-01-25 16:54  robert

	* From Thomas Hogarth, "Attached are two minor modifications to the
	  master CMakeLists.txt file.
	  
	  It now points to sdk version 6.0 (I do intend to make this
	  configurable my command line)
	  
	  It also added a search for libtiff to Apple builds mainly for use
	  with osg earth."

2013-01-25 11:54  robert

	* From Wang Rui, "In the attached files I've added the Compute
	  Shader support for OSG, as well as serializer updates and a new
	  osgcomputeshaders example. My submission also include a
	  setComputeGroups() function in Program for setting compute-shader
	  work groups, and a bindToImageUnit() function in Texture for
	  binding textures as image variables in shaders.
	  
	  All code are tested on Windows 7 + NVIDIA GFX 570 with the latest
	  GeForce 310.70 Driver (BETA), which could support OpenGL 4.3.
	  
	  Compute shader information can be found at
	  "http://www.opengl.org/registry/specs/ARB/compute_shader.txt"
	  "

2013-01-25 11:08  robert

	* From Lukasz Izdebski, "Adding this GL mode makes possibly to use
	  this GL Modes (added in core OpenGL 3.2) in Windows."

2013-01-25 10:36  robert

	* Fixed compile warning

2013-01-25 10:24  robert

	* Added debug message for Timout

2013-01-24 18:48  robert

	* Fixed usage of META_NodeVisitor so it doesn't include ""

2013-01-23 17:38  robert

	* From Pjotr Svetachov, "when you restart threading
	  with startThreading/stopThreading the _drawQueue and
	  _availableQueue
	  are not reset properly. This can lead to a deadlock when
	  threading is
	  started again. So before threading is started again the queues
	  must be
	  reset. This deadlock is also reported earlier by someone else in
	  here:
	  http://forum.openscenegraph.org/viewtopic.php?p=43415#43415"

2013-01-23 17:37  robert

	* From Pjotr Svetachov, "small bug which I have found in the
	  FlattenStaticTransformsDuplicatingSharedSubgraphsVisitor: the
	  visitor
	  will replace part of the tree when visiting the nodes but it does
	  not
	  update the current node path to reflect this. If you then have
	  multiple nested transform nodes it will usually crash and
	  sometimes it
	  won't crash but the resulting mesh will miss some nodes."

2013-01-23 16:27  robert

	* From Mathias Froehlich, "I have extended the dds loader by some
	  newer DX10 texture formats. Especially
	  the float texture formats.
	  I need a few of these formats somewhere but have extended
	  everything that I
	  found plausible and was easy to find a GL texture type/format
	  for.
	  For some float32 type of texture the files the implementation
	  seem to work fine.
	  The rest lacks testing.
	  The writer side is not implemented."

2013-01-23 16:22  robert

	* From Wang Rui with edits from Robert Osfield, additional GLenums
	  for cross platform build

2013-01-23 15:54  robert

	* From Lionel Lagarde, fixed typo bug

2013-01-23 11:50  robert

	* Removed redundent code block

2013-01-23 11:45  robert

	* From Lukasz Izdebski, "I found problem with rgb plugin.
	  Internal format of rgb image is wrongly set ( diffrent then in
	  other images type plugin ), because of that using rgb images in
	  osg::Texture2DArray causes a bug."

2013-01-23 11:20  robert

	* From Mathias Froehlich, "Attached is a patch that includes the
	  stereo cameras in
	  Renderer::*etCameraRequiresSetUp.
	  
	  I am not sure if the getter needs to be changed, but this is
	  currently
	  included for consistency."

2013-01-22 16:53  robert

	* From Alessandro Terenzi, "I've modified the avfoundation plugin
	  to copy the preferredTransform matrix into the UserData property
	  of the corresponding imagestream: by doing so, we can realize if
	  the video should be transformed when applied as a texture (this
	  should be the case, for instance, when we record a movie using an
	  iOS device with any orientation different than 'landscape
	  left')."

2013-01-22 16:13  robert

	* Added <template_layer name="layerbase_1"> and <layer
	  inherit="layerbase_1"> functionality to .p3d functionality.

2013-01-22 10:33  robert

	* Added extra check against whether node needs to be traversed in
	  update and event traversals to prevent osgPresentation::Timeout
	  being classified as a node that can be removed.

2013-01-18 17:11  robert

	* Added Options support to ImageSequence LOAD_* functionality

2013-01-18 16:30  robert

	* Update SO_VERSION to reflect new API changes

2013-01-18 16:21  robert

	* Added LOAD_AND_RETAIN_IN_UPDATE_TRAVERSAL and
	  LOAD_AND_DISCARD_IN_UPDATE_TRAVERSAL ImageSequence::Mode's to
	  allow for ImageSequence usage without using background paging
	  threads, instead loading all the images on demand in the update
	  traversal.

2013-01-17 13:51  robert

	* Added <display_broadcast_event> and <dismiss_broadcast_event>
	  support to <timeout> to allow the different timeout statges to be
	  broadcast.

2013-01-17 11:57  robert

	* Changed the defaults of the Timeout to be DBL_MAX by default.

2013-01-17 11:48  robert

	* Completed <timeout> support, to use it with p3d use it along the
	  lines:
	  
	  <slide>
	  <layer>
	  <paragraph>Test</paragraph>
	  <timeout>
	  <idle_duration_before_timeout>3.0</idle_duration_before_timeout>
	  <idle_duration_before_action>5.0</idle_duration_before_action>
	  <key_starts_timeout_display>A</key_starts_timeout_display>
	  <key_dismiss_timeout_display>S</key_dismiss_timeout_display>
	  <key_run_action>D</key_run_action>
	  <timeout_jump slide="0" layer="1"></timeout_jump>
	  <timeout_event>w</timeout_event>
	  <timeout_broadcast_event>t</timeout_broadcast_event>
	  <image width="0.5">Images/lz.rgb</image>
	  </timeout>
	  </layer>
	  <layer>
	  <model>cow.osg</model>
	  </layer>
	  </slide>

2013-01-17 09:51  robert

	* Added support for <timeout_jump> to Timeout support.

2013-01-16 16:13  robert

	* Implemented basic Timeout display and timing codes

2013-01-15 11:31  robert

	* Added shell of Timeout class

2013-01-11 11:30  robert

	* Added movie volume animation control to <image> and
	  <stereo_image> tags to be used in the form:
	  
	  <slide>
	  <properties>
	  <property name="volume" type="float">0.20</property>
	  </properties>
	  
	  <property_animation>
	  <key_frame time="0.0">
	  <property name="volume" type="float">0.0</property>
	  </key_frame>
	  <key_frame time="2.0">
	  <property name="volume" type="float">1.0</property>
	  </key_frame>
	  <key_frame time="10.0">
	  <property name="volume" type="float">1.0</property>
	  </key_frame>
	  <key_frame time="12.0">
	  <property name="volume" type="float">0.0</property>
	  </key_frame>
	  </property_animation>
	  
	  <layer>
	  <image volume="$volume"
	  looping="ON">big_buck_bunny_1080p_stereo.ogg</image>
	  </layer>
	  </slide>

2013-01-10 19:55  robert

	* Added support for <image delay="time" stop="time"> properties
	  that works in conjunction with the start="time" property support
	  checked in in previous submission,
	  together these control the delay, start position and stop
	  position of movies.

2013-01-10 14:37  robert

	* Added support for <image "start=10"> property that tells a video
	  to start specificied number of sections into a video.

2013-01-10 10:53  robert

	* From Stephan Huber, "thanks for your input, unfortunately I could
	  not get it working with packing, but setting the row-length works
	  now. Seems I had it wrong the first time.
	  
	  Attached are both files. This should fix the video-bug mentioned
	  on the dlf-wiki.
	  
	  "

2013-01-09 16:29  robert

	* Changed the named colours back to having a alpha value of 1.0 to
	  avoid problems with text not appearing.

2013-01-09 16:03  robert

	* Added reset of the cursorFileName when hideCursor is activated to
	  prevent the custom cursor being enabled.

2013-01-08 10:21  robert

	* Added case for FORWARD_EVENT to address warning

2013-01-07 15:03  robert

	* From Aurelien Albert, "I get a compile error on Windows VS2008
	  wih new DAE plugin, here is a fix :
	  
	  
	  _document = _dae->openFromMemory(fileURI, buffer.data());
	  
	  "data" method is unknow for std::vector with VS2008
	  
	  I've replaced it with :
	  
	  _document = _dae->openFromMemory(fileURI, &buffer[0]);
	  "

2013-01-07 12:41  robert

	* Added support for --show-cursor and --hide-cursor command line
	  options, and P3D_SHOW_CURSOR env var that can be set to YES or
	  NO.

2013-01-07 12:17  robert

	* From Stephan Huber, "* osgGA: fixed a small bug regarding
	  emulating mouse-events from touch-events
	  * resthttp/osc: encapsulate RequestHandler-classes in their own
	  namespaces to prevent class-name-lookup-errors in the
	  debugger/code (had some weird crashes)
	  * QTKit: fixed a compile-bug for gcc and blocks
	  * osgPresentation: click_to_* will fire on RELEASE, only if the
	  drawable received a PUSH beforehand
	  * p3d/osgPresentation: implemented
	  "forward_mouse_event_to_device"-tag, which will forward
	  mouse-events to all registered devices of a viewer, if an
	  intersection occurs. The mouse-coordinates get reprojected
	  * present3d: all devices get registered with the viewer
	  * osgViewer: only devices which are capable of receiving events
	  are queried for new events.
	  * GraphicWindowIOS: added a flag to GraphicWindowIOS::WindowData
	  to set up a retained backing buffer (defaults to false) This will
	  enable read-back of the render-buffer with glReadPixels even
	  after the renderbuffer got presented
	  * curl: added an optimized check for file-existance, now only the
	  headers are requested and checked, instead of reading the whole
	  file and handle it with a ReaderWriter
	  * p3d: fixed a bug, where the existence of a local file may
	  prevent the remote loading of a file with the same name.
	  
	  "

2012-12-20 16:16  robert

	* Made UpdateVisitor::TravesalMode default to
	  TRAVERSE_ACTIVE_CHILDREN

2012-12-20 12:14  robert

	* Added region="$xmin $ymin $zmin $xmax $ymax $zmax" support to
	  <model> tag, along with animation support via the
	  <property_animation> support.

2012-12-19 17:14  robert

	* Removed lighting of trk lines

2012-12-19 12:38  robert

	* Changed the colour calculation and added gl_ClipVertex to enable
	  clipping.

2012-12-18 11:20  robert

	* Removed erroneous region setting

2012-12-18 09:49  robert

	* From Juergen Rensen, "This is a fix for the latest SVN version
	  (rev 13269). The ‘destroyFrameBuffer’ method in
	  ‘GraphicsWindowIOS.mm’ had ‘glDeleteFramebuffersOES’ calls for
	  the stencil buffer, MSAA render buffer and MSAA depth buffer
	  instead of ‘glDeleteRenderbuffersOES’. The fix changes the
	  mismatched calls to ‘glDeleteRenderbuffersOES’.
	  
	  
	  
	  The impact of the bug was a memory leak that would affect
	  multi-sampling iOS apps that allow for device rotation or window
	  resizing in general. For our app, the leak ranged from ca. 10 MB
	  to 40 MB per device rotation, depending on device, for the MSAA
	  buffers. I have not been able to confirm impact for the stencil
	  buffer. "

2012-12-17 15:58  robert

	* Added support for RGBA colour buffer in osgframerenderer using
	  the --rgba command line option (--rgb selects the standard non
	  colour frame buffer which is the default).

2012-12-16 17:10  robert

	* Added handling of aspect ratio for vertical/horizontal split
	  stereo.

2012-12-14 16:31  robert

	* From Stephan Hunber, "* now you can create a transparent
	  opengl-view (see GraphicWindowIOS::WindowData)
	  * changes of the view's bound are reported via osg's event-system
	  more reliably
	  
	  "

2012-12-14 16:30  robert

	* Updated SO version

2012-12-13 17:35  robert

	* From Lionel Lagarde, "Here is a correction on the
	  PixelBufferObject getter methods of Image.
	  
	  The set method modify the buffer object of the BufferData while
	  the get method returned the buffer object of the Image.
	  
	  I've also removed the _bufferObject member of Image (not used
	  anymore)."
	  --This line, Lionel Lagardeand those below, will be ignored--
	  
	  M include/osg/Image

2012-12-13 16:23  robert

	* Added colouring and lighting of track using shader

2012-12-11 17:45  robert

	* Fixed handling of image colour space conversion when pixel format
	  changes

2012-12-11 17:27  robert

	* Added automatic conversion of RGB to RGBA when doing
	  REPLACE_ALPHA_WITH_LUMINANCE colour space conversion.

2012-12-11 10:44  robert

	* Disabled lighting and set the colour to white

2012-12-11 09:55  robert

	* First cut of generating lines from .trk data

2012-12-10 11:11  robert

	* Added setting of the fusion distance.

2012-12-08 16:11  robert

	* Added --flip and --no-flip command line options to enable/disable
	  a vertical flip of the captured image before writing out to disk.

2012-12-07 19:05  robert

	* From Stephan Huber, "attached you'll find a zip containing some
	  bug-fixes and some refactored + new code.
	  
	  * ZeroConfDevice does now return FILE_NOT_HANDLED instead of
	  FILE_NOT_FOUND
	  * present3D supports multiple devices per env-var P3D_DEVICE,
	  separate multiple device with a space
	  
	  I refactored parts the p3d-plugin, the curl-plugin and parts of
	  Registry and ReaderWriter. Currently the p3d-plugin tries to open
	  all remote files with the help of the curl-plugin.
	  
	  I added a new method to Registry called
	  getReaderWriterForProtocolAndExtension. which will return a
	  ReaderWriter which is capable in handling the remote file for the
	  given protocol and extension. If no readerwriter is found for the
	  given extension, a list is built of all readerwriters supporting
	  the given protocol and this list is checked for support of
	  wildcards (extension = "*"). If anything matches it get returned.
	  
	  I added this principle also to the Registry, so now it's possible
	  to register a generic ReaderWriter which can handle all filetypes
	  for a given protocol, similar what curl is doing. All you have to
	  do is to load the plugin at startup. The curl-fallback is still
	  in place.
	  
	  With these changes it is now possible to reference a movie inside
	  a presentation without a server-address, read the presentation
	  (with curl) and stream the movie with the correct plugin (e.g.
	  QTKit)
	  
	  "

2012-12-07 19:04  robert

	* Added template swapBytes method

2012-12-07 13:59  robert

	* Added naming of root of presentation and used this in the setup
	  of the position of the camera.

2012-12-07 12:47  robert

	* Fixed handling of window size/projection matrix

2012-12-07 10:19  robert

	* From Stephan Huber, attached is a fix for the bug of present3D
	  not loading fonts across http. I pass SlideShowConstructor's
	  options-object to readFontFile when constructing any text-objects
	  so freetype can pick up the font-data from the curl-plugin. It
	  works fine now on my end.

2012-12-06 19:09  robert

	* Intial shell of .trk plugin

2012-12-06 18:12  robert

	* From Stephan Huber, build fix

2012-12-06 14:42  robert

	* Added default value for initialization of port number

2012-12-06 11:36  robert

	* Fixed typo

2012-12-06 11:36  robert

	* Added creation of directory path for ouput if one is required

2012-12-06 08:02  robert

	* From Stephan Huber, ZerConfDevice plugin for Windows and Apple

2012-12-05 17:15  robert

	* From Stephan Huber, "* imageio: removed
	  ReaderWriterImageIO_IOS.cpp, refactored ReaderWriterImageIO to
	  work on OS X and IOS
	  * avfoundation: added support for IOS (CoreVideo-support is still
	  in development, works only for SDK >= 6.0, set IPHONE_SDKVER in
	  cMake accordingly)
	  * zeroconf: added ZeroConf-device-plugin (Mac/Win only, linux
	  implementation missing) to advertise and discover services via
	  ZeroConf/Bonjour, on windows you'll need the Bonjour SDK from
	  Apple
